#include"xml_ind.h"
// funzione che inizializza la console relativa al file 
// indicato. Deve essere chiamata prima di ogni altra 
// funzione della libreria
int XCDE_Init_Console(const char *name_source,
		      XCDE_Console_Type *XCDE_Console)
{ // variabile utilizzata per acquisire informazioni sui file
  struct stat sbuf ;

  // variabili usate come contatore nei cicli for
  register
    unsigned int k=0 ;

  register
    unsigned int j=0 ;

  register
    unsigned int i=0 ;

  // variabile usata per controllare i risultati
  // delle funzioni chiamate
  int function_result=0 ;

  // variabile usata per puntare ad una posizione
  // del file Header
  int Header_Mem_Position=0 ;

  // variabile usata per la lunghezza in bytes della
  // codifica con il continuation bit
  unsigned
    long len=0ul ;

  // lunghezza in bytes della tabella degli indici ai blocchi zlib
  // del file body compressi
  int Body_Table_Byte_Len=0 ;

  // puntatore al blocco codificato
  uchar *Code_Pointer=NULL ;

  // offset per la lettura delle liste compresse
  unsigned
    int Deltacode_Bit_Offset=0 ;

  // variabile utilizzata per fare la somma e risolvere
  // cosi' il codice delta
  unsigned
    int Deltacode_Sum=0 ;

  // elemento estratto dalla lista compressa degli indici
  unsigned
    int Deltacode_El=0 ;

  // numero di elementi contenuti nella tabella dei puntatori
  // alle IL
  int IL_Number_Table_Element=0 ;

  /* ------------------------------------------------------------ */
  /* controlla la corretta presenza della libreria per il mapping */
  /* ------------------------------------------------------------ */

  #ifdef _POSIX_MAPPED_FILES
  return(-1) ;
  #endif

  /* ----------------------------------------- */
  /* controllo della correttezza dei parametri */
  /* ----------------------------------------- */

  if ( (XCDE_Console == NULL) || (name_source==NULL) )

    return(-1) ;

  /* ---------------------------------------- */
  /* Preparazione dei nomi dei file necessari */
  /* ---------------------------------------- */

  // preparazione dei nomi dei file necessari
  strcpy(XCDE_Console->XCDE_XML_Source_File_Name, name_source) ;

  strcpy(XCDE_Console->XCDE_Body_File_Name, name_source) ;

  strcat(XCDE_Console->XCDE_Body_File_Name, ".body") ;

  strcpy(XCDE_Console->XCDE_Header_File_Name, name_source) ;

  strcat(XCDE_Console->XCDE_Header_File_Name, ".head") ;

  strcpy(XCDE_Console->XCDE_IL_File_Name, name_source) ;

  strcat(XCDE_Console->XCDE_IL_File_Name, ".il") ;

  for(k=0 ; k<NUMBER_DICT; ++k)

    { sprintf(XCDE_Console->XCDE_Dict_Cmp_File_Names[k], "%s.dict.%d.cmp", name_source, k) ;

    // pone a off il flag di espansione dei dizionari TAG - ATTR - WORD
    XCDE_Console->XCDE_Dict_File_Decompressed[k]=0 ;
    }

  /* ----------------- */
  /* Apertura dei file */
  /* ----------------- */

  // apertura del file header
  if ((XCDE_Console->XCDE_Header_File_Pointer=fopen(XCDE_Console->XCDE_Header_File_Name, "rb")) == NULL)

    { fprintf(stderr, "\nFatal Error: problems opening file %s\n", XCDE_Console->XCDE_Header_File_Name) ;

    return(-1) ;
    }

  // apertura del file delle IL
  if ((XCDE_Console->XCDE_IL_File_Pointer=fopen(XCDE_Console->XCDE_IL_File_Name, "rb"))==NULL)

    { fprintf(stderr, "\nFatal Error: problems opening file %s\n", XCDE_Console->XCDE_IL_File_Name) ;

    // chiusura dei file aperti
    fclose(XCDE_Console->XCDE_Header_File_Pointer) ;
    }

  // apertura del file body
  if ((XCDE_Console->XCDE_Body_File_Pointer=fopen(XCDE_Console->XCDE_Body_File_Name, "rb")) == NULL)

    { fprintf(stderr, "\nFatal Error: problems opening file %s\n", XCDE_Console->XCDE_Body_File_Name) ;

    // chiusura dei file aperti
    fclose(XCDE_Console->XCDE_Header_File_Pointer) ;

    fclose(XCDE_Console->XCDE_IL_File_Pointer) ;

    return(-1) ;
    }

  /* --------------------------------------------------------- */
  /* Lettura delle informazioni sulle dimensioni del file Body */
  /* --------------------------------------------------------- */

  // lettura delle informazioni sul file body
  function_result=stat(XCDE_Console->XCDE_Body_File_Name,
		       &sbuf) ;

  // controlla l'esito dell'operazione
  if (function_result==-1)

    { fprintf(stderr, "\nFatal Error: problems in stat operation on file %s\n", XCDE_Console->XCDE_Body_File_Name) ;

    // chiusura dei file aperti
    fclose(XCDE_Console->XCDE_Header_File_Pointer) ;

    fclose(XCDE_Console->XCDE_IL_File_Pointer) ;

    return(-1) ;
    }

  // lettura delle dimensioni del file
  XCDE_Console->XCDE_Body_Filesize=(int) sbuf.st_size ;

  /* ----------------------------------- */
  /* Operazione di mapping del file Body */
  /* ----------------------------------- */

  // mappa il file body in memoria
  XCDE_Console->XCDE_Body_Mapped_Pointer= (char *) mmap(NULL,
							XCDE_Console->XCDE_Body_Filesize,
							PROT_READ,
							MAP_SHARED,
							fileno(XCDE_Console->XCDE_Body_File_Pointer),
							0) ;

  // controlla l'esito dell'operazione di mapping
  if (XCDE_Console->XCDE_Body_Mapped_Pointer==MAP_FAILED)

    { fprintf(stderr, "\nFatal Error: problems in map operation on file %s\n", XCDE_Console->XCDE_Body_File_Name) ;

      // chiusura dei file aperti
      fclose(XCDE_Console->XCDE_Header_File_Pointer) ;

      fclose(XCDE_Console->XCDE_IL_File_Pointer) ;

      fclose(XCDE_Console->XCDE_Body_File_Pointer) ;

      return(-1) ;
    }

  /* ------------------------------------------------------- */
  /* Lettura delle informazioni sulle dimensioni del file IL */
  /* ------------------------------------------------------- */

  // lettura delle informazioni sul file body
  function_result=stat(XCDE_Console->XCDE_IL_File_Name,
		       &sbuf) ;

  // controlla l'esito dell'operazione
  if (function_result==-1)

    { fprintf(stderr, "\nFatal Error: problems in stat operation on file %s\n", XCDE_Console->XCDE_IL_File_Name) ;

    // chiusura dei file aperti
    fclose(XCDE_Console->XCDE_Header_File_Pointer) ;

    fclose(XCDE_Console->XCDE_IL_File_Pointer) ;

    fclose(XCDE_Console->XCDE_Body_File_Pointer) ;

    // unmapping dei file
    munmap(XCDE_Console->XCDE_Body_Mapped_Pointer,
	   XCDE_Console->XCDE_Body_Filesize) ;

    return(-1) ;
    }

  // lettura delle dimensioni del file
  XCDE_Console->XCDE_IL_Filesize=(int) sbuf.st_size ;

  /* --------------------------------- */
  /* Operazione di mapping del file IL */
  /* --------------------------------- */

  // mappa il file body in memoria
  XCDE_Console->XCDE_IL_Mapped_Pointer= (char *) mmap(NULL,
						      XCDE_Console->XCDE_IL_Filesize,
						      PROT_READ,
						      MAP_SHARED,
						      fileno(XCDE_Console->XCDE_IL_File_Pointer),
						      0) ;

  // controlla l'esito dell'operazione di mapping
  if (XCDE_Console->XCDE_IL_Mapped_Pointer==MAP_FAILED)

    { fprintf(stderr, "\nFatal Error: problems in map operation on file %s\n", XCDE_Console->XCDE_IL_File_Name) ;

    // chiusura dei file aperti
    fclose(XCDE_Console->XCDE_Header_File_Pointer) ;

    fclose(XCDE_Console->XCDE_IL_File_Pointer) ;

    fclose(XCDE_Console->XCDE_Body_File_Pointer) ;

    // unmapping dei file
    munmap(XCDE_Console->XCDE_Body_Mapped_Pointer,
	   XCDE_Console->XCDE_Body_Filesize) ;

    return(-1) ;
    }

  /* ----------------------------------------------------------- */
  /* Lettura delle informazioni sulle dimensioni del file header */
  /* ----------------------------------------------------------- */

  // lettura delle informazioni sul file body
  function_result=stat(XCDE_Console->XCDE_Header_File_Name,
		       &sbuf) ;

  // controlla l'esito dell'operazione
  if (function_result==-1)

    { fprintf(stderr, "\nFatal Error: problems in map operation on file %s\n", XCDE_Console->XCDE_IL_File_Name) ;

    // chiusura dei file aperti
    fclose(XCDE_Console->XCDE_Header_File_Pointer) ;

    fclose(XCDE_Console->XCDE_IL_File_Pointer) ;

    fclose(XCDE_Console->XCDE_Body_File_Pointer) ;

    // unmapping dei file
    munmap(XCDE_Console->XCDE_Body_Mapped_Pointer,
	   XCDE_Console->XCDE_Body_Filesize) ;

    munmap(XCDE_Console->XCDE_IL_Mapped_Pointer,
	   XCDE_Console->XCDE_IL_Filesize) ;

    return(-1) ;
    }

  // lettura delle dimensioni del file
  XCDE_Console->XCDE_Header_Filesize=(int) sbuf.st_size ;

  /* ------------------------------------- */
  /* Operazione di mapping del file header */
  /* ------------------------------------- */

  // mappa il file body in memoria
  XCDE_Console->XCDE_Header_Mapped_Pointer= (char *) mmap(NULL,
							  XCDE_Console->XCDE_Header_Filesize,
							  PROT_READ,
							  MAP_SHARED,
							  fileno(XCDE_Console->XCDE_Header_File_Pointer),
							  0) ;

  // controlla l'esito dell'operazione di mapping
  if (XCDE_Console->XCDE_Header_Mapped_Pointer==MAP_FAILED)

    { fprintf(stderr, "\nFatal Error: problems in map operation on file %s\n", XCDE_Console->XCDE_IL_File_Name) ;

    // chiusura dei file aperti
    fclose(XCDE_Console->XCDE_Header_File_Pointer) ;

    fclose(XCDE_Console->XCDE_IL_File_Pointer) ;

    fclose(XCDE_Console->XCDE_Body_File_Pointer) ;

    // unmapping dei file
    munmap(XCDE_Console->XCDE_Body_Mapped_Pointer,
	   XCDE_Console->XCDE_Body_Filesize) ;

    munmap(XCDE_Console->XCDE_IL_Mapped_Pointer,
	   XCDE_Console->XCDE_IL_Filesize) ;

    return(-1) ;
    }

  /* ------------------------------------------ */
  /* lettura delle informazioni dal file header */
  /* ------------------------------------------ */

  // lettura delle prime parole di codice di ogni livello
  for (k=1; k<=4; k++)

    for (XCDE_Console->Huffman_Firstcw[k]=0,j=0; j<4; j++)

      { XCDE_Console->Huffman_Firstcw[k] = ((XCDE_Console->Huffman_Firstcw[k] << 7) | fgetc(XCDE_Console->XCDE_Header_File_Pointer));

      // incrementa il contatore del file header
      ++Header_Mem_Position ;
      }

  // lettura degli offset di ogni livello
  for (k=1; k<=4; k++)

    for (XCDE_Console->Huffman_Offsetcw[k]=0,j=0; j<4; j++)

      { XCDE_Console->Huffman_Offsetcw[k] = ((XCDE_Console->Huffman_Offsetcw[k] << 8) | fgetc(XCDE_Console->XCDE_Header_File_Pointer)) ;

      // incrementa il contatore del file header
      ++Header_Mem_Position ;
      }

  // lettura della profondita' dell'albero di Huffman,
  // e quindi della lunghezza massima delle parole di codice
  for (XCDE_Console->Huffman_Codeword_Max_Len=0, j=0; j<4; ++j)

    { XCDE_Console->Huffman_Codeword_Max_Len = ((XCDE_Console->Huffman_Codeword_Max_Len << 8) | fgetc(XCDE_Console->XCDE_Header_File_Pointer)) ;

    // incrementa il contatore del file header
    ++Header_Mem_Position ;
    }

  // lettura delle informazioni necessarie alla
  // ricostruzione del dizionario
  for(XCDE_Console->Huffman_Num_Tokens=0, k=0; (k<XCDE_Console->Huffman_Codeword_Max_Len); ++k)

    { for(i=0, XCDE_Console->Huffman_Dict_NumEl[k][i]=0; i<NUMBER_DICT; ++i)

      { for(j=0; j<4; j++)

	{ XCDE_Console->Huffman_Dict_NumEl[k][i]=((XCDE_Console->Huffman_Dict_NumEl[k][i] << 8) | fgetc(XCDE_Console->XCDE_Header_File_Pointer)) ;

	// incrementa il contatore del file header
	++Header_Mem_Position ;
	}

      // incrementa il numero dei tokens totali del dizionario
      XCDE_Console->Huffman_Num_Tokens+=XCDE_Console->Huffman_Dict_NumEl[k][i] ;
      }
    }

  // lettura dell'ampiezza del file originale in Byte
  continuation_bit_d((unsigned long *) &XCDE_Console->XCDE_XML_Source_Filesize,
		     (char *) (XCDE_Console->XCDE_Header_Mapped_Pointer+Header_Mem_Position),
		     (unsigned int) 0,
		     (unsigned long *) &len) ;

  // aggiorna il puntatore al file Header
  Header_Mem_Position+=((int) (len/8)) ;

  // numero degli elementi che formano l'indice del blocco
  continuation_bit_d((unsigned long *) &XCDE_Console->XCDE_Body_Num_Block,
		     (char *) (XCDE_Console->XCDE_Header_Mapped_Pointer+Header_Mem_Position),
		     (unsigned int) 0,
		     (unsigned long *) &len) ;

  // aggiorna il puntatore al file Header
  Header_Mem_Position+=((int) (len/8)) ;

  if (XCDE_Console->XCDE_Body_Num_Block > 1)

    { // lettura dell'ampiezza in bytes della compressione della tabella
      // dei riferimenti ai blocchi lzip del body
      continuation_bit_d((unsigned long *) &Body_Table_Byte_Len,
			 (char *) (XCDE_Console->XCDE_Header_Mapped_Pointer+Header_Mem_Position),
			 (unsigned int) 0,
			 (unsigned long *) &len) ;

      // aggiorna il puntatore al file Header
      Header_Mem_Position+=((int) (len/8)) ;
    }

  else Body_Table_Byte_Len=0 ;

  // alloca la memoria necessaria per la tabella degli indici dei blocchi
  // lzip del body
  XCDE_Console->XCDE_Body_Table_Pointers=(int *) malloc(Body_Table_Byte_Len*sizeof(int)) ; 

  XCDE_Console->XCDE_Body_Table_Pointers[0]=0 ; 

  // inizializza gli elemente per il calcolo del deltacode 
  Deltacode_Sum=0u ; 

  Deltacode_Bit_Offset=0u ; 

  // inizializza il puntatore alla lista compressa 
  Code_Pointer=(uchar *) (XCDE_Console->XCDE_Header_Mapped_Pointer+Header_Mem_Position) ; 
  for (k=1 ; k<XCDE_Console->XCDE_Body_Num_Block ; ++k) 

    { // decompressione dell'elemento dalla lista 
      Deltacode_El=(unsigned int) read_delta_code((unsigned char *) &Code_Pointer,
						  &Deltacode_Bit_Offset) ; 
      
      // somma l'elemento per la decodifica del delta code
      Deltacode_Sum+=Deltacode_El ; 
	
      // lettura dell'elemento corrispondente della tabella 
      XCDE_Console->XCDE_Body_Table_Pointers[k]=Deltacode_Sum ; 
    }
  
  // aggiorna il puntatore al file Header 
  Header_Mem_Position+=((int) Body_Table_Byte_Len) ; 

  // calcola il numero degli elementi nel tabella degli 
  // indici alle IL 
  IL_Number_Table_Element=XCDE_Console->Huffman_Num_Tokens/20 ; 

  if ((IL_Number_Table_Element%20) > 0)

    ++IL_Number_Table_Element ; 

  XCDE_Console->XCDE_IL_Table_Pointers=(int *) malloc(IL_Number_Table_Element*sizeof(int)) ;

  // inizializza gli elementi per il calcolo del deltacode 
  Deltacode_Sum=0u ; 

  Deltacode_Bit_Offset=0u ; 
  
  // inizializza il puntatore alla lista compressa 
  Code_Pointer=(uchar *) (XCDE_Console->XCDE_Header_Mapped_Pointer+Header_Mem_Position) ; 

  // memorizza il primo elemento della tabella degli 
  // indici alle IL
  XCDE_Console->XCDE_IL_Table_Pointers[0]=0 ; 

  for (k=1 ; k<IL_Number_Table_Element ; ++k) 

    { // decompressione dell'elemento dalla lista 
      Deltacode_El=(int) read_delta_code(&Code_Pointer, 
					 &Deltacode_Bit_Offset) ; 

      // somma l'elemento per la decodifica del delta code
      Deltacode_Sum+=Deltacode_El ; 

      // memorizza l'elemento corrispondente della tabella 
      XCDE_Console->XCDE_IL_Table_Pointers[k]=Deltacode_Sum ; 
    }

  // inizializza i puntatori per il caricamento della cache:
  // nessun blocco di cache e' caricato in memoria 
  XCDE_Console->XCDE_IL_Cache_Block=NULL ; 

  XCDE_Console->XCDE_Body_Cache_Block=NULL ;

  XCDE_Console->XCDE_IL_Cache_What_Block=-1 ; 

  XCDE_Console->XCDE_Body_Cache_What_Block=-1 ; 

  XCDE_Console->XCDE_IL_Cache_Block_File_Position=0 ; 

  XCDE_Console->XCDE_Body_Cache_Block_File_Position=0 ; 

  XCDE_Console->XCDE_IL_Cache_Dcmp_Block_Size=0 ; 

  XCDE_Console->XCDE_Body_Cache_Dcmp_Block_Size=0 ; 

  XCDE_Console->XCDE_IL_Cache_Cmp_Block_Size=0 ; 

  XCDE_Console->XCDE_Body_Cache_Cmp_Block_Size=0 ; 

  // pone a 1 il flag che indica che la console e' 
  // stata inizializzata 
  XCDE_Console->XCDE_Console_Initialized=1 ; 

  return(1) ; 
}  


int XCDE_Get_Source_Filesize(int *Source_Filesize,
			     XCDE_Console_Type *XCDE_Console) 
{ 
  /* ----------------------------------------- */
  /* controllo della correttezza dei parametri */
  /* ----------------------------------------- */

  if ((XCDE_Console == NULL) || (Source_Filesize == NULL))

    return(-1) ;

  if (XCDE_Console->XCDE_Console_Initialized != 1)

    return(-1) ;

  /* --------------------------------------- */
  /* lettura dell'ampiezza del file sorgente */
  /* --------------------------------------- */ 

  *Source_Filesize=XCDE_Console->XCDE_XML_Source_Filesize ; 

  return(1) ; 
}

int XCDE_Get_Source_Filename(char *Source_Filename, 
			     XCDE_Console_Type *XCDE_Console) 
{ 
  /* ----------------------------------------- */
  /* controllo della correttezza dei parametri */
  /* ----------------------------------------- */

  if (XCDE_Console == NULL)

    return(-1) ; 

  if (XCDE_Console->XCDE_Console_Initialized != 1)

    return(-1) ; 

  /* ------------------------------- */ 
  /* copia il nome del file sorgente
  /* ------------------------------- */ 

  Source_Filename=malloc(strlen(XCDE_Console->XCDE_XML_Source_File_Name)) ; 

  // controlla che la memoria sia stata allocata 
  if (Source_Filename == NULL)

    return(-1) ; 

  // copia il nome del file sorgente 
  strcpy(Source_Filename, 
	 XCDE_Console->XCDE_XML_Source_File_Name) ; 

  return(1) ; 
}			     


int XCDE_Get_Header_Filesize(int *Header_Filesize,
			     XCDE_Console_Type *XCDE_Console) 
{ 
  /* ----------------------------------------- */
  /* controllo della correttezza dei parametri */
  /* ----------------------------------------- */

  if ((XCDE_Console == NULL) || (Header_Filesize == NULL))   

    return(-1) ; 

  if (XCDE_Console->XCDE_Console_Initialized != 1)

    return(-1) ; 

  /* ------------------------------------- */ 
  /* lettura dell'ampiezza del file header */
  /* ------------------------------------- */ 

  *Header_Filesize=XCDE_Console->XCDE_Header_Filesize ; 

  return(1) ; 
}


int XCDE_Get_Header_Filename(char *Header_Filename, 
			     XCDE_Console_Type *XCDE_Console) 
{ 
  /* ----------------------------------------- */
  /* controllo della correttezza dei parametri */
  /* ----------------------------------------- */

  if (XCDE_Console == NULL)

    return(-1) ; 

  if (XCDE_Console->XCDE_Console_Initialized != 1)

    return(-1) ; 

  /* ----------------------------- */ 
  /* copia il nome del file header */
  /* ----------------------------- */ 

  Header_Filename=malloc(strlen(XCDE_Console->XCDE_Header_File_Name)) ; 

  // controlla che la memoria sia stata allocata 
  if (Header_Filename==NULL) 

    return(-1) ; 

  // copia il nome del file sorgente 
  strcpy(Header_Filename, 
	 XCDE_Console->XCDE_Header_File_Name) ; 

  return(1) ; 
}		


int XCDE_Get_Body_Filesize(int *Body_Filesize,
			   XCDE_Console_Type *XCDE_Console)
{ 
  /* ----------------------------------------- */
  /* controllo della correttezza dei parametri */
  /* ----------------------------------------- */

  if ((XCDE_Console == NULL) || (Body_Filesize == NULL))   

    return(-1) ; 

  if (XCDE_Console->XCDE_Console_Initialized != 1)

    return(-1) ; 

  /* ----------------------------------- */ 
  /* lettura dell'ampiezza del file body */
  /* ----------------------------------- */ 

  *Body_Filesize=XCDE_Console->XCDE_Body_Filesize ; 

  return(1) ; 
}


int XCDE_Get_Body_Filename(char *Body_Filename, 
			   XCDE_Console_Type *XCDE_Console) 
{ 
  /* ----------------------------------------- */
  /* controllo della correttezza dei parametri */
  /* ----------------------------------------- */

  if (XCDE_Console == NULL)

    return(-1) ; 

  if (XCDE_Console->XCDE_Console_Initialized != 1)

    return(-1) ; 

  /* --------------------------- */ 
  /* copia il nome del file body */
  /* --------------------------- */ 

  Body_Filename=malloc(strlen(XCDE_Console->XCDE_Body_File_Name)) ; 

  // controlla che la memoria sia stata allocata 
  if (Body_Filename == NULL) 

    return(-1) ; 

  // copia il nome del file sorgente 
  strcpy(Body_Filename, 
	 XCDE_Console->XCDE_Body_File_Name) ; 

  return(1) ; 
}		


int XCDE_Get_IL_Filesize(int *IL_Filesize,
			 XCDE_Console_Type *XCDE_Console) 
{ 
  /* ----------------------------------------- */
  /* controllo della correttezza dei parametri */
  /* ----------------------------------------- */

  if ((XCDE_Console == NULL) || (IL_Filesize == NULL))   
    
    return(-1) ; 
  
  if (XCDE_Console->XCDE_Console_Initialized != 1)
    
    return(-1) ; 

  /* ----------------------------------- */ 
  /* lettura dell'ampiezza del file body */
  /* ----------------------------------- */ 

  *IL_Filesize=XCDE_Console->XCDE_IL_Filesize ; 
  
  return(1) ; 
}


int XCDE_Get_IL_Filename(char *IL_Filename, 
			 XCDE_Console_Type *XCDE_Console) 
{ 
  /* ----------------------------------------- */
  /* controllo della correttezza dei parametri */
  /* ----------------------------------------- */

  if (XCDE_Console == NULL)

    return(-1) ; 

  if (XCDE_Console->XCDE_Console_Initialized != 1)

    return(-1) ; 

  /* ------------------------------- */ 
  /* copia il nome del file delle IL */
  /* ------------------------------- */ 

  IL_Filename=malloc(strlen(XCDE_Console->XCDE_IL_File_Name)) ; 

  // controlla che la memoria sia stata allocata 
  if (IL_Filename == NULL) 

    return(-1) ; 

  // copia il nome del file sorgente 
  strcpy(IL_Filename, 
	 XCDE_Console->XCDE_IL_File_Name) ; 

  return(1) ; 
}	  


int XCDE_Get_Dict_Cmp_Filename(unsigned char Dict,
			       char *Dict_Cmp_Filename,
			       XCDE_Console_Type *XCDE_Console) 
{ /* ----------------------------------------- */
  /* controllo della correttezza dei parametri */
  /* ----------------------------------------- */

  if ((XCDE_Console == NULL ) || (Dict_Cmp_Filename == NULL)) 

    return(-1) ; 

  if (XCDE_Console->XCDE_Console_Initialized != 1)

    return(-1) ; 

  if ((Dict != ATTR) && (Dict != WORD) && (Dict != TAG)) 
    
    return(-1) ; 

  /* ---------------------- */ 
  /* copia il nome del file */
  /* ---------------------- */ 

  Dict_Cmp_Filename=malloc(strlen(XCDE_Console->XCDE_Dict_Cmp_File_Names[Dict])) ; 

  // controlla che la memoria sia stata allocata 
  if (Dict_Cmp_Filename == NULL) 

    return(-1) ; 

  // copia il nome del file sorgente 
  strcpy(Dict_Cmp_Filename, 
	 XCDE_Console->XCDE_Dict_Cmp_File_Names[Dict]) ;

  return(1) ; 
}	  


int XCDE_Get_Dict_Dcmptmp_Filename(unsigned char Dict,
				   char *Dict_Dcmptmp_Filename,
				   XCDE_Console_Type *XCDE_Console)
{ /* ----------------------------------------- */
  /* controllo della correttezza dei parametri */
  /* ----------------------------------------- */
  
  if ((XCDE_Console == NULL ) || (Dict_Dcmptmp_Filename == NULL)) 
    
    return(-1) ; 

  if (XCDE_Console->XCDE_Console_Initialized != 1 )

    return(-1) ; 

  if ((Dict != ATTR) && (Dict != WORD) && (Dict != TAG)) 
    
    return(-1) ; 

  if (XCDE_Console->XCDE_Dict_File_Decompressed[Dict] != 1) 

    return(-1) ; 

  /* ---------------------- */ 
  /* copia il nome del file */
  /* ---------------------- */

  Dict_Dcmptmp_Filename=malloc(strlen(XCDE_Console->XCDE_Dict_Dcmptmp_Names[Dict])) ; 

  // controlla che la memoria sia stata allocata 
  if (Dict_Dcmptmp_Filename == NULL) 

    return(-1) ; 

  // copia il nome del file sorgente 
  strcpy(Dict_Dcmptmp_Filename, 
	 XCDE_Console->XCDE_Dict_Dcmptmp_Names[Dict]) ;
  
  return(1) ; 
}	


int XCDE_Get_Dict_Dcmptmp_Filesize(unsigned char Dict,
				   int *Dict_Dcmptmp_Filesize, 
				   XCDE_Console_Type *XCDE_Console)
{ /* ----------------------------------------- */
  /* controllo della correttezza dei parametri */
  /* ----------------------------------------- */

  if ((XCDE_Console == NULL) || (Dict_Dcmptmp_Filesize == NULL)) 

    return(-1) ; 

  if (XCDE_Console->XCDE_Console_Initialized != 1)

    return(-1) ; 

  if ((Dict != ATTR) && (Dict != WORD) && (Dict != TAG)) 
    
    return(-1) ; 

 if (XCDE_Console->XCDE_Dict_File_Decompressed[Dict] != 1)

    return(-1) ; 

  /* ---------------------- */ 
  /* copia il nome del file */
  /* ---------------------- */ 

 // lettura dell'ampiezza del file richiesto 
 *Dict_Dcmptmp_Filesize=XCDE_Console->XCDE_Dict_Dcmptmp_Filesize[Dict] ; 

  return(1) ; 
}	    


int XCDE_Get_Maxcwlen(int *Maxcwlen,
		      XCDE_Console_Type *XCDE_Console) 
{ /* ----------------------------------------- */
  /* controllo della correttezza dei parametri */
  /* ----------------------------------------- */

  if (Maxcwlen == NULL) 

    return(-1) ; 

  if (XCDE_Console == NULL)
    
    return(-1) ; 

  if (XCDE_Console->XCDE_Console_Initialized != 1)

    return(-1) ; 
  
  /* ---------------------------------------------------- */
  /* lettura del valore della massima lunghezza di una cw */
  /* ---------------------------------------------------- */

  *Maxcwlen=XCDE_Console->Huffman_Codeword_Max_Len ; 

  return(1) ; 
}


int XCDE_Get_Num_Tokens(int *Num_Tokens,
			XCDE_Console_Type *XCDE_Console) 
{ /* ----------------------------------------- */
  /* controllo della correttezza dei parametri */
  /* ----------------------------------------- */

  if (Num_Tokens == NULL) 

    return(-1) ; 

  if (XCDE_Console == NULL)
    
    return(-1) ; 

  if (XCDE_Console->XCDE_Console_Initialized != 1)

    return(-1) ; 
  
  /* ---------------------------------------------------- */
  /* lettura del valore della massima lunghezza di una cw */
  /* ---------------------------------------------------- */

  *Num_Tokens=XCDE_Console->Huffman_Num_Tokens ;

  return(1) ;
}


int XCDE_Get_Num_El_Dict(unsigned char Dict,
			 int *Num_El,
			 XCDE_Console_Type *XCDE_Console)
{ // variabile usata come contatore
  register
    int k=0 ;

  /* ----------------------------------------- */
  /* controllo della correttezza dei parametri */
  /* ----------------------------------------- */

  if (XCDE_Console == NULL)

    return(-1) ;

  if (XCDE_Console->XCDE_Console_Initialized != 1)

    return(-1) ;

  if ((Dict != ATTR) && (Dict != WORD) && (Dict != TAG))

    return(-1) ;

  if (Num_El == NULL)

    return(-1) ;

  /* -------------------------------------------- */
  /* calcola il numero di elementi del dizionario */
  /* -------------------------------------------- */

  // inizializza il numero di elementi del dizionario
  *Num_El=0 ;

  // calcola il numero di elementi di un dizionario
  for(k=1; k<=XCDE_Console->Huffman_Codeword_Max_Len; ++k)

    *Num_El+=XCDE_Console->Huffman_Dict_NumEl[k][Dict] ;

  return(1) ;
}

int XCDE_Get_Num_El_Lev(int Lev,
			int *Num_El,
			XCDE_Console_Type *XCDE_Console)
{ // variabile usata come contatore
  register
    unsigned int k=0 ;

  /* ----------------------------------------- */
  /* controllo della correttezza dei parametri */
  /* ----------------------------------------- */

  if (XCDE_Console == NULL)

    return(-1) ;

  if (XCDE_Console->XCDE_Console_Initialized != 1)

    return(-1) ;

  if (Num_El == NULL)

    return(-1) ;

  if ((Lev<1) || (Lev > XCDE_Console->Huffman_Codeword_Max_Len))

    return(-1) ;

  /* ---------------------------------------- */
  /* calcola il numero di elementi al livello */
  /* ---------------------------------------- */

  // inizializza il numero di elementi per il calcolo 
  *Num_El=0 ;

  // esegue il calcolo del numero degli elementi allo stesso livello
  for(k=0; k<NUMBER_DICT; ++k)

    *Num_El+=XCDE_Console->Huffman_Dict_NumEl[Lev][k] ; 

  return(1) ; 
}
