/********************************************************************
   	              xcde_expat_handler.c 
                       contains functions: 
     doctypestart, doctypeend, start, startcod, startwrite, end, 
     endcod, endwrite, text, textcod, textwrite, cdstart, cdstartcod, 
     cdstartwrite, cdend, cdendcod, cdendwrite, comment, commentcode, 
            commentwrite, defa, defacod, defawrite, InternalEntity
                  Xml Compressed Document Engine
	                Building Program
	      Paolo Ferragina - Andrea Mastroianni 
        Dipartimento di Informatica - Universita' di Pisa 
	               ferragin@di.unipi.it
 	               mastroia@di.unipi.it
********************************************************************/
#include"xcde_consts.h"
#include"xcde_build.h"

// FILE POINTERS
extern
FILE *inputFile ; 

extern
FILE *configFile ; 

extern
FILE *dictsFile[XCDE_NUMBER_DICT] ; 

extern
FILE *bodyFile ;

extern
FILE *headerFile ; 

extern
FILE *IL_File ; 

extern
FILE *tagstructFile ;

extern
FILE *depthstructFile ;

extern
FILE *debugPhysicView ;

extern
FILE *debugIndexFile ;

extern
FILE *debugStatsFile ;

// FILES' NAMES POINTERS

extern
char *inputFilename ;

extern
char *dictionaryFilename[XCDE_NUMBER_DICT] ;

extern
char *headerFilename ;

extern
char *bodyFilename ;

extern
char *IL_Filename ;

extern
char *tagstructFilename ;

extern
char *depthstructFilename ;

extern
char *debugPhysicFilename ;

extern
char *debugStatsFilename ;

extern
char *debugIndexFilename ;

extern
char *configFilename ;

extern
int inputFilesize ;

extern
char expat_parsing_buffer[XCDE_EXPAT_PARSING_BUFFER_SIZE] ;

extern
char zlib_decompress_buffer[XCDE_COMPRESS_BLOCK_SIZE] ;

extern
char zlib_compress_buffer[2*XCDE_COMPRESS_BLOCK_SIZE] ;

extern
int pointer_decompress_buffer ;

extern
unsigned
char expat_CDATA_section_flag ;

extern
unsigned
char expat_DTD_flag ;

extern
unsigned
char expat_CDATA_expansion_flag ;

extern
unsigned
char empty_tag_flag ;

extern
unsigned
char verbosing_flag ;

extern
unsigned
char proximity_flag ;

extern
unsigned
char tagstruct_flag ;

extern
unsigned
char depthstruct_flag ;

extern
unsigned
char different_configfile_flag ;

extern
unsigned
char recursivetag_flag ;

extern
int proximity_counter ;

extern
int element_displacement ;

extern
int number_tokens ;

extern
int last_body_position_written ;

extern
int bodyFileSize ;

extern
int body_size_without_zlib ;

extern
int dictionaryFileSize ;

extern
int expat_number_tag_opened ;

extern
int dict_elem[XCDE_HUFF_MAX_LEVEL][XCDE_NUMBER_DICT] ;

extern
HashTable ht ;

extern
HashTable expat_general_declared_entity ;

extern
HashTable expat_separators_table ;

extern
HashTable expat_attribute_separators_table ;

extern
Hashptr *Huffman_tree ;

extern
XML_Parser parser ;

extern
char *expat_source_pointer ;

// variables used to traduce the physical text into the logical view
extern
char *xml_code ; 

extern
long xml_dimension ; 

extern
long xml_position ; 

extern
long last_expanded_position ; 

extern
unsigned 
char changed_position ; 

extern
unsigned 
char physical_correspondence ; 

extern
unsigned 
char last_physical_correspondence ; 

extern
int elementRank ; 

extern
struct stat sbuf ;

extern
Textbuffer textbuffer ;

extern
char separators[XCDE_MAX_NUMBER_SEPARATORS] ; 

extern
char attribute_separators[XCDE_MAX_NUMBER_SEPARATORS] ; 

extern
uchar *body_pointers_cmp_buffer ; 

extern
uchar *body_pcmp_point ; 

extern
int body_pointers_cmp_buffer_dimension ; 

extern
int number_body_points ; 

extern
int body_bit_offset ;

extern
uchar **IL_pointers_buff ; 

extern
int IL_pointers_buff_length ; 

extern
int number_IL_table_pointer ;

extern
int diff_position ; 

extern
int new_diff_position ; 

extern
int new_body_pointers_point ;

extern
int number_tagstruct_intervals ; 

/*******************************************************************
                        DTD start handler
 *******************************************************************/

void doctypestart(void *userData,
		  const XML_Char *doctypeName)
{ expat_DTD_flag=1u ; 

 return ; 
} 

/*******************************************************************
                        DTD end handler
 *******************************************************************/

void doctypeend(void *userData)
{ 
  expat_DTD_flag=0u ; 
  
  return ; 
} 

/*******************************************************************
   		      tag start handlers
 *******************************************************************/

void 
start(void *data,
      const char *el, 
      const char **attr)
{ // counter variables 
  register
    int j=0 ;

  register
    int k=0 ;
  
  register
    int i=0 ;

  int buffer_length=0 ; 

  int number_this_tag_opened=0 ; 

  char *recursive_logic_tag=NULL ; 

  int recursive_logic_tag_size=0 ; 

  char *token=NULL ; 

  int token_len=0 ; 

  char *entity=NULL ; 

  int entity_len=0 ; 

  char separator='\0' ; 

  char delimiter='\0' ; 

  char seps[XCDE_MAX_SEPARATORS_BLOCK+1] ; 

  char *logic_token=NULL ; 

  int logic_token_len=0 ; 

  char *result_token=NULL ;

  int result_token_dimension=0 ; 

  char *result=NULL ; 

  int result_dimension=0 ; 

  int position_logic_token=0 ; 

  int attribute_position=0 ; 
  
  int position_expanded_attribute=0 ; 

  int position_result=0 ; 

  int position_result_token=0 ; 

  char *NTagNAttr=NULL ; 

  int num_seps=0 ; 

  unsigned 
    char physic_flag=0u ; 

  unsigned 
    char done=0u ; 

  Hashptr search=NULL ;

  Hashptr tagposition=NULL ;

  int token_len1=0 ;

  int token_len2=0 ;

  // ..
  // ..   
  // ..   start - ANALYZES THE TEXTBUFFER
  // ..
  // ..
  
  // checks if there is a token in the buffer and 
  // reads it 
  if (text_in_buffer(&textbuffer)) { 

    buffer_length=get_buffer_length(&textbuffer) ; 
    
    token =(char *) malloc((buffer_length+1)*sizeof(char)) ; 
    
    buffer_length=get_text_in_buffer(&textbuffer, 
				     token) ; 
    
    token[buffer_length]='\0' ; 
    
    undercase(token, 
	      buffer_length) ; 
    
    // it's in the first pass: insert the logic token and enventually
    // computes the proximity (doesn't increases the physical count
    // because the token in the buffer is logical)
    if (proximity_flag) {

      // the token can be only a WORD component
      // insert it in the hash table with its proximity counter
      number_tokens+=hinsert((char *) token, 
			     buffer_length, 
			     WORD, 
			     (char *) NULL, 
			     ht, 
			     proximity_counter,
			     0,
			     ((0x00) | _INSERT_LOGICAL_OCCURRENCE)) ;  
    
      // increases the proximity counter 
      ++proximity_counter ; 
    }
    
    else
      
      // only insert the token in the words dictionary because it's a logical
      // token
      number_tokens+=hinsert((char *) token, 
			     buffer_length, 
			     WORD, 
			     (char *) NULL, 
			     ht, 
			     0,
			     0,
			     0x00) ; 
  }
  
  // ..
  // ..   start - INCREASES THE NUMBER OF TAG OPENED AND  
  // ..   CHECKS THE CORRESPONDENCE BEETWEEN PHYSICAL
  // ..   AND LOGICAL VIEW (EVANTUALLY THE FUNCTION PHY_CORR INSERTS
  // ..   THE ENTITY IN THE HASH TABLE, AS WE CAN SEE FROM THE 1 OPTION)
  // .. 

  // increases the number of tag opened 
  ++expat_number_tag_opened ; 
  
  // checks the physical correspondence 
  physic_flag=phy_corr(&entity,
		       &entity_len,
		       1) ;
  
  // ..
  // ..   start - READS THE TAGNAME AND INSERTS IT IN THE ATTRIBUTES DICTIOANARY 
  // .. 

  // reads the tag name
  token_len=get_next_token(xml_code+xml_position,
			   " /\t\n>", 
			   &separator,  
			   xml_dimension-xml_position) ; 
  
  // there is a correspondence between logical and physical views: 
  // writes the character '<' in the body file 
  if (physic_flag) { 
    
    number_tokens+=hinsert((char *) "<", 
			   1, 
			   WORD,
			   (char *) NULL, 
			   ht, 
			   0,
			   0,
			   ((0x00) | _INCREASE_PHYSICAL_COUNT)) ;   
    
    if (verbosing_flag)
      
      fprintf(debugPhysicView, "<") ; 
  }
  
  // eventually frees the memory allocated to read the textbuffer
  if (token != NULL)
    
    free(token) ; 
  
  // allocates the memory needed to read the token name
  token=(char *) malloc(token_len*sizeof(char)) ; 
  
  // copies the token read with get_next_token function, starting from 1 
  // to cancel the '<' character 
  for (k=1; k<token_len; ++k) { 

    if ((physic_flag) && (verbosing_flag))
      
      fprintf(debugPhysicView, "%c", xml_code[xml_position+k]) ; 
    
    token[k-1]=xml_code[xml_position+k] ; 
  }
  
  token[k-1]='\0' ;

  // now the token contains the tag name 
  if (physic_flag) { 
    
    // there is a correspondence beetween logical and physical views 
    // inserts the tag name as a physical token 
    number_tokens+=hinsert((char *) token,
			   strlen(token),
			   TAG,
			   (char *) NULL, 
			   ht, 
			   0,
			   0,
			   ((0x00) | _INCREASE_PHYSICAL_COUNT)) ; 
  }
  
  else 
    
    // there isn't a correspondence beetween the two views. Insert a logical token
    number_tokens+=hinsert((char *) token,
			   strlen(token),
			   TAG, 
			   (char *) NULL,
			   ht,
			   0,
			   0, 
			   (0x00)) ; 
  
  // updates the pointer to the logical text element 
  xml_position+=token_len ;

  // ..
  // ..   start - READS SEPARATORS AND PUTS IT IN THE HASH TABLE WORDS DICTIONARY 
  // .. 

  // eventually reads separator characters
  do { num_seps=0 ; 
    
  do { seps[num_seps]=separator ; 
      
      ++num_seps ; 
      
      ++xml_position ; 
      
      // if the character is '/' the tag is empty 
      if (separator=='/') empty_tag_flag=1u;
      
  } while ((separator != '>') && (num_seps < XCDE_MAX_SEPARATORS_BLOCK) && 
	   ((token_len = get_next_token(xml_code+xml_position, 
					" />\t\n", 
					&separator, 
					xml_dimension-xml_position))==0)) ;
  seps[num_seps]='\0' ; 
  
  if (physic_flag) { 
    
    // inserts separators in the hash table 
    number_tokens+=hinsert((char *) seps, 
			   strlen(seps),
			   WORD,
			   (char *) NULL, 
			   ht, 
			   0,
			   0, 
			   ((0x00) | _INCREASE_PHYSICAL_COUNT)) ;  
    
    if (verbosing_flag)
      
      fprintf(debugPhysicView, "%s", seps) ; 
  }
  } while ((token_len==0) && (num_seps == XCDE_MAX_SEPARATORS_BLOCK)) ; 

  // ..
  // ..   start - CHECKS IF THE TAG IS RECURSIVE
  // .. 

  // checks how many times the tag has been opened, and if it's a recursive tag
  if ((tagposition=hsearch((char *) el,
			   strlen(el), 
			   TAG, 
			   ht)) == NULL) { 

    fprintf(stderr, "\nFatal Error: at raw %d.Tag %s not found in the hash table\n\tError code 40\n", 
	    XML_GetCurrentLineNumber(parser), 
	    el) ;
    
    for(k=0 ; ((k<XCDE_EXPAT_PARSING_BUFFER_SIZE) && (k<100)) ; ++k)
      
      fprintf(stderr, "%c", expat_parsing_buffer[XML_GetCurrentByteIndex(parser)+k]) ; 
    
    fprintf(stderr, " ... \n") ; 
    
    DELETE_FILES ;
    
    exit(-1) ;
  }
  
  // finds the tagposition and sets the tag open flag to on
  number_this_tag_opened=hopentag(tagposition) ;

  if ((!recursivetag_flag) && (number_this_tag_opened > 1)) { // if enters in the block the tag is recursive, and this situation isn't allowed

    fprintf(stderr, "\nFatal Error : at raw %d.It's not possible to nest the tag %s into itself\n\tError code 41\n", 
	    XML_GetCurrentLineNumber(parser), 
	    el) ; 

    for(k=0 ; ((k<XCDE_EXPAT_PARSING_BUFFER_SIZE) && (k<100)) ; ++k)
    
      fprintf(stderr, "%c", expat_parsing_buffer[XML_GetCurrentByteIndex(parser)+k]) ; 
    
    fprintf(stderr, " ... \n") ; 

    fflush(stderr) ;

    DELETE_FILES ;

    exit(-1) ; 
  }

  // if the tag is recursive creates a virtual tag to inserts occurrencies
  if (number_this_tag_opened > 1) { 

    recursive_logic_tag_size=((number_this_tag_opened-1)*strlen(XCDE_RECURSIVE_TAG_PREFIX)+strlen(token)) ; 
    
    recursive_logic_tag=(char *) malloc((recursive_logic_tag_size+1)*sizeof(char)) ; 
    
    recursive_logic_tag[0]='\0' ; 
      
    for(k=0 ; k<(number_this_tag_opened-1) ; ++k)
      
      strcat(recursive_logic_tag, "xml_") ; 
    
    strcat(recursive_logic_tag, token) ; 
    
    // inserts the logic recursive tag into the hash table 
    number_tokens+=hinsert((char *) recursive_logic_tag,
			   strlen(recursive_logic_tag),
			   TAG, 
			   (char *) NULL,
			   ht,
			   0,
			   0, 
			   (0x00)) ; 

    if (token != NULL) 

      free(token) ; 
    
    // the new token is the virtual one, 
    // that's the recursive logic token 
    token=recursive_logic_tag;
  }

  // ..
  // ..   start - CHECKS IF THE TAG IS EMPTY 
  // .. 

  // if enters in the block the tag is empty
  if (empty_tag_flag) { 
    
    number_this_tag_opened=hclosetag(tagposition) ;
      
    if ((!recursivetag_flag) && (number_this_tag_opened > 0)) { 
      
      fprintf(stderr, "\nFatal Error : at raw %d.the tag %s has not been opened, and so can't be closed\n\t\nError code 42\n", 
	      XML_GetCurrentLineNumber(parser),
	      el) ; 
      
      for(k=0 ; ((k<XCDE_EXPAT_PARSING_BUFFER_SIZE) && (k<100)) ; ++k)
	
	fprintf(stderr, "%c", expat_parsing_buffer[XML_GetCurrentByteIndex(parser)+k]) ; 
      
      fprintf(stderr, " ... \n") ; 
      
      fflush(stderr) ;
      
      DELETE_FILES ;
      
      exit(-1) ; 
    }
  }

  num_seps=0 ; 
  
  // ..
  // ..   start - ANALYZES ATTRIBUTES
  // ..   FOR EACH COUPLE ATTRIBUTE=VALUE CREATES TWO VIEW (PHYSICAL AND LOGICAL)
  // ..   AND EVENTUALLY CREATES OTHER COUPLES ATTRIBUT=RESULT_TOKEN, WHERE RESULT
  // ..   TOKEN IS CREATED BY DIVIDING THE VALUE USING ATTRIBUTES SEPARATOR CHARACTERS
  // ..

  if (attr[0] != NULL)  
    
    // loops over each couple attribute=value ... 
    for (j=0 ; attr[j]; j+=2) { 

      // sets the initial position of the attribute
      attribute_position=xml_position ; 

      // finds the initial position of the value of the attribute
      logic_token_len=get_next_token((char *) xml_code+attribute_position, 
				     "\'\"",
				     &separator,
				     xml_dimension-attribute_position) ; 
	
      attribute_position+=(logic_token_len+1) ;
      
      // finds which is the separator 
      sprintf(seps, "%c", separator) ; 
      
      // finds the final position of the value of the attribute
      logic_token_len=get_next_token((char *) xml_code+attribute_position,
				     seps, 
				     &delimiter,
				     xml_dimension-attribute_position) ; 
	
      // frees the memory eventually allocated for other couples 
      if (logic_token != NULL) 
	
	free(logic_token) ; 
      
      // allocates the memory for the logic token 
      logic_token=(char *) malloc((logic_token_len+2)*sizeof(char)) ; 
      
      // creates the logic view of the attribute
      for(k=0 ; k<logic_token_len; ++k)
	
	logic_token[k]=xml_code[attribute_position+k] ;
      
      logic_token[k]='\0' ; 
      
      if ((strlen(attr[j+1])) == 0) { 

	if (result_token != NULL)

	  free(result_token) ;

	result_token=(char *) malloc(3*sizeof(char)) ;

	strcpy(result_token, "") ;

	if (result != NULL) 

	  free(result) ;

	result=(char *) malloc(3*sizeof(char)) ;

	strcpy(result, "") ;
      }
      
      // checks the differences between the logical and physical views 
      for(position_logic_token=0, position_expanded_attribute=0, position_result=0, position_result_token=0 ; ((position_logic_token < strlen(logic_token)) && (position_expanded_attribute) < strlen(attr[j+1])) ;) 
	
	// there is a correspondence between the logic view and the expanded one 
	if ((logic_token[position_logic_token] == attr[j+1][position_expanded_attribute]) && (attr[j+1][position_expanded_attribute] != '&')) { 

	  // checks if the character is a separator 
	  for (i=0, done=0u; ((done==0u) && (i<strlen(attribute_separators))); ++i) 
	    
	    if (logic_token[position_logic_token] == attribute_separators[i]) 
	      
	      done=1u ; 
	  
	  // the character is a separators, and there is a token in memory,
	  // so a coupe attribute=result_token has been found 
	  if ((i<strlen(attribute_separators) && (position_result_token > 0))) { 
	    
	    // frees the memory eventually allocated 
	    if (NTagNAttr != NULL) 
	      
	      free(NTagNAttr) ; 
	    
	    // allocates the memory for the couple attr=result_token
	    NTagNAttr=(char *) malloc((strlen(attr[j])+strlen(result_token)+2)*sizeof(char)) ; 
	    
	    // writes the couple in the memory 
	    sprintf(NTagNAttr, "%s%c%s", attr[j], _SepValAttr, result_token) ;
	    
	    // inserts the couple attr=result_token into the attribute dictionary
	    number_tokens+=hinsert(NTagNAttr, 
				   strlen(NTagNAttr),
				   ATTR, 
				   (char *) NULL,
				   ht, 
				   0,
				   0,
				   (0x00)) ;
	    
	    // put to 0 the pointer to the buffer attr=result_token 
	    position_result_token=0 ; 
	    
	    // checks the dimension of the buffer
	    if (position_result >= (result_dimension-1)) { 
	      
	      result=(char *) realloc((char *) result,
				      result_dimension+256) ; 
	      
	      result_dimension+=256 ; 
	    }
	    
	    // copies the character in the logical buffer
	    result[position_result]=attr[j+1][position_expanded_attribute] ; 
	    
	    result[position_result+1]='\0' ; 
	    
	    // increases the counters
	    ++position_result ; 
	    
	    ++position_logic_token ; 
	    
	    ++position_expanded_attribute ;
	  }
	  
	  else 
	    
	    if (i<strlen(attribute_separators)){ // the character is a separator, but there is not a couple attr=result_token
	                                         // to be inserted into a dictionary 

	      if (position_result >= (result_dimension-1)) { // checks the dimension of the logical buffer		  
 
		result=realloc(result,
			       result_dimension+256) ; 
		
		result_dimension+=256 ; 
	      }
		
	      // copies the character in the logical buffer
	      result[position_result]=attr[j+1][position_expanded_attribute] ; 
		
	      result[position_result+1]='\0' ; 
	      
	      // increases buffers pointers
	      ++position_result ; 
	      
	      ++position_logic_token ; 
	      
	      ++position_expanded_attribute ; 
	    }
	  
	    else { // the character isn't a separator

		// checks the dimension of the buffer attr=result_token 
		if (position_result_token >= (result_token_dimension-1)) { 
		  
		  result_token=(char *) realloc((char *) result_token,
						result_token_dimension+256) ; 
		  
		  result_token_dimension+=256 ; 
		}
		
		// copies the character in the buffer attr=result_token
		result_token[position_result_token]=attr[j+1][position_expanded_attribute] ; 
		
		result_token[position_result_token+1]='\0' ; 
		
		// checks the dimension of the logical buffer
		if (position_result >= (result_dimension-1)) { 
		  
		  result=(char *) realloc((char *) result,
					  result_dimension+256) ; 
		  
		  result_dimension+=256 ; 
		}
		
		// copies the character in the buffer
		result[position_result]=attr[j+1][position_expanded_attribute] ; 
		
		result[position_result+1]='\0' ; 
		
		// increases buffers counters 
		++position_result_token ; 
		
		++position_logic_token ; 
		
		++position_expanded_attribute ; 
		
		++position_result ; 
	    }
	}
	
	else  // there isn't a correspondence between the logical and 
	      // physical view 

	  // checks if it's because there is an entity reference in the attribute value 		
	  if (logic_token[position_logic_token]=='&') { // it's an entity reference. Reads its name. 
	    
	    // reads the entity name, that's ended by the semicolon 
	    token_len=get_next_token((char *) (logic_token+position_logic_token),
				     ";",
				     &separator, 
				     strlen(logic_token)-position_logic_token) ; 

	    // it's read the name of the entity. Not it's going to check its type (numerical, internal, external)

	    // checks if it's a numerical entity (for example &#126;) 		
	    if (logic_token[position_logic_token+1] == '#') { // if enters in this block it's a numeric entity 

	      // increases the position pointer 
	      position_logic_token+=(token_len+1) ;
		  
	      // checks if the entity reference character is a separator
	      for (i=0, done=0u; ((done==0u) && (i<strlen(attribute_separators))); ++i) 
		  
		if (attr[j+1][position_expanded_attribute] == attribute_separators[i])
			
		  done=1u ; 
		  
	      if ((i<strlen(attribute_separators)) && (result_token > 0)) { // it's a separator and there's a couple attr=result_tokens in the 
		                                                            // buffer: inserts it in the attribute dictionary 
	
		// frees the memory allocated
		if (NTagNAttr != NULL) 
		  
		  free(NTagNAttr) ; 
		    
		// allocates the memory needed to contain the couple attr=result_token
		NTagNAttr = (char *) malloc((strlen(result_token)+strlen(attr[j])+2)*sizeof(char)) ; 
		
		// writes the couple attr=result_token in the memory allocated 
		sprintf(NTagNAttr, "%s%c%s", attr[j], _SepValAttr, result_token) ;
		
		// inserts the couple attr=result_token in the attributes dictionary
		number_tokens+=hinsert(NTagNAttr, 
				       strlen(NTagNAttr),
				       ATTR, 
				       (char *) NULL,
				       ht, 
				       0,
				       0,
				       (0x00)) ;
		
		// put to 0 the pointer to the attr=result_token buffer
		position_result_token=0 ; 
	      }
		    
	      else { // it's not a separator and must be copied 

		// checks the buffer dimension 
		if (position_result_token >= (result_token_dimension-1)) { 

		  result_token=(char *) realloc((char *) result_token,
						result_token_dimension+256) ;
		      
		      result_token_dimension+=256 ; 
		}
		
		// copies the character in the attr=result_token buffer
		result_token[position_result_token]=attr[j+1][position_expanded_attribute] ; 
		
		result_token[position_result_token+1]='\0' ; 
		
		// increases the counter 
		++position_result_token ; 
	      }

	      // checks the logical buffer dimension 
	      if (position_result >= (result_dimension-1)) { 

		result=(char *) realloc((char *) result,
					result_dimension+256) ; 
		
		result_dimension+=256 ; 
	      }
	      
	      // copies the character in the logical buffer
	      result[position_result]=attr[j+1][position_expanded_attribute] ; 
		  
	      result[position_result+1]='\0' ; 
		  
	      // increases pointers 
	      ++position_result ; 
	      
	      ++position_expanded_attribute ; 
	    }
	      
	    else { // itsn't a numeric entity reference. It can be an internal or external entity 
	      
	      // frees the memory allocated  
	      if (entity != NULL) 
		
		free(entity) ; 
	      
	      // allocates the memory needed to contain the name of the entity 
	      entity=(char *) malloc((token_len+2)*sizeof(char)) ; 
	      
	      // reads the name of the entity and copies it in the memory allocated 
	      for(i=0 ; i<(token_len+1); ++i)  

		entity[i]=logic_token[position_logic_token+i] ; 
		
	      entity[i]='\0' ; 
		  
	      // checks if the entity is a separator (this information is in the configuration file) 
	      if (hsearch(entity,
			  strlen(entity),
			  NOTHING, 
			  expat_attribute_separators_table))  { // if enters here means that the entity is a separator, 
		                                                // checks if there is a couple attr=result_token in the buffer 

		if (position_result_token > 0) { // if enters here the entity is in the list of separator entities
		                                 // and there's a couple attr=result_token in the buffer

		  // frees the memory allocated 
		  if (NTagNAttr != NULL) 
			 
		    free(NTagNAttr) ; 
		  
		  // allocates the memory needed to contain the couple attr=result_token 
		  NTagNAttr = (char *) malloc((strlen(attr[j])+strlen(result_token)+2)*sizeof(char)) ; 
		  

		  // writes the attr=result_token couple in the memory allocated
		  sprintf(NTagNAttr, "%s%c%s", attr[j], _SepValAttr, result_token) ;
		  
		  // inserts the attr=result_token couple in the hash table 
		  number_tokens+=hinsert(NTagNAttr, 
					 strlen(NTagNAttr),
					 ATTR, 
					 (char *) NULL,
					 ht, 
					 0,
					 0,
					 (0x00)) ; 
		      
		  // put to 0 the pointer to the attr=result_token buffer
		  position_result_token=0 ; 
		}
		 
		// increases the pointer to the logical buffer
		position_logic_token+=(token_len+1) ; 

		// if it's a predefined or an internal entity, increase the position expanded attribute with the 
		// length of the associated elements
		if ((search=hsearch(entity,
				    strlen(entity),
				    NOTHING, 
				    expat_general_declared_entity)) != NULL)
		  
		  position_expanded_attribute+=(strlen(search->ass_el)) ;
	      }
		
	      else
		  
		if ((search=hsearch(entity,
				    strlen(entity),
				    NOTHING, 
				    expat_general_declared_entity)) != NULL) { // it's an predefined entity or a general internal declared entity

		  // increases the pointer to the logical buffer
		  position_logic_token+=(token_len+1) ; 

		  // increases the pointer to the expanded attribute with the length of the associated element
		  position_expanded_attribute+=(strlen(search->ass_el)) ;
		  
		  for(i=0 ; i<strlen(search->ass_el); ++i) { // checks if any character in the expansion is a separator 

		    for(k=0, done=0u ; ((done==0u) && (k<strlen(attribute_separators))); ++k)
			
		      if (attribute_separators[k] == search->ass_el[i])
			
			done=1u ; 
			  
		    if ((k<strlen(attribute_separators)) && (position_result_token > 0)) { // the character is a separator and there's a couple attr=result_token 
		                                                                           // in the buffer 
			    
			// frees the memory allocated
			if (NTagNAttr != NULL)
			  
			  free(NTagNAttr) ; 
			
			// allocates the memory needed for the couple attr=result_token 
			NTagNAttr = (char *) malloc((strlen(attr[j])+strlen(result_token)+2)) ; 
			  
			// writes the value of the couple attr=result_token in the memory 
			sprintf(NTagNAttr, "%s%c%s", attr[j], _SepValAttr, result_token) ;
			  
			// inserts the couple attr=result_token into the attribute dictionary
			number_tokens+=hinsert(NTagNAttr, 
					       strlen(NTagNAttr),
					       ATTR, 
					       (char *) NULL,
					       ht, 
					       0,
					       0,
					       (0x00)) ;
			    
			// put to 0 the pointer to the couple attr=result_token
			position_result_token=0 ; 
		      }
			  
		      else if (k >= strlen(attribute_separators)) { // the character isn't a separator. It must be copied to buffers
			  
			// checks the dimension of the attr=result_token buffer
			if (position_result_token >= (result_token_dimension-1)) { 
			  
			  result_token=(char *) realloc((char *) result_token,
							result_token_dimension+256) ; 
			  
			  result_token_dimension+=256 ; 
			}
			
			// copies the character to the couple attr=result_token buffer
			result_token[position_result_token]=search->ass_el[i] ; 
			
			result_token[position_result_token+1]='\0' ; 
			
			// increases the pointer to the couple attr=result_token buffer
			++position_result_token ; 
		      }
		      
		      // checks the dimension of the buffer
		      if (position_result >= (result_dimension-1)) { 
			
			result = (char *) realloc((char *) result,
						  result_dimension+256) ;
			
			result_dimension+=256 ;
		      }
		      

		      // copies the character to the logical buffer
		      result[position_result]=search->ass_el[i] ; 
		      
		      result[position_result+1]='\0' ; 
		      
		      // increases the pointer to the logical buffer 
		      ++position_result ;
		  }
		}	
		else { // it's an external entity reference. It's not expanded but its name is written to the
		       // logical and attr=result_token buffer
		  
		  for (i=0; i<token_len+1; ++i)  { // loops over all character of the external entity 
		    
		    // checks the dimension of the attr=result_token buffer
		    if ((position_result_token+i) >= (result_token_dimension-1)) { 
		      
		      result_token=(char *) realloc((char *) result_token,
						    result_token_dimension+256) ;
		      
		      result_token_dimension+=256 ; 
		    }
		    
		    // copies the character of the name of the external entity to the attr=result_token buffer
		    result_token[position_result_token+i]=logic_token[position_logic_token+i] ; 
		    
		    // checks the dimension of the logical buffer
		    if ((position_result+i) >= (result_dimension-1)) {  

		      result=(char *) realloc((char *) result,
					      result_dimension+256) ; 
		      
		      result_dimension+=256 ;
		    }
		     
		    // copies the character of the name of the external entity to the logical buffer 
		    result[position_result+i]=logic_token[position_logic_token+i] ; 
		  }
		    
		  result[position_result+i]='\0' ; 
		  
		  result_token[position_result_token+i]='\0' ; 
		    
		  // increases pointers to the buffers 		  
		  position_result_token+=(token_len+1) ; 
		  
		  position_result+=(token_len+1) ; 
		    
		  position_logic_token+=(token_len+1) ; 
		}
	    }
	  }

      // it's at the end of the attributes and may be that a couple attr=result_tokens is in the buffer
      if (position_result_token > 0) { // there's a couple attr=result_token in the buffer
	
	// frees the memory allocated
	if (NTagNAttr != NULL)
	  
	  free(NTagNAttr) ; 
	
	// allocates the memory needed to contain the couple attr=result_token
	NTagNAttr = (char *) malloc((strlen(attr[j])+strlen(result_token)+2)*sizeof(char)) ; 
	
	// writes the couple attr=result_token in the buffer
	sprintf(NTagNAttr, "%s%c%s", attr[j], _SepValAttr, result_token) ;
	
	// insert the couple attr=result_token in the attribute dictionary 
	number_tokens+=hinsert(NTagNAttr, 
			       strlen(NTagNAttr),
			       ATTR, 
			       (char *) NULL,
			       ht, 
			       0,
			       0,
			       (0x00)) ;
	
	// put to 0 the pointer to the attr=result_token buffer 
	position_result_token=0 ; 
      }
      
      // now it must insert the logical token attr=token_value and its physical correspondence

      // frees the memory allocated 
      if (NTagNAttr != NULL)
	
	free(NTagNAttr) ; 

      // allocates the memory needed to contain the couple attr=token_value 
      NTagNAttr = (char *) malloc((strlen(attr[j])+strlen(result)+4)*sizeof(char)) ;

      // writes the attr=separator-logic value-separator couple in the memory allocated
      
      sprintf(NTagNAttr, "%s%c%c%s%c", attr[j], _SepValAttr, delimiter, result, delimiter) ;

      // inserts the couple in the attributes dictionary 
      number_tokens+=hinsert(NTagNAttr, 
			     strlen(NTagNAttr),
			     ATTR, 
			     (char *) NULL,
			     ht, 
			     0,
			     0,
			     (0x00)) ; 
      
      // reads the physical value of the attribute
      token_len1=get_next_token(xml_code+xml_position,
				(delimiter == _DoppiApici) ? "\"" : "\'", 
				&separator, 
				xml_dimension-xml_position) ;
      
      token_len2=get_next_token(xml_code+xml_position+token_len1+1, 
				(delimiter == _DoppiApici) ? "\"" : "\'", 
				&separator, 
				xml_dimension-(xml_position+token_len1+1)) ; 
      
      token_len = token_len1 + token_len2 + 2 ;


      if ((physic_flag) && (strncmp(xml_code+xml_position, 
				    NTagNAttr, 
				    token_len) != 0)) { // theres't correspondence beetween the logical and physical view,
	                                                // for example because there's an attribute in the value, so 
	                                                // inserts the physical view in the attributes dictionary 
	
	// frees the memory allocated
	if (NTagNAttr != NULL)

	  free(NTagNAttr) ; 
	
	// allocates the memory needed for the physical view 
	NTagNAttr = (char *) malloc((token_len+1)*sizeof(char)) ; 
	
	// copies the physical view in the memory allocated 
	strncpy((char *) NTagNAttr, 
		xml_code+xml_position, 
		token_len) ; 
	
	NTagNAttr[token_len] = '\0' ; 
      }

      if (physic_flag) { // inserts the physical view of the couple attr= separator - result value - separator in the attributes 
	                 // dictionary and increases the physical count 

	number_tokens+=hinsert((char *) NTagNAttr,
			       strlen(NTagNAttr),
			       ATTR, 
			       (char *) NULL,
			       ht, 
			       0,
			       0, 
			       ((0x00) | _INCREASE_PHYSICAL_COUNT)) ; 
	
	if (verbosing_flag)
	  
	  fprintf(debugPhysicView, "%s", NTagNAttr) ; 
      }

      // increases the logic position 
      xml_position+=token_len ; 
      
      do { // reads the separator character until the end of the tag or the next attribute
	
	num_seps=0 ;
	
	while(((token_len=get_next_token(xml_code+xml_position, 
					 " />\t\n", 
					 &separator, 
					 xml_dimension-xml_position))== 0)
	      
	      && (num_seps <  XCDE_MAX_SEPARATORS_BLOCK)) { 
	  
	  ++xml_position ; 
	  
	  seps[num_seps]=separator; 
	  
	  ++num_seps ; 
	  
	  if (separator == '/') // in this case it's an empty flag 
	    
	    empty_tag_flag=1u ; 
	  
	  if (separator == '>') // in this case it's reached the end of the tag 
	    
	    break ; 
	}
	
      seps[num_seps]='\0' ; 
      
      if ((empty_tag_flag) && (separator == '>')) { // in this case it's an empty flag 
	
	// check if it's a recursive tag and that's not allowed 
	number_this_tag_opened=hclosetag(tagposition) ;

	if ((!recursivetag_flag) && (number_this_tag_opened > 0)) {  // in this case it's a recursive tag and that's not allowed

	  fprintf(stderr, "\nFatal Error : at raw %d.the tag %s has not been opened, and so can't be closed\n\tError code 43\n", 
		  XML_GetCurrentLineNumber(parser),
		  el) ; 
	  
	  for(k=0 ; ((k<XCDE_EXPAT_PARSING_BUFFER_SIZE) && (k<100)) ; ++k)
	    
	    fprintf(stderr, "%c", expat_parsing_buffer[XML_GetCurrentByteIndex(parser)+k]) ; 
	  
	  fprintf(stderr, " ... \n") ; 
	  
	  fflush(stderr) ;
	
	  DELETE_FILES ;
	
	  exit(-1) ; 
	}
      }

      if ((physic_flag) && (num_seps > 0))  { // if there's the correspondence between logical and physical view inserts separators
	                                      // in the words dictionary 
 
	number_tokens+=hinsert((char *) seps, 
			       strlen(seps) , 
			       WORD, 
			       (char *) NULL, 
			       ht, 
			       0,
			       0, 
			       ((0x00) | _INCREASE_PHYSICAL_COUNT)) ; 
	
	if ((verbosing_flag) && (num_seps > 0)) 
	    
	  fprintf(debugPhysicView, "%s", seps) ; 
      }
      
      } while ((separator!='>') && (token_len==0)) ;
    }

  // it's has analyzed all attributes or there're no attributes

  // frees allocated memory
  if (token != NULL) 
    
    free(token) ;  

  if (entity != NULL)
    
    free(entity) ;

  if (result != NULL)

    free(result) ;  

   if (result_token != NULL) 
    
      free(result_token) ;  

  if (logic_token != NULL)
    
    free(logic_token) ; 

  if (NTagNAttr != NULL)
    
    free(NTagNAttr) ; 

  return ; 
}

void 
startcod(void *data,
	 const char *el, 
	 const char **attr)
{ // counter variables 
  register
    int j=0 ;

  register
    int k=0 ;
  
  register
    int i=0 ;

  int buffer_length=0 ; 

  char *token=NULL ; 

  int token_len=0 ; 

  char *recursive_logic_tag=NULL ; 

  int recursive_logic_tag_size=0 ; 

  int number_this_tag_opened=0 ; 

  char *entity=NULL ; 

  int entity_len=0 ; 

  char separator='\0' ; 

  char delimiter='\0' ; 

  char seps[XCDE_MAX_SEPARATORS_BLOCK+1] ; 

  char *logic_token=NULL ; 

  int logic_token_len=0 ; 

  char *result_token=NULL ;

  int result_token_dimension=0 ; 

  char *result=NULL ; 

  int result_dimension=0 ; 

  int position_logic_token=0 ; 

  int attribute_position=0 ; 
  
  int position_expanded_attribute=0 ; 

  int position_result=0 ; 

  int position_result_token=0 ; 

  char *NTagNAttr=NULL ; 

  int num_seps=0 ; 

  unsigned 
    char physic_flag=0u ; 

  unsigned 
    char done=0u ; 

  Hashptr search=NULL ;

  Hashptr tagposition=NULL ; 

  int token_len1=0 ;

  int token_len2=0 ;

  // ..
  // ..   
  // ..   startcod - ANALYZES THE TEXTBUFFER
  // ..
  // ..
  
  // checks if there is a token in the buffer
  // and reads it 
  if (text_in_buffer(&textbuffer)) { 
    
    buffer_length=get_buffer_length(&textbuffer) ; 
    
    token = (char *) malloc((buffer_length+1)*sizeof(char)) ;  
    
    buffer_length=get_text_in_buffer(&textbuffer, 
				     token) ; 
    
    token[buffer_length]='\0' ; 
    
    undercase(token, 
	      buffer_length) ; 

    // the logical token in the buffer isn't an entity expantion.  
    if (physical_correspondence) 
    
      hinsert((char *) token,
	      buffer_length,
	      WORD,
	      (char *) NULL, 
	      ht, 
	      last_body_position_written,
	      0,
	      ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ;  

    // in this case the logical token in the buffer is an entity expantion. 
    else { hinsert((char *) token,
		buffer_length,
		WORD,
		(char *) NULL,
		ht,
		last_body_position_written,
		elementRank, 
		((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
    
    // increases the rank of the element
    ++elementRank ; 
    }
  }

  // ..
  // ..   startcod - INCREASES THE NUMBER OF TAG OPENED AND  
  // ..   CHECKS THE CORRESPONDENCE BEETWEEN PHYSICAL
  // ..   AND LOGICAL VIEW (EVANTUALLY THE FUNCTION PHY_CORR INSERTS
  // ..   THE ENTITY IN THE HASH TABLE, AS WE CAN SEE FROM THE 1 OPTION)
  // .. 


  // increases the number of tags opened
  ++expat_number_tag_opened ; 
  
  // update the last physical position written 
  if (physical_correspondence)

    last_body_position_written=body_size_without_zlib ; 
  
  // checks if there is a correspondence between logical
  // and physical views
  physical_correspondence=phy_corr(&entity,
				   &entity_len,
				   0) ; 
  
  // update the last physical correspondence 
  last_physical_correspondence=physical_correspondence ; 
  
  // checks if it's in an entity expantion and it's different from
  // the previous entity expantion (in this case update the element rank
  // counter)
  if ((!physical_correspondence) && (changed_position))
    
    elementRank=1 ; 
  
  // ..
  // ..   startcod - READS THE TAGNAME AND INSERTS IT IN THE HASH TABLE
  // .. 

  // reads the tagname 
  token_len=get_next_token(xml_code+xml_position,
			   " /\t\n>", 
			   &separator,  
			   xml_dimension-xml_position) ; 
  
  // eventually frees the memory allocated to read the textbuffer
  if (token != NULL)
    
    free(token) ; 
  
  // allocates the memory needed to read the token name 
  token = (char *) malloc(token_len*sizeof(char)) ; 
  
  // copies the token read with get_next_token function, starting from 1 
  // to cancel the '<' character 
  for (k=1; k<token_len; ++k) 
    
    token[k-1]=xml_code[xml_position+k] ; 
  
  token[k-1]='\0' ;
  
  if (physical_correspondence) { // if there's the physical correspondence writes the character '<' and the
                                 // token name in the body file 
    
    output_token("<", 
		 1, 
		 WORD) ; 
    
    output_token(token, 
		 strlen(token),
		 TAG) ; 
  }

  // updates the pointer to the logical text element 
  xml_position+=token_len ;

  // ..
  // ..   startcod - CHECKS IF THE TAG IS RECURSIVE
  // .. 

  // checks how many times the tag has been opened, and if it's a recursive tag
  if ((tagposition=hsearch((char *) el,
			   strlen(el), 
			   TAG, 
			   ht)) == NULL) { 

    fprintf(stderr, "\nFatal Error: at raw %d.Tag %s not found in the hash table\n\tError code 44\n", 
	    XML_GetCurrentLineNumber(parser), 
	    el) ;
    
    for(k=0 ; ((k<XCDE_EXPAT_PARSING_BUFFER_SIZE) && (k<100)) ; ++k)
      
      fprintf(stderr, "%c", expat_parsing_buffer[XML_GetCurrentByteIndex(parser)+k]) ; 
    
    fprintf(stderr, " ... \n") ; 
    
    DELETE_FILES ;
    
    exit(-1) ;
  }
  
  // find the tagposition and sets the tag open flag to on
  number_this_tag_opened=hopentag(tagposition) ;

  if ((!recursivetag_flag) && (number_this_tag_opened > 1)) { // if enters in the block the tag is recursive, and this situation isn't allowed 

    fprintf(stderr, "\nFatal Error : at raw %d.It's not possible to nest the tag %s into itself\n\tError code 45\n", 
	    XML_GetCurrentLineNumber(parser), 
	    el) ; 
    
    for(k=0 ; ((k<XCDE_EXPAT_PARSING_BUFFER_SIZE) && (k<100)) ; ++k)
      
      fprintf(stderr, "%c", expat_parsing_buffer[XML_GetCurrentByteIndex(parser)+k]) ; 
    
    fprintf(stderr, " ... \n") ; 
    
    fflush(stderr) ;
    
    DELETE_FILES ;
    
    exit(-1) ; 
  }

  // if the tag is recursive creates a virtual tag to inserts occurrencies
  if (number_this_tag_opened > 1) { 

    recursive_logic_tag_size=((number_this_tag_opened-1)*strlen(XCDE_RECURSIVE_TAG_PREFIX)+strlen(token)) ; 
    
    recursive_logic_tag=(char *) malloc((recursive_logic_tag_size+1)*sizeof(char)) ; 
    
    recursive_logic_tag[0]='\0' ; 
    
    for(k=0 ; k<(number_this_tag_opened-1) ; ++k)
      
      strcat(recursive_logic_tag, "xml_") ; 
    
    strcat(recursive_logic_tag, token) ; 

    if (token != NULL) 
      
      free(token) ; 

    // the new token is the virtual one, 
    // that's the recursive logic token 
    token=recursive_logic_tag ; 
  }
  
  // theresn't a correspondence beetween logical and physical
  // views. 
  if (!physical_correspondence)
    
    // insert the opening tag (or virtual tag) position as an escape position.
    // Doesn't increase the element rank because all the tag and its attributes
    // have the same element rank 
    hinsert((char *) token,
	    strlen(token),
	    TAG,
	    (char *) NULL, 
	    ht, 
	    last_body_position_written,
	    elementRank,
	    ((0x00) | _INSERT_PHYSIC_ESCAPE)) ;
  
  else
    
    // insert the opening tag (or virtual tag) position as a physical position 
    hinsert((char *) token,
	    strlen(token),
	    TAG,
	    (char *) NULL, 
	    ht, 
	    last_body_position_written,
	    0,
	    ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)); 

  // ..
  // ..   startcod - READS SEPARATORS AND PUTS IT IN THE HASH TABLE 
  // .. 

  do { num_seps=0 ; 
    
    do { seps[num_seps]=separator ; 
	
    ++num_seps ; 
	
    ++xml_position ; 
      
    if (separator=='/') empty_tag_flag=1u;
    
    } while ((separator != '>') && (num_seps < XCDE_MAX_SEPARATORS_BLOCK) && 
	     ((token_len = get_next_token(xml_code+xml_position, 
					  " />\t\n", 
					  &separator, 
					  xml_dimension-xml_position))==0)) ;
    
    seps[num_seps]='\0' ; 
    
    // ..
    // ..   startcod - CHECKS IF THE TAG IS EMPTY 
    // .. 

    // checks if it's in the case of an empty tag 
    if ((empty_tag_flag) && (separator == '>')) { // in this case the tag is empty 
      
      if (!physical_correspondence) { // there's correspondence between physical and logical views  
	
	// insert the closing position of the tag (or of the virtual tag) as an 
	// escape position 
	hinsert((char *) token,
		strlen(token),
		TAG,
		(char *) NULL, 
		ht, 
		last_body_position_written,
		elementRank,
		((0x00) | _INSERT_PHYSIC_ESCAPE)) ;
	
	// increases the element rank 
	++elementRank ; 
      }
      
      else { // theresn't correspondence between physical and logical view 

	// the physical position of the closening is the physical position 
	// of the character '>'
	last_body_position_written=body_size_without_zlib ;
	
	// inserts the physical position of the character '>' in the TAG dictionary 
	hinsert((char *) token,
		strlen(token),
		TAG,
		(char *) NULL, 
		ht, 
		last_body_position_written,
		0,
		((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
      }

      // closes the tag 
      number_this_tag_opened=hclosetag(tagposition) ;

      // check if it's a recursive tag and that's not allowed 
      if ((!recursivetag_flag) && (number_this_tag_opened > 0)) { 

	fprintf(stderr, "\nFatal Error : at raw %d.the tag %s has not been opened, and so can't be closed\n\tError code 46\n", 
		XML_GetCurrentLineNumber(parser),
		el) ; 
      
	for(k=0 ; ((k<XCDE_EXPAT_PARSING_BUFFER_SIZE) && (k<100)) ; ++k)
	
	  fprintf(stderr, "%c", expat_parsing_buffer[XML_GetCurrentByteIndex(parser)+k]) ; 
      
	fprintf(stderr, " ... \n") ; 
	
	fflush(stderr) ;
	
	DELETE_FILES ;
	
	exit(-1) ; 
      }
    }

    // writes the separators block in the body file 
    if (physical_correspondence) { 

      output_token(seps, 
		   strlen(seps), 
		   WORD) ; 
    }
    } while ((token_len==0) && (num_seps == XCDE_MAX_SEPARATORS_BLOCK)) ;
  
  num_seps=0 ; 
  
  // ..
  // ..   startcode - ANALYZES ATTRIBUTES
  // ..   FOR EACH COUPLE ATTRIBUTE=VALUE CREATES TWO VIEW (PHYSICAL AND LOGICAL)
  // ..   AND EVENTUALLY CREATES OTHER COUPLES ATTRIBUT=RESULT_TOKEN, WHERE RESULT
  // ..   TOKEN IS CREATED BY DIVIDING THE VALUE USING ATTRIBUTES SEPARATOR CHARACTERS
  // ..


  // checks for the presence of attributes 
  if (attr[0] != NULL)  
    
    for (j=0 ; attr[j]; j+=2) { 

      // set the initial position of the attributes
      attribute_position=xml_position ; 
      
      // finds the initial position of the value of the attribute
      logic_token_len=get_next_token((char *) xml_code+attribute_position, 
				     "\'\"",
				     &separator,
				     xml_dimension-attribute_position) ; 
      
      attribute_position+=(logic_token_len+1) ; 
      
      // finds which is the separator 
      sprintf(seps, "%c", separator) ; 
      
      // frees the final position of the value of the attribute
      logic_token_len=get_next_token((char *) xml_code+attribute_position, 
				     seps,
				     &delimiter,
				     xml_dimension-attribute_position) ; 
      
      // frees the memory eventually allocated for other couples 
      if (logic_token != NULL)
	
	free(logic_token) ; 
      
      // allocates the memory for the logic token 
      logic_token=(char *) malloc((logic_token_len+1)*sizeof(char)) ; 
      
      // creates the logic views of the attribute
      for(k=0 ; k<logic_token_len; ++k)
	
	logic_token[k]=xml_code[attribute_position+k] ;
      
      logic_token[k]='\0' ; 
      
      if ((strlen(attr[j+1])) == 0) { 
	
	if (result_token != NULL)
	  
	  free(result_token) ;

	result_token=(char *) malloc(3*sizeof(char)) ;
	
	strcpy(result_token, "") ;

	if (result != NULL) 
	  
	  free(result) ;
	
	result=(char *) malloc(3*sizeof(char)) ;

	strcpy(result, "") ;
      }

      // checks the difference between the logical and physical views
      for(position_logic_token=0, position_expanded_attribute=0, position_result=0, position_result_token=0 ; ((position_logic_token < strlen(logic_token)) && (position_expanded_attribute < strlen(attr[j+1]))) ; )

	// there is a correspondence between the logic view and the expanded one 
	if ((logic_token[position_logic_token] == attr[j+1][position_expanded_attribute]) && (attr[j+1][position_expanded_attribute] != '&')) { 

	  // checks if the character is a separator 
	  for (i=0, done=0u; ((done == 0u) && (i<strlen(attribute_separators))); ++i) 
	    
	    if (logic_token[position_logic_token] == attribute_separators[i])
	      
	      done=1u ; 
	  
	  // the character is a separators, and there is a token in memory,
	  // so a coupe attribute=result_token has been found 
	  if ((i<strlen(attribute_separators) && (position_result_token > 0))) { 

	    // frees the memory eventually allocated 
	    if (NTagNAttr != NULL)
	      
	      free(NTagNAttr) ; 
	    
	    // allocates the memory for the couple attr=result_token 
	    NTagNAttr=(char *) malloc((strlen(attr[j])+strlen(result_token)+2)*sizeof(char)) ; 
	    
	    // writes the couple in the memory
	    sprintf(NTagNAttr, "%s%c%s", attr[j], _SepValAttr, result_token) ;
	    
	    // inserts the position of the couple attr=result_token into the attribute dictionary
	    if (!physical_correspondence)  
	      
	      // insert the escape position of the couple attr=result_tokens because it's derived from
	      // an internal entity expantion. Doesn't increase the element rank because all attributes
	      // have the name element rank of the tag
	      hinsert(NTagNAttr, 
		      strlen(NTagNAttr), 
		      ATTR,
		      (char *) NULL,
		      ht, 
		      last_body_position_written,
		      elementRank,
		      ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
	    
	    else

	      // inserts the physical position of the couple attr=result_token 
	      hinsert(NTagNAttr, 
		      strlen(NTagNAttr), 
		      ATTR,
		      (char *) NULL,
		      ht, 
		      last_body_position_written,
		      0, 
		      ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ;
	    
	    // put to 0 the pointer to the buffer attr=result_token 
	    position_result_token=0 ; 
	    
	    // checks the dimension of the buffer
	    if (position_result >= (result_dimension-1)) { 
	      
	      result=(char *) realloc((char *) result,
				      result_dimension+256) ; 
	      
	      result_dimension+=256 ; 
	    }
	    
	    // copies the character in the buffer
	    result[position_result]=attr[j+1][position_expanded_attribute] ; 
	    
	    result[position_result+1]='\0' ; 
	    
	    // increases buffers pointers 
	    ++position_result ; 
	    
	    ++position_logic_token ; 
	    
	    ++position_expanded_attribute ; 
	  }
	    
	  else 
	    
	    if (i<strlen(attribute_separators)) { // the character is a separator, but there is not a couple attr=result_token
	                                          // to be inserted into a dictionary  

	      if (position_result >= (result_dimension-1)) { // checks the dimension of the logical buffer 
		
		result=realloc(result,
			       result_dimension+256) ;
		
		result_dimension+=256 ; 
	      }

	      // copies the character in the logical buffer
	      result[position_result]=attr[j+1][position_expanded_attribute] ;
	      
	      result[position_result+1]='\0' ; 
	      
	      // increases buffers pointers
	      ++position_result ; 
	      
	      ++position_logic_token ; 
	      
	      ++position_expanded_attribute ;
	    }

	    else 
	      
	      { // the character isn't a separator

		// checks the dimension of the buffer attr=result_token 
		if (position_result_token >= (result_token_dimension-1)) { 

		result_token=(char *) realloc((char *) result_token,
					      result_token_dimension+256) ; 
		
		result_token_dimension+=256 ; 
		}
	      
		// copies the character in the buffer attr=result_token		
		result_token[position_result_token]=attr[j+1][position_expanded_attribute] ; 
	      
		result_token[position_result_token+1]='\0' ; 
		
		// checks the dimension of the logical buffer 
		if (position_result >= (result_dimension-1)) { 

		result=(char *) realloc((char *) result,
					result_dimension+256) ; 
		
		result_dimension+=256 ; 
		}
	      
		// copies the character in the buffer
		result[position_result]=attr[j+1][position_expanded_attribute] ; 
	      
		result[position_result+1]='\0' ; 
	      
		// increases buffers counter 
		++position_result_token ;
	      
		++position_expanded_attribute ; 
		
		++position_result ; 
	      
		++position_logic_token ; 
	      }
	}
	    
	else // there isn't a correspondence between the logical and 
	     // physical view 
	  
	  // checks if it's because there is an entity reference in the attribute value 		
	  if (logic_token[position_logic_token]=='&') { // it's an entity reference. Reads its name. 

	    // reads the entity name, that's ended by the semicolon 
	    token_len=get_next_token((char *) (logic_token+position_logic_token),
				     ";",
				     &separator, 
				     strlen(logic_token)-position_logic_token) ; 
	    
	    // it's read the name of the entity. Not it's going to check its type (numerical, internal, external)	    

	    // checks if it's a numeric reference (ea. &#126;) 		
	    if (logic_token[position_logic_token+1] == '#') {  // if enters it's a numeric reference 

	      // increase the position pointer 
	      position_logic_token+=(token_len+1) ; 
	      
	      // checks if the entity reference character is a separator
	      for (i=0, done=0u; ((done==0u) && (i<strlen(attribute_separators))); ++i) 
		
		if (attr[j+1][position_expanded_attribute] == attribute_separators[i])
		  
		  done=1u ; 
	      
	      // it's a separator: inserts the couple attr=result_token 
	      // into the attribute dictionary
	      if ((i<strlen(attribute_separators)) && (result_token > 0)) { // it's a separator and there's a couple attr=result_tokens in the 
		                                                            // buffer: inserts it in the attribute dictionary 

		// frees the memory allocated
		if (NTagNAttr != NULL)
		  
		  free(NTagNAttr) ; 
		
		// allocates the memory needed to contain the couple attr=result_token
		NTagNAttr = (char *) malloc((strlen(result_token)+strlen(attr[j])+2)*sizeof(char)) ; 
		
		// writes the couple attr=result_token in the memory allocated 
		sprintf(NTagNAttr, "%s%c%s", attr[j], _SepValAttr, result_token) ;
		
		// inserts the position of couple attr=result_token into the attribute dictionary 
		if (!physical_correspondence)
		  
		  // theresn't a correspondence between logical and physical views, so inserts the escape position. Doesn't
		  // increase the element rank because it's the same for the tag and all attributes 
		  hinsert(NTagNAttr, 
			  strlen(NTagNAttr), 
			  ATTR,
			  (char *) NULL,
			  ht, 
			  last_body_position_written,
			  elementRank,
			  ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
		
		else
		  
		  // there's a correspondence between logical and physical views, so inserts the physical position that's
		  // the same for the tag and all attributes 
		  hinsert(NTagNAttr, 
			  strlen(NTagNAttr), 
			  ATTR,
			  (char *) NULL,
			  ht, 
			  last_body_position_written,
			  0, 
			  ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ;	      
		
		// put to 0 the pointer to the attr=result_token buffer
		position_result_token=0 ; 
	      }
	      
	      else { // it's not a separator and must be copied 

		// checks the buffer dimension 
		if (position_result_token >= (result_token_dimension-1)) { 
		  
		  result_token=(char *) realloc((char *) result_token,
						result_token_dimension+256) ;
		      
		  result_token_dimension+=256 ; 
		}
		
		// copies the character in the attr=result_token buffer
		result_token[position_result_token]=attr[j+1][position_expanded_attribute] ; 
		
		result_token[position_result_token+1]='\0' ; 
		
		// increases the counter 
		++position_result_token ; 
	      }

	      // cheakcs the buffer dimension 
	      if (position_result >= (result_dimension-1)) { 
		
		result=(char *) realloc((char *) result,
					result_dimension+256) ; 
		
		result_dimension+=256 ; 
	      }
	      
	      // copies the character in the logical buffer 
	      result[position_result]=attr[j+1][position_expanded_attribute] ; 
	      
	      result[position_result+1]='\0' ; 
	      
	      // increases pointers 
	      ++position_result ; 
	      
	      ++position_expanded_attribute ; 		    
	    }
		
	    else { // itsn't a numeric entity reference. It can be an internal or external entity 

	      // frees the memory allocated
	      if (entity != NULL)
		
		free(entity) ; 
	      
	      // allocates the memory needed to contain the name of the entity 
	      entity=(char *) malloc((token_len+2)*sizeof(char)) ; 
	      
	      // reads the name of the entity and copies it in the memory allocated 
	      for(i=0 ; i<token_len+1; ++i) 
		    
		entity[i]=logic_token[position_logic_token+i] ; 
	      
	      entity[i]='\0' ; 
	      
	      // checks if the entity is a separator (this information is in the configuration file) 
	      if (hsearch(entity,
			  strlen(entity),
			  NOTHING, 
			  expat_attribute_separators_table)) {  // if enters here means that the entity is a separator, 
		                                                // checks if there is a couple attr=result_token in the buffer 

		if (position_result_token > 0) { // if enters here the entity is in the list of separator entities
           		                         // and there's a couple attr=result_token in the buffer

		  // frees the memory allocated 
		  if (NTagNAttr != NULL)
		    
		    free(NTagNAttr) ; 
		  
		  // allocates the memory needed to contain the couple attr=result_token 
		  NTagNAttr = (char *) malloc((strlen(attr[j])+strlen(result_token)+2)*sizeof(char)) ;
		  
		  // writes the attr=result_token couple in the memory allocated
		  sprintf(NTagNAttr, "%s%c%s", attr[j], _SepValAttr, result_token) ;
		  
		  if (physical_correspondence)
		  
		    // there's a correspondence between logical and physical views, so inserts the physical
		    // position and doesn't increase it because it's the same for the tag and all attributes
		    hinsert(NTagNAttr, 
			    strlen(NTagNAttr), 
			    ATTR,
			    (char *) NULL,
			    ht, 
			    last_body_position_written,
			    0,
			    ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
		  
		  else
		    
		    // theresn't a correspondence between logical and phycial views, so interts the escape
		    // position and doesn't increase the element rank because it's the same for the tag and all 
		    // attributes
		    hinsert(NTagNAttr, 
			    strlen(NTagNAttr), 
			    ATTR,
			    (char *) NULL,
			    ht, 
			    last_body_position_written,
			    elementRank,
			    ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
		  
		  // put to 0 the pointer to the attr=result_token buffer
		  position_result_token=0 ; 
		}
		
		// increases the pointer to the logical buffer
		position_logic_token+=(token_len+1) ; 
		
		
		// if it's a predefined or an internal entity, increase the position expanded attribute with the 
		// length of the associated elements
		if ((search=hsearch(entity,
				    strlen(entity),
				    NOTHING, 
				    expat_general_declared_entity)) != NULL)
		  
		  position_expanded_attribute+=(strlen(search->ass_el)) ;
	      }

	      else
		
		if ((search=hsearch(entity,
				    strlen(entity),
				    NOTHING, 
				    expat_general_declared_entity)) != NULL) {  // it's an predefined entity or a general internal declared entity

		  // increases the pointer to the logical buffer
		  position_logic_token+=(token_len+1) ; 
		  
		  // increases the pointer to the expanded attribute with the length of the associated element
		  position_expanded_attribute+=(strlen(search->ass_el)) ;
		  
		  for(i=0 ; i<strlen(search->ass_el); ++i) { // checks is any character in the expansion is a separator 

		    // checks if the character in the expansion is a separator 
		    for(k=0, done=0u ; ((done==0u) && (k<strlen(attribute_separators))); ++k)
		      
		      if (attribute_separators[k] == search->ass_el[i])
			
			done=1u ; 		
		    
		    if ((k<strlen(attribute_separators)) && (position_result_token > 0)) {  // the character is a separator and there's a couple attr=result_token 
			                                                                    // in the buffer 
		      
		      // frees the memory allocated		      
		      if (NTagNAttr != NULL)
			
			free(NTagNAttr) ; 
			    
		      // allocates the memory needed for the couple attr=result_token 
		      NTagNAttr = (char *) malloc((strlen(attr[j])+strlen(result_token)+2)) ; 
		      
		      // writes the value of the couple attr=result_token in the memory 
		      sprintf(NTagNAttr, "%s%c%s", attr[j], _SepValAttr, result_token) ;
		      
		      // inserts the physical or escape position of the couple attr=result_token 
		      // into the attribute dictionary
		      if (physical_correspondence)
			
			// there's correspondence between physical and logical views. In this case inserts
			// the physical position of the couple attr=result_token and doesn't increase it 
			// because it's the same for the tag and all attributes 
			hinsert(NTagNAttr, 
				strlen(NTagNAttr), 
				ATTR,
				(char *) NULL,
				ht, 
				last_body_position_written,
				0,
				((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
		      
		      else
			
			// theresn't correspondence between physical and logical views. In this case inserts
			// the escape position and doesn't increase the element rank because it's the same for
			// the tag and all attributes 
			hinsert(NTagNAttr, 
				strlen(NTagNAttr), 
				ATTR,
				(char *) NULL,
				ht, 
				last_body_position_written,
				elementRank,
				((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
		      
		      // put to 0 the pointer to the couple attr=result_token
		      position_result_token=0 ; 
		    }
		    
		    else
		      
		      if (k>= strlen(attribute_separators)) { // the character isn't a separator. It must be copied to buffers
			
			// checks the dimension of the buffer
			if (position_result_token >= (result_token_dimension-1)) { 
			  
			  result_token=(char *) realloc((char *) result_token,
							result_token_dimension+256) ; 
			  
			  result_token_dimension+=256 ; 
			}
			
			// copies the character to the couple attr=result_token buffer
			result_token[position_result_token]=search->ass_el[i] ; 
			
			result_token[position_result_token+1]='\0' ; 

			// increases the pointer to the couple attr=result_token buffer			
			++position_result_token ; 
		      }
		    
		    // checks the dimension of the buffer
		    if (position_result >= (result_dimension-1)) { 
		      
		      result = (char *) realloc((char *) result,
						result_dimension+256) ;
		      
		      result_dimension+=256 ;
		    }
			

		    // copies the character to the logical buffer
		    result[position_result]=search->ass_el[i] ; 
		    
		    result[position_result+1]='\0' ; 

		    // increases the pointer to the logical buffer 		    
		    ++position_result ;
		  }
		}

		else { // it's an external entity reference. It's not expanded but its name is written to the
		       // logical and attr=result_token buffer
		  
		  for (i=0 ; i<token_len+1; ++i) {  // loops over all character of the external entity 
		    
		    // checks the dimension of the attr=result_token buffer
		    if ((position_result_token+i) >= (result_token_dimension-1)) { 
		      
		      result_token= (char *) realloc((char *) result_token,
						     result_token_dimension+256) ; 
		      
		      result_token_dimension+=256 ; 
		    }
			
		    // copies the character of the name of the external entity to the attr=result_token buffer
		    result_token[position_result_token+i]=logic_token[position_logic_token+i] ; 
		    
		    // checks the dimension of the logical buffer
		    if ((position_result+i) >= (result_dimension-1)) { 
		      
		      result=(char *) realloc((char *) result,
					      result_dimension+256) ; 
		      
		      result_dimension+=256 ;
		    }
		     
		    // copies the character of the name of the external entity to the logical buffer 
		    result[position_result+i]=logic_token[position_logic_token+i] ;
		  }
		    
		  result[position_result+i]='\0' ; 
		  
		  result_token[position_result_token+i]='\0' ; 
		  
		  // increases pointers to the buffers 
		  position_result_token+=(token_len+1) ; 
		  
		  position_result+=(token_len+1) ; 
		  
		  position_logic_token+=(token_len+1) ; 
		  }
	      }
	  }
      
      // it's at the end of the attributes and may be that a couple attr=result_tokens is in the buffer
      if (position_result_token > 0) { 
	
	// frees the memory allocated 
	if (NTagNAttr != NULL)
	  
	  free(NTagNAttr) ;
	
	// allocates the memory needed to contain the couple attr=result_token
	NTagNAttr=(char *) malloc((strlen(attr[j])+strlen(result_token)+2)*sizeof(char)) ; 
	
	// writes the couple attr=result_token in the buffer
	sprintf(NTagNAttr, "%s%c%s", attr[j], _SepValAttr, result_token) ;
	
	// insert the physical or escape position of the couple attr=result_token in the attribute dictionary 	
	if (physical_correspondence)

	  // there's correspondence between physical and logical views. In this case inserts
	  // the physical position of the couple attr=result_token and doesn't increase it 
	  // because it's the same for the tag and all attributes 	  
	  hinsert(NTagNAttr, 
		  strlen(NTagNAttr), 
		  ATTR,
		  (char *) NULL,
		  ht, 
		  last_body_position_written,
		  0,
		  ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
	
	else
	  
	  // theresn't correspondence between physical and logical views. In this case inserts
	  // the escape position and doesn't increase the element rank because it's the same for
	  // the tag and all attributes 
	  hinsert(NTagNAttr, 
		  strlen(NTagNAttr), 
		  ATTR,
		  (char *) NULL,
		  ht, 
		  last_body_position_written,
		  elementRank,
		  ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
	
	// put to 0 the pointer to the attr=result_token buffer
	position_result_token=0 ; 
      }

      // now it must insert the position of the couple attr=token_value 

      // frees the memory allocated
      if (NTagNAttr != NULL) 
	
	free(NTagNAttr) ; 

      // allocates the memory needed to contain the couple attr=separator - logic value - separator 
      NTagNAttr = (char *) malloc((strlen(attr[j])+strlen(result)+4)*sizeof(char)) ; 

      // writes the attr=separator - logica value - separator couple in the memory allocated
      sprintf(NTagNAttr, "%s%c%c%s%c", attr[j], _SepValAttr, delimiter, result, delimiter) ;
      
      // checks if there's correspondence beetween physical and logical views
      if (physical_correspondence)


	// there's correspondence between physical and logical views. In this case inserts
	// the physical position of the couple attr=separator - logic value - separator and 
	// doesn't increase it because it's the same for the tag and all attributes 	 	
	hinsert(NTagNAttr, 
		strlen(NTagNAttr), 
		ATTR,
		(char *) NULL,
		ht, 
		last_body_position_written,
		0,
		((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
      
      else
	
	// theresn't correspondence between physical and logical views. In this case inserts
	// the escape position and doesn't increase the element rank because it's the same for
	// the tag and all attributes 
	hinsert(NTagNAttr, 
		strlen(NTagNAttr), 
		ATTR,
		(char *) NULL,
		ht, 
		last_body_position_written,
		elementRank,
		((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
      
      // reads the physical value of the attribute
      token_len1=get_next_token(xml_code+xml_position,
				(delimiter == _DoppiApici) ? "\"" : "\'", 
				&separator, 
				xml_dimension-xml_position) ;
      
      token_len2=get_next_token(xml_code+xml_position+token_len1+1, 
				(delimiter == _DoppiApici) ? "\"" : "\'", 
				&separator, 
				xml_dimension-(xml_position+token_len1+1)) ; 
      
      token_len = token_len1 + token_len2 + 2 ; 
      
      if ((physical_correspondence) && (strncmp(xml_code+xml_position, 
						NTagNAttr, 
						token_len) != 0)) {  // theres't correspondence beetween the logical and physical view,
	                                                             // for example because there's an attribute in the value, so 
	                                                             // writes the physical view in the body file  
	// frees the memory allocated
	if (NTagNAttr)
	  
	  free(NTagNAttr) ; 
	
	// allocates the memory needed for the physical view 
	NTagNAttr = (char *) malloc((token_len+1)*sizeof(char)) ; 
	
	// copies the physical view in the memory allocated 
	strncpy((char *) NTagNAttr, 
		xml_code+xml_position, 
		token_len) ; 
	
	NTagNAttr[token_len] = '\0' ; 
      }

      // writes the physical view of the couple attr= separator - logic value - separator 
      // to the body file (if there's physical correspondence)
      if (physical_correspondence) { 

	output_token(NTagNAttr, 
		     strlen(NTagNAttr), 
		     ATTR) ;
	
      }
	
      // increases the logic position 
      xml_position+=token_len ; 
      
      do { // reads the separator character until the end of the tag or the next attribute

	num_seps=0;
      
	while (((token_len=get_next_token(xml_code+xml_position, 
					  " />\t\n", 
					  &separator, 
					  xml_dimension-xml_position)) == 0)
	       
	       && (num_seps < XCDE_MAX_SEPARATORS_BLOCK)) { 
	  
	  ++xml_position ; 
	  
	  seps[num_seps]=separator; 
	  
	  ++num_seps ; 
	  
	  if (separator =='/') empty_tag_flag=1u; // in this case it's an empty flag 
	  
	  if (separator =='>') break ; // in this case it's reached the end of the tag 
	}
	
      seps[num_seps]='\0' ; 
      
     
      if ((empty_tag_flag) && (separator == '>')) { // in this case it's an empty flag  
	
	// checks if it's a recursive tag and that's not allowed
	number_this_tag_opened=hclosetag(tagposition) ;

	if ((!recursivetag_flag) && (number_this_tag_opened > 0)) { // in this case it's a recursive tag and that's not allowed

	  fprintf(stderr, "\nFatal Error : at raw %d.the tag %s has not been opened, and so can't be closed\n\tError code 47\n", 
		  XML_GetCurrentLineNumber(parser),
		  el) ; 
	  
	  for(k=0 ; ((k<XCDE_EXPAT_PARSING_BUFFER_SIZE) && (k<100)) ; ++k)
	    
	    fprintf(stderr, "%c", expat_parsing_buffer[XML_GetCurrentByteIndex(parser)+k]) ; 
	  
	  fprintf(stderr, " ... \n") ; 
	  
	  fflush(stderr) ;
	
	  DELETE_FILES ;
	
	  exit(-1) ; 
	}
	
	// it's must insert the physical or escape closing position. Checks it there's correspondence
	// between logical and physical views
	if (physical_correspondence) { // there's correspondence between logical and physical views

	  // update the closing position that is the position of the character '>' 
	  last_body_position_written=body_size_without_zlib ; 
	  
	  // insert the physical closing position to the attributes dictionary 
	  hinsert((char *) token,
		  strlen(token),
		  TAG,
		  (char *) NULL, 
		  ht, 
		  last_body_position_written,
		  0,
		  ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ;
	}
	
	else { // there's not correspondece between logical and physical views,
	       // inserts the escape position and increases the element rank
	  
	  hinsert((char *) token,
		  strlen(token),
		  TAG,
		  (char *) NULL, 
		  ht, 
		  last_body_position_written,
		  elementRank,
		  ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
	  
	  ++elementRank ; 
	}
      }

      // checks if there's correspondence
	if (physical_correspondence) { // there's correspondence. Writes separators to the body file
	  
	  output_token(seps, 
		       strlen(seps), 
		     WORD) ; 
	  
	}
      } while ((separator !='>') && (token_len==0)) ;
    }

  // it's has analyzed all attributes or there're no attributes

  // updates the last body position written
  last_body_position_written=body_size_without_zlib ;
  

  // frees the memory allocated
  if (token != NULL)
    
    free(token) ;

  if (result != NULL)
    
    free(result) ; 
  
  if (result_token != NULL)
    
    free(result_token) ; 

  if (NTagNAttr != NULL)

    free(NTagNAttr) ; 

  if (entity != NULL)

    free(entity) ; 

  if (logic_token != NULL)
    
    free(logic_token) ; 
  
  return ; 
}

void 
startwrite(void *data,
	   const char *el, 
	   const char **attr)
{ // counter variables 
  register
    int j=0 ;

  register
    int k=0 ;
  
  register
    int i=0 ;

  int buffer_length=0 ; 

  char *token=NULL ; 

  int token_len=0 ; 

  char *recursive_logic_tag=NULL ; 

  int recursive_logic_tag_size=0 ; 

  int number_this_tag_opened=0 ; 

  char *entity=NULL ; 

  int entity_len=0 ; 

  char separator='\0' ; 

  char delimiter='\0' ; 

  char seps[XCDE_MAX_SEPARATORS_BLOCK+1] ; 

  char *logic_token=NULL ; 

  int logic_token_len=0 ; 

  char *result_token=NULL ;

  int result_token_dimension=0 ; 

  char *result=NULL ; 

  int result_dimension=0 ; 

  int position_logic_token=0 ; 

  int attribute_position=0 ; 
  
  int position_expanded_attribute=0 ; 

  int position_result=0 ; 

  int position_result_token=0 ; 

  char *NTagNAttr=NULL ; 

  int num_seps=0 ; 

  unsigned 
    char physic_flag=0u ; 

  unsigned 
    char done=0u ; 

  Hashptr search=NULL ;

  Hashptr tagposition=NULL ; 

  int token_len1=0 ;

  int token_len2=0 ;

  // ..
  // ..   
  // ..   startwrite - ANALYZES THE TEXTBUFFER
  // ..
  // ..

  // checks if there is a token in the buffer
  // and reads it 
  if (text_in_buffer(&textbuffer)) { 

    buffer_length=get_buffer_length(&textbuffer) ; 
    
    token = (char *) malloc((buffer_length+1)*sizeof(char)) ;  
    
    buffer_length=get_text_in_buffer(&textbuffer, 
				     token) ; 
    
    token[buffer_length]='\0' ; 
    
    undercase(token, 
	      buffer_length) ; 
    
    // it must compute the proximity 
    if (proximity_flag) {

      // the token can be only a WORD component
      hinsert((char *) token, 
	      buffer_length, 
	      WORD, 
	      (char *) NULL, 
	      ht, 
	      proximity_counter,
	      0,
	      ((0x00) | _WRITE_LOGICAL_OCCURRENCE)) ;  
      
      // increases the proximity counter 
      ++proximity_counter ; 
    }
     
    // checks if there's a correspondence between logical and physical views
    if (physical_correspondence) 
      
      // there's a correspondence between physical and logical views. Insert the 
      // physical position of the token 
      hinsert((char *) token,
	      buffer_length,
	      WORD,
	      (char *) NULL, 
	      ht, 
	      last_body_position_written,
	      0,
	      ((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ;  

    else { // there's not correspondence beetween logical and physical views. Insert the 
           // escape position and increase the element rank  
      
      hinsert((char *) token,
	      buffer_length,
	      WORD,
	      (char *) NULL,
	      ht,
	      last_body_position_written,
	      elementRank, 
	      ((0x00) | _WRITE_PHYSIC_ESCAPE)) ; 
      
      // increases the rank of the element
      ++elementRank ; 
    }
  }

  // ..
  // ..   startwrite - INCREASES THE NUMBER OF TAG OPENED AND  
  // ..   CHECKS THE CORRESPONDENCE BEETWEEN PHYSICAL
  // ..   AND LOGICAL VIEW (EVANTUALLY THE FUNCTION PHY_CORR INSERTS
  // ..   THE ENTITY IN THE HASH TABLE, AS WE CAN SEE FROM THE 1 OPTION)
  // .. 

  // increases the number of tags opened
  ++expat_number_tag_opened ; 
  
  // it there's correspondence between logical and physical 
  // views updates the last body position written 
  if (physical_correspondence)
    
    last_body_position_written=body_size_without_zlib ; 
  
  // checks if there is a correspondence between logical
  // and physical views. The options is 2 because the body
  // has alyet been written 
  physical_correspondence=phy_corr(&entity,
				   &entity_len,
				   2) ; 
  
  // update the last physical correspondence used to analyze
  // the text
  last_physical_correspondence=physical_correspondence ; 
  
  // checks if it's in an entity expantion and it's different from
  // the previous entity expantion (in this case update the element rank
  // counter)
  if ((!physical_correspondence) && (changed_position))
    
    elementRank=1 ; 

  // ..
  // ..   startwrite - READS THE TAGNAME AND INSERTS IT IN THE ATTRIBUTES DICTIONARY
  // .. 
  
  // read the tagname 
  token_len=get_next_token(xml_code+xml_position,
			   " /\t\n>", 
			   &separator,  
			   xml_dimension-xml_position) ; 
  
  // eventually frees the memory allocated to read the textbuffer 
  if (token != NULL)
    
    free(token) ; 
  
  // allocates the memory needed to read the token name 
  token = (char *) malloc(token_len*sizeof(char)) ; 
  
  // copies the token read with get_next_token function, starting from 1 
  // to cancel the '<' character 
  for (k=1; k<token_len; ++k) 
    
    token[k-1]=xml_code[xml_position+k] ; 
  
  token[k-1]='\0' ;
  
  if (physical_correspondence) { // if there's physical correspondence between logical and physical
                                 // views updates the physical position written by adding the
                                 // codeword length of the character '<' and of the tag name 

    nooutput_token("<", 
		   1, 
		   WORD) ; 
    
    nooutput_token(token, 
		   strlen(token),
		   TAG) ; 
  }

  // ..
  // ..   startwrite - CHECKS IF THE TAG IS RECURSIVE
  // .. 
  
  // checks how many times the tag has been opened, and if it's a recursive tag
  if ((tagposition=hsearch((char *) el,
			   strlen(el), 
			   TAG, 
			   ht)) == NULL) { 
    
    fprintf(stderr, "\nFatal Error: at raw %d.Tag %s not found in the hash table\n\tError code 48\n", 
	    XML_GetCurrentLineNumber(parser), 
	    el) ;
    
    for(k=0 ; ((k<XCDE_EXPAT_PARSING_BUFFER_SIZE) && (k<100)) ; ++k)
      
      fprintf(stderr, "%c", expat_parsing_buffer[XML_GetCurrentByteIndex(parser)+k]) ; 
    
    fprintf(stderr, " ... \n") ; 
    
    DELETE_FILES ;
    
    exit(-1) ;
  }

  // finds the tagposition and sets the tag open flag to on
  number_this_tag_opened=hopentag(tagposition) ;
  
  if ((!recursivetag_flag) && (number_this_tag_opened > 1)) { // if enters in the block the tag is recursive, and this situation isn't allowed 

    fprintf(stderr, "\nFatal Error : at raw %d.It's not possible to nest the tag %s into itself\n\tError code 49\n", 
	    XML_GetCurrentLineNumber(parser), 
	    el) ; 
    
    for(k=0 ; ((k<XCDE_EXPAT_PARSING_BUFFER_SIZE) && (k<100)) ; ++k)
      
      fprintf(stderr, "%c", expat_parsing_buffer[XML_GetCurrentByteIndex(parser)+k]) ; 
    
    fprintf(stderr, " ... \n") ; 
    
    fflush(stderr) ;
    
    DELETE_FILES ;
    
    exit(-1) ; 
  }
  
  // if the tag is recursive creates a virtual tag to inserts occurrencies
  if (number_this_tag_opened > 1) { 
    
    recursive_logic_tag_size=((number_this_tag_opened-1)*strlen(XCDE_RECURSIVE_TAG_PREFIX)+strlen(token)) ; 
    
    recursive_logic_tag=(char *) malloc((recursive_logic_tag_size+1)*sizeof(char)) ; 
    
    recursive_logic_tag[0]='\0' ; 
    
    for(k=0 ; k<(number_this_tag_opened-1) ; ++k)
      
      strcat(recursive_logic_tag, "xml_") ; 
    
    strcat(recursive_logic_tag, token) ; 
    
    if (token != NULL) 
      
      free(token) ; 
    
    token=recursive_logic_tag ; 
  }
  
  // checks if there is a correspondence beetween logical and physical
  // views
  if (!physical_correspondence)
    
    hinsert((char *) token,
	    strlen(token),
	    TAG,
	    (char *) NULL, 
	    ht, 
	    last_body_position_written,
	    elementRank,
	    ((0x00) | _WRITE_PHYSIC_ESCAPE)) ;
  
  else
    
    hinsert((char *) token,
	    strlen(token),
	    TAG,
	    (char *) NULL, 
	    ht, 
	    last_body_position_written,
	    0,
	    ((0x00) | _WRITE_PHYSICAL_OCCURRENCE)); 

  // increases the logical position 
  xml_position+=token_len ;
  
  // ..
  // ..   start - READS SEPARATORS AND PUTS IT IN THE WORDS DICTIONARY 
  // .. 

  // eventually reads separator characters
  do { num_seps=0 ; 
    
  do { seps[num_seps]=separator ; 
      
  ++num_seps ; 
      
  ++xml_position ; 
      
  // if the character is '/' the tag is empty 
  if (separator=='/') empty_tag_flag=1u;
      
  } while ((separator != '>') && (num_seps < XCDE_MAX_SEPARATORS_BLOCK) && 
	   ((token_len = get_next_token(xml_code+xml_position, 
					" />\t\n", 
					&separator, 
					xml_dimension-xml_position))==0)) ;
    
  seps[num_seps]='\0' ; 
    
  // checks if it's in the case of an empty tag 
  if ((empty_tag_flag) && (separator == '>')) {  

    if (!physical_correspondence) { // theresn't a correspondence between physical and logical tag. Writes the escape
                                    // position of the tag and increases the element rank, because there are no attributes 

      hinsert((char *) token,
	      strlen(token),
	      TAG,
	      (char *) NULL, 
	      ht, 
	      last_body_position_written,
	      elementRank,
	      ((0x00) | _WRITE_PHYSIC_ESCAPE)) ;
	
      // increases the element rank
      ++elementRank ; 
    }
    
    else { // there's a correspondence between physical and logical tag. Writes the physical position of the tag

      last_body_position_written=body_size_without_zlib ;
	
      hinsert((char *) token,
	      strlen(token),
	      TAG,
	      (char *) NULL, 
	      ht, 
	      last_body_position_written,
	      0,
	      ((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ; 
    }

    // closes the tag, because it's empty 
    number_this_tag_opened=hclosetag(tagposition) ;
    
      if ((!recursivetag_flag) && (number_this_tag_opened > 0)) { 
	
	fprintf(stderr, "\nFatal Error : at raw %d.the tag %s has not been opened, and so can't be closed\nError code 50\n", 
		XML_GetCurrentLineNumber(parser),
		el) ; 
	
	for(k=0 ; ((k<XCDE_EXPAT_PARSING_BUFFER_SIZE) && (k<100)) ; ++k)
	  
	  fprintf(stderr, "%c", expat_parsing_buffer[XML_GetCurrentByteIndex(parser)+k]) ; 
	
	fprintf(stderr, " ... \n") ; 
	
	fflush(stderr) ;
	
	DELETE_FILES ;
	
	exit(-1) ; 
      }
  }
    
  // there's physical correspondence. Computes the separators codeword length
  if (physical_correspondence) { 
    
    nooutput_token(seps, 
		   strlen(seps), 
		   WORD) ; 
    
  }
  } while ((token_len==0) && (num_seps == XCDE_MAX_SEPARATORS_BLOCK)) ;

  // put to 0 the number of separators 
  num_seps=0 ; 

  // ..
  // ..   startwrite - ANALYZES ATTRIBUTES
  // ..   FOR EACH COUPLE ATTRIBUTE=VALUE CREATES TWO VIEW (PHYSICAL AND LOGICAL)
  // ..   AND EVENTUALLY CREATES OTHER COUPLES ATTRIBUT=RESULT_TOKEN, WHERE RESULT
  // ..   TOKEN IS CREATED BY DIVIDING THE VALUE USING ATTRIBUTES SEPARATOR CHARACTERS
  // ..  

  // checks for the presence of attributes 
  if (attr[0] != NULL)  
    
    // loops over each couple attributes=value ... 
    for (j=0 ; attr[j]; j+=2) { 

      // sets the initial position of the attribute
      attribute_position=xml_position ; 
      
      // finds the initial position of the value of the attribute
      logic_token_len=get_next_token((char *) xml_code+attribute_position, 
				     "\'\"",
				     &separator,
				     xml_dimension-attribute_position) ; 
      
      attribute_position+=(logic_token_len+1) ; 
      
      // finds which is the separator
      sprintf(seps, "%c", separator) ; 
      
      // finds the final position of the value of the attribute
      logic_token_len=get_next_token((char *) xml_code+attribute_position, 
				     seps,
				     &delimiter,
				     xml_dimension-attribute_position) ; 
      
      // frees the memory eventually allocated for other couples 
      if (logic_token != NULL)
	
	free(logic_token) ; 
      
      // allocates the memory for the logic token 
      logic_token=(char *) malloc((logic_token_len+1)*sizeof(char)) ; 
      
      // creates the logic views of the attribute
      for(k=0 ; k<logic_token_len; ++k)
	
	logic_token[k]=xml_code[attribute_position+k] ;
      
      logic_token[k]='\0' ; 

      if ((strlen(attr[j+1])) == 0) { 
	
	if (result_token != NULL)
	  
	  free(result_token) ;
	
	result_token=(char *) malloc(3*sizeof(char)) ;
	
	strcpy(result_token, "") ;

	if (result != NULL) 
	  
	  free(result) ;
	
	result=(char *) malloc(3*sizeof(char)) ;
	
	strcpy(result, "") ;
      }
      
      // checks the difference between the logical and physical views 
      for(position_logic_token=0, position_expanded_attribute=0, position_result=0, position_result_token=0 ; ((position_logic_token < strlen(logic_token)) && (position_expanded_attribute < strlen(attr[j+1]))) ; )
	
	// there is a correspondence between the logic view and the expanded one 
	if ((logic_token[position_logic_token] == attr[j+1][position_expanded_attribute]) && (attr[j+1][position_expanded_attribute] != '&')) { 

	  // checks if the character is a separator 
	  for (i=0, done=0u; ((done == 0u) && (i<strlen(attribute_separators))); ++i) 
	    
	    if (logic_token[position_logic_token] == attribute_separators[i])
	      
	      done=1u ; 
	  
	  // the character is a separators, and there is a token in memory,
	  // so a coupe attribute=result_token has been found 
	  if ((i<strlen(attribute_separators) && (position_result_token > 0))) { 

	    // frees the memory eventually allocated 
	    if (NTagNAttr != NULL)
	      
	      free(NTagNAttr) ; 
	    
	    // allocates the memory for the couple attr=result_token
	    NTagNAttr=(char *) malloc((strlen(attr[j])+strlen(result_token)+2)*sizeof(char)) ; 
	    
	    // writes the couple in the memory 
	    sprintf(NTagNAttr, "%s%c%s", attr[j], _SepValAttr, result_token) ;
	    
	    // inserts the position of the couple attr=result_token into the attribute dictionary
	    if (!physical_correspondence)  
	      
	      // there's not a correspondence between physical and logical views. In this case
	      // writes the escape position. Doesn't increase the element rank because all attributes 
	      // and the tag have the same position 
	      hinsert(NTagNAttr, 
		      strlen(NTagNAttr), 
		      ATTR,
		      (char *) NULL,
		      ht, 
		      last_body_position_written,
		      elementRank,
		      ((0x00) | _WRITE_PHYSIC_ESCAPE)) ; 
	    
	    else
	      
	      // there's a correspondence between physical and logical views. In this case
	      // writes the escape position. All attributes and the tag have the same position 
	      hinsert(NTagNAttr, 
		      strlen(NTagNAttr), 
		      ATTR,
		      (char *) NULL,
		      ht, 
		      last_body_position_written,
		      0, 
		      ((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ;
	      
	    // put to 0 the pointer to the attr=result_token buffer
	    position_result_token=0 ; 
	    
	    // checks the logical buffer dimension 
	    if (position_result >= (result_dimension-1)) { 
	      
	      result=(char *) realloc((char *) result,
				      result_dimension+256) ; 
	      
	      result_dimension+=256 ; 
	    }
	    
	    // copies the character to the buffer
	    result[position_result]=attr[j+1][position_expanded_attribute] ; 
	    
	    result[position_result+1]='\0' ; 
	    
	    // increases pointers 
	    ++position_result ; 
	    
	    ++position_logic_token ; 
	    
	    ++position_expanded_attribute ; 
	  }
	  
	  else 
	    
	    if (i<strlen(attribute_separators)) { // the character is a separator, but there is not a couple attr=result_token 
	                                          // to be inserted into a dictionary 
 
	      // checks the logical buffer dimension 
	      if (position_result >= (result_dimension-1)) { 
		
		result=realloc(result,
			       result_dimension+256) ;
		
		result_dimension+=256 ; 
	      }
	      
	      // copies character to the logical buffer dimension 
	      result[position_result]=attr[j+1][position_expanded_attribute] ;
	      
	      result[position_result+1]='\0' ; 
	      
	      // increases pointers 
	      ++position_result ; 
	      
	      ++position_logic_token ; 
	      
	      ++position_expanded_attribute ;
	    }
	  
	    else 
	      
	      { // the caracter isn't a separator, it's copied in all buffers

		// checks the attr=result_token buffer dimension 
		if (position_result_token >= (result_token_dimension-1)) { 
		
		  result_token=(char *) realloc((char *) result_token,
						result_token_dimension+256) ; 
		  
		  result_token_dimension+=256 ; 
		}
	      
		// copies character in the attr=result_token buffer 
		result_token[position_result_token]=attr[j+1][position_expanded_attribute] ; 
	      
		result_token[position_result_token+1]='\0' ; 
	      
		// checks the logical buffer dimension 
		if (position_result >= (result_dimension-1)) { 
		
		  result=(char *) realloc((char *) result,
					  result_dimension+256) ; 
		  
		  result_dimension+=256 ; 
		}
	      
		// copies the character in the logical buffer 
		result[position_result]=attr[j+1][position_expanded_attribute] ; 
	      
		result[position_result+1]='\0' ; 
		
		// increases buffers pointers  
		++position_result_token ;
		
		++position_expanded_attribute ; 
		
		++position_result ; 
		
		++position_logic_token ; 
	      }
	}
      
	else
	  
	  // there isn't a correspondence between the logical and 
	  // physical view 
	  
	  
	  // checks if it's because there is an entity reference in the attribute value
	  if (logic_token[position_logic_token]=='&') { // if enters in this block it's a numeric reference 
	    
	    // reads the entity name, that's ended by the semicolon 
	    token_len=get_next_token((char *) (logic_token+position_logic_token),
				     ";",
				     &separator, 
				     strlen(logic_token)-position_logic_token) ; 
	    
	    // checks if it's a numeric reference (for example &#126;) 		 		
	    if (logic_token[position_logic_token+1] == '#') { // if enetes in this block it's a numeric entity 
	      
	      // increases the position pointer 
	      position_logic_token+=(token_len+1) ; 
	      
	      // checks if the entity reference character is a separator
	      for (i=0, done=0u; ((done==0u) && (i<strlen(attribute_separators))); ++i) 
		
		if (attr[j+1][position_expanded_attribute] == attribute_separators[i])
		  
		  done=1u ; 
	      
	      if ((i<strlen(attribute_separators)) && (result_token > 0)) { // it's a separator and there's a couple attr=result_tokens in the 
		                                                            // buffer: inserts it in the attribute dictionary 
		
		// frees the memory allocated 
		if (NTagNAttr != NULL)
		  
		  free(NTagNAttr) ; 
		
		// allocates the memory needed to contain the couple attr=result_token 
		NTagNAttr = (char *) malloc((strlen(result_token)+strlen(attr[j])+2)*sizeof(char)) ; 
		
		// writes the couple attr=result_token in the memory allocated 
		sprintf(NTagNAttr, "%s%c%s", attr[j], _SepValAttr, result_token) ;
		
		// inserts the physical or escape position of couple attr=result_token in the attributes dictionary 
		if (!physical_correspondence)
		  
		  // there's not correspondence between physical and logical views, inserts the escape position of the
		  // couple and doesn't increase the element rank because all attributes and the tag have the same 
		  // position 
		  hinsert(NTagNAttr, 
			  strlen(NTagNAttr), 
			  ATTR,
			  (char *) NULL,
			  ht, 
			  last_body_position_written,
			  elementRank,
			  ((0x00) | _WRITE_PHYSIC_ESCAPE)) ; 
		
		else
			

		  // there's a correspondence between physical and logical views, inserts the escape position of the
		  // couple and doesn't update the position because all attributes and the tag have the same
		  // position 
		  hinsert(NTagNAttr, 
			  strlen(NTagNAttr), 
			  ATTR,
			  (char *) NULL,
			  ht, 
			  last_body_position_written,
			  0, 
			  ((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ;	      
		
		// put to 0 the attr=result_token buffer
		position_result_token=0 ; 
	      }
		    
	      // checks the logical buffer dimension  
	      if (position_result >= (result_dimension-1)) { 
		
		result=(char *) realloc((char *) result,
					result_dimension+256) ; 
		
		result_dimension+=256 ; 
	      }
		  
	      // copies the character in the logical buffer 
	      result[position_result]=attr[j+1][position_expanded_attribute] ; 
	      
	      result[position_result+1]='\0' ; 
	      
	      // increase pointers 
	      ++position_result ; 
	      
	      ++position_expanded_attribute ; 		    
	    }
	    
	    else { // itsn't a numeric entity reference. It can be an internal or external entity 

	      // frees the memory allocated 
	      if (entity != NULL)
		
		free(entity) ; 
	      
	      // allocates the memory needed to contain the name of the entity 
	      entity=(char *) malloc((token_len+2)*sizeof(char)) ; 
	      
	      // reads the name of the entity and copies it in the memory allocated 
	      for(i=0 ; i<token_len+1; ++i) 
		
		entity[i]=logic_token[position_logic_token+i] ; 
	      
	      entity[i]='\0' ; 
	      
	      // checks if the entity is a separator (this information is in the configuration file) 
	      if (hsearch(entity,
			  strlen(entity),
			  NOTHING, 
			  expat_attribute_separators_table))  {  // if enters here means that the entity is a separator, 
		                                                 // checks if there is a couple attr=result_token in the buffer 
 
		if (position_result_token > 0) { // if enters here the entity is in the list of separator entities
		                                 // and there's a couple attr=result_token in the buffer
		  
		  // fress the memory allocated 
		  if (NTagNAttr != NULL)
		    
		    free(NTagNAttr) ; 

		  // allocates the memory needed to contain the couple attr=result_token 
		  NTagNAttr = (char *) malloc((strlen(attr[j])+strlen(result_token)+2)*sizeof(char)) ;
		  
		  // checks if there's a correspondence between logical and physical views.
		  if (physical_correspondence)
		    
		    // there's a correspondence between logical and physical views. Writes the physical position and
		    // doesn't update it because all attributes and the tag have the same position 
		    hinsert(NTagNAttr, 
			    strlen(NTagNAttr), 
			    ATTR,
			    (char *) NULL,
			    ht, 
			    last_body_position_written,
			    0,
			    ((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ; 
		  
		  else
		    
		    // theresn't a correspondence between logical and physical views. Writes the escape position and
		    // doesn't increase the element rank because all attributes and the tag have the same position 
		    hinsert(NTagNAttr, 
			    strlen(NTagNAttr), 
			    ATTR,
			    (char *) NULL,
			    ht, 
			    last_body_position_written,
			    elementRank,
			    ((0x00) | _WRITE_PHYSIC_ESCAPE)) ; 
		  
		  // put to 0 the attr=result_token buffer pointer 
		  position_result_token=0 ; 
		}
		
		// increases the pointer to the logical buffer 
		position_logic_token+=(token_len+1) ; 
		
		// increases the pointer to the expanded attribute with the length of the associated element 
		if ((search=hsearch(entity,
				    strlen(entity),
				    NOTHING, 
				    expat_general_declared_entity)) != NULL)
		  
		  position_expanded_attribute+=(strlen(search->ass_el)) ;
	      }
	      
	      else
		
		if ((search=hsearch(entity,
				    strlen(entity),
				    NOTHING, 
				    expat_general_declared_entity)) != NULL) { // it's an predefined entity or a general internal declared entity

		  // increases the pointer to the logical buffer
		  position_logic_token+=(token_len+1) ; 
		  
		  // increases the pointer to the expanded attribute with the length of the associated element 
		  position_expanded_attribute+=(strlen(search->ass_el)) ;
		  
		  for(i=0 ; i<strlen(search->ass_el); ++i) {  // checks if any character in the expansion is a separato
		    
		    for(k=0, done=0u ; ((done==0u) && (k<strlen(attribute_separators))); ++k)
		      
		      if (attribute_separators[k] == search->ass_el[i])
			
			done=1u ; 		
		    
		    if ((k<strlen(attribute_separators)) && (position_result_token > 0)) { // the character is a separator and there's a couple attr=result_token 
		                                                                           // in the buffer
		      
		      // frees the memory allocated 
		      if (NTagNAttr != NULL)
			
			free(NTagNAttr) ; 
		      
		      // allocates the memory needed for the couple attr=result_token 
		      NTagNAttr = (char *) malloc((strlen(attr[j])+strlen(result_token)+2)) ; 
		    
		      // writes the value of the couple attr=result_token in the memory   
		      sprintf(NTagNAttr, "%s%c%s", attr[j], _SepValAttr, result_token) ;
		      
		      // checks if there's correspondence between logical and physical views. 
		      if (physical_correspondence)
			
			// there's correspondence between logical and physical views. Inserts the physical position
			// and doesn't update it because all attributes and the tag have the same position 
			hinsert(NTagNAttr, 
				strlen(NTagNAttr), 
				ATTR,
				(char *) NULL,
				ht, 
				last_body_position_written,
				0,
				((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ; 
		      
		      else
			
			// theresn't correspondence between logical and physical views. Inserts the escape position
			// and doesn't increase the element rank because all attributes and the tag have the same
			// rank 
			hinsert(NTagNAttr, 
				strlen(NTagNAttr), 
				ATTR,
				(char *) NULL,
				ht, 
				last_body_position_written,
				elementRank,
				((0x00) | _WRITE_PHYSIC_ESCAPE)) ; 
		      
		      // put to 0 the pointer to the attr=result_token buffer 
		      position_result_token=0 ; 
		    }
			  
		    else if (k>= strlen(attribute_separators)) { // the character, that is in an internal or predefined entity expantion, is not 
		                                                 // a separator. It must be copied to buffers  

		      // checks the dimension of the attr=result_token buffer 
		      if (position_result_token >= (result_token_dimension-1)) { 
			
			result_token=(char *) realloc((char *) result_token,
						      result_token_dimension+256) ; 
			
			result_token_dimension+=256 ; 
		      }
			
		      // copies the character to the attr=result_token buffer
		      result_token[position_result_token]=search->ass_el[i] ; 
			
		      result_token[position_result_token+1]='\0' ; 

		      // increases the position to the attr=result_token buffer
		      ++position_result_token ; 
		    }

		    // checks the logic buffer dimension
		    if (position_result >= (result_dimension-1)) { 
		      
		      result = (char *) realloc((char *) result,
						result_dimension+256) ;
		      
		      result_dimension+=256 ;
		    }
		    
		    // copies the character to the logic buffer
		    result[position_result]=search->ass_el[i] ; 
		    
		    result[position_result+1]='\0' ; 
		    
		    // increases the logic buffer pointer 
		    ++position_result ;
		  }
		}
	      
		else
		  
		  // it's an external entity reference
		  
		  { for (i=0 ; i<token_len+1; ++i) { // it's an external entity reference. It's not expanded but its name is written to the
						     // logical and attr=result_token buffer
			
		    // checks the attr=result_token buffer dimension 
		    if ((position_result_token+i) >= (result_token_dimension-1)) { 
		      
		      result_token= (char *) realloc((char *) result_token,
						     result_token_dimension+256) ; 
		      
		      result_token_dimension+=256 ; 
		    }
		    
		    // copies the character to the attr=result_token buffer dimension  
		    result_token[position_result_token+i]=logic_token[position_logic_token+i] ; 
		    
		    // checks the logical buffer dimension 
		    if ((position_result+i) >= (result_dimension-1)) { 
		      
		      result=(char *) realloc((char *) result,
					      result_dimension+256) ; 
		      
		      result_dimension+=256 ;
		    }
		    
		    // copies the character to the logical token buffer dimension  
		    result[position_result+i]=logic_token[position_logic_token+i] ;
		  }
		  
		  result[position_result+i]='\0' ; 
		  
		  result_token[position_result_token+i]='\0' ; 

		  // increases buffers pointers 
		  position_result_token+=(token_len+1) ; 
		  
		  position_result+=(token_len+1) ; 
		  
		  position_logic_token+=(token_len+1) ; 
		  }
	    }
	  }
      
      // it's at the end of the attributes and may be that a couple attr=result_tokens is in the buffer
      
      if (position_result_token > 0) { // if enters the block there's a couple attr=result_token in the buffer  
	
	// frees the memory allocated 
	if (NTagNAttr != NULL)
	  
	  free(NTagNAttr) ;
	
	// allocates the memory needed to contain the couple attr=result_token 
	NTagNAttr=(char *) malloc((strlen(attr[j])+strlen(result_token)+2)*sizeof(char)) ; 
	
	// writes the couple attr=result_token to the memory allocated 
	sprintf(NTagNAttr, "%s%c%s", attr[j], _SepValAttr, result_token) ;
	
	// checks if there's correspondence between logical and physical views
	if (physical_correspondence)
	  
	  // there's a correspondence between physical and logical views. Writes the physical position 
	  // and doesn't update the position because all attributes and the tag have the same position  
	  hinsert(NTagNAttr, 
		  strlen(NTagNAttr), 
		  ATTR,
		  (char *) NULL,
		  ht, 
		  last_body_position_written,
		  0,
		  ((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ; 
	
	else

	  // thersn't correspondence between physical and logical views. Writes the escape position
	  // and doesn't updata the element rank because all attributes and the tag have the same
	  // rank 
	  hinsert(NTagNAttr, 
		  strlen(NTagNAttr), 
		  ATTR,
		  (char *) NULL,
		  ht, 
		  last_body_position_written,
		  elementRank,
		  ((0x00) | _WRITE_PHYSIC_ESCAPE)) ; 
	
	// put to 0 the pointer to the attr=result_token buffer
	position_result_token=0 ; 
      }

      // now it must insert in the attributes dictionary the position of the logical token 
      // attr=token_value and its physical correspondence

      // frees the memory allocated
      if (NTagNAttr != NULL) 
	
	free(NTagNAttr) ; 
      
      // allocates the memory needed to contain the couple attr=token_value 
      NTagNAttr = (char *) malloc((strlen(attr[j])+strlen(result)+4)*sizeof(char)) ; 

      // writes the attr=separator-logic value-separator couple in the memory allocated
      sprintf(NTagNAttr, "%s%c%c%s%c", attr[j], _SepValAttr, delimiter, result, delimiter) ;
      
      // checks if there's correspondence between logical and physical views 
      if (physical_correspondence)
	
	// there's a correspondence between logical and physical views. 
	// Writes the physical position of the attr=token_value in 
	// the attributes dictionary. Doesn't update the position because all attributes
	// and the tag have the same position 
	hinsert(NTagNAttr, 
		strlen(NTagNAttr), 
		ATTR,
		(char *) NULL,
		ht, 
		last_body_position_written,
		0,
		((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ; 
      
      else
	
	// theresn't a correspondence between logical and physical views. Writes the escape position
	// of the attr=token_value in the attributes dictionary. Doesn't update the element rank because
	// all attributes and the tag have the same rank
	hinsert(NTagNAttr, 
		strlen(NTagNAttr), 
		ATTR,
		(char *) NULL,
		ht, 
		last_body_position_written,
		elementRank,
		((0x00) | _WRITE_PHYSIC_ESCAPE)) ; 
      
      // reads the physical value of the attribute 
      token_len1=get_next_token(xml_code+xml_position,
				(delimiter == _DoppiApici) ? "\"" : "\'", 
				&separator, 
				xml_dimension-xml_position) ;
      
      token_len2=get_next_token(xml_code+xml_position+token_len1+1, 
				(delimiter == _DoppiApici) ? "\"" : "\'", 
				&separator, 
				xml_dimension-(xml_position+token_len1+1)) ; 
      
      token_len = token_len1 + token_len2 + 2 ; 
      
      
      if ((physical_correspondence) && (strncmp(xml_code+xml_position, 
						NTagNAttr, 
						token_len) != 0)) { // theres't correspondence beetween the logical and physical view,
	                                                            // for example because there's an attribute in the value, so 
	                                                            // inserts the physical view in the attributes dictionary 
	
	// frees the memory allocated 
	if (NTagNAttr)
	  
	  free(NTagNAttr) ; 
	
	// allocates the memory for the physical view 
	NTagNAttr = (char *) malloc((token_len+1)*sizeof(char)) ; 
	
	// copies the physical view in the memory allocated
	strncpy((char *) NTagNAttr, 
		xml_code+xml_position, 
		token_len) ; 
	
	NTagNAttr[token_len] = '\0' ; 
      }
      
      if (physical_correspondence) { // computes the lenght of the codeword associated to the physical attributes 
	
	nooutput_token(NTagNAttr, 
		       strlen(NTagNAttr), 
		       ATTR) ;
	
      }
      
      // increases the logical position 
      xml_position+=token_len ; 
      
      do { // reads the separator character until the end of the tag or the next attribute

	num_seps=0;
	
	while (((token_len=get_next_token(xml_code+xml_position, 
					  " />\t\n", 
					  &separator, 
					  xml_dimension-xml_position)) == 0)
	       
	       && (num_seps < XCDE_MAX_SEPARATORS_BLOCK)) { 
	
	  ++xml_position ; 
	  
	  seps[num_seps]=separator; 
	
	  ++num_seps ; 
	
	  if (separator =='/') // in this case it's an empty flag  
	    
	    empty_tag_flag=1u; 
	
	  if (separator =='>') // in this case it's reached the end of the tag

	    break ; 
	}
	
	seps[num_seps]='\0' ; 
      
	if ((empty_tag_flag) && (separator == '>')) { // in this case it's an empty flag 
	
	  // chacks if there's a correspondence between logical and physical views 
	  if (physical_correspondence) { // if enters in this block there's a correspondence between
	                                 // the physical and logical view  

	    // update the body position, because the closing position is that of the '>' character
	    last_body_position_written=body_size_without_zlib ; 
	    
	    // inserts the physical position of the character '>' that's the closing position, 
	    // because the tag is empty 
	    hinsert((char *) token,
		    strlen(token),
		    TAG,
		    (char *) NULL, 
		    ht, 
		    last_body_position_written,
		    0,
		    ((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ;
	  }
	  
	  else
	    
	    { // if enters this block theresn't correspondence between logical and physical
	      // views. 

	      // inserts the escape position of the couple in the attributes dictionary. Increases the element
	      // rank because it's the closing position 
	      hinsert((char *) token,
		      strlen(token),
		      TAG,
		      (char *) NULL, 
		      ht, 
		      last_body_position_written,
		      elementRank,
		      ((0x00) | _WRITE_PHYSIC_ESCAPE)) ; 
	    
	      // increases the element rank because it's the closing position. There're not more attributes
	      ++elementRank ; 
	    }
	  
	  // it's an empty tag. It must be closed 
	  number_this_tag_opened=hclosetag(tagposition) ;
	  
	  if ((!recursivetag_flag) && (number_this_tag_opened > 0)) { 

	    fprintf(stderr, "\nFatal Error : at raw %d.the tag %s has not been opened, and so can't be closed\n\tError code 51\n", 
		    XML_GetCurrentLineNumber(parser),
		    el) ; 
	    
	    for(k=0 ; ((k<XCDE_EXPAT_PARSING_BUFFER_SIZE) && (k<100)) ; ++k)
	
	      fprintf(stderr, "%c", expat_parsing_buffer[XML_GetCurrentByteIndex(parser)+k]) ; 
	    
	    fprintf(stderr, " ... \n") ; 
	    
	    fflush(stderr) ;
	    
	    DELETE_FILES ;
	    
	    exit(-1) ; 
	  }
	}
      
	// checks if there's physical correspondence between logical and physical view
	if (physical_correspondence) { // there's physical correspondence. Computes separators codeword length and 
	                               // adds it to the body position 

	  nooutput_token(seps, 
			 strlen(seps), 
			 WORD) ; 
	  
      }
      } while ((separator !='>') && (token_len==0)) ;
    }
  
  // it's has analyzed all attributes or there're no attributes
  
  // updates the body physical position 
  last_body_position_written=body_size_without_zlib ;
  
  // frees allocated memory 
  if (token != NULL)
    
    free(token) ;

  if (result != NULL)

    free(result) ; 

  if (result_token != NULL)
    
    free(result_token) ; 

  if (NTagNAttr != NULL)

    free(NTagNAttr) ; 

  if (entity != NULL)

    free(entity) ; 

  if (logic_token != NULL)
    
    free(logic_token) ; 
  
  return ; 
}
/*******************************************************************
		          tag end handlers
*******************************************************************/

void end(void *data,
	 const char *el)
{ register
    int k=0 ; 

 char *token=NULL ; 

 int number_this_tag_opened=0 ; 

 int token_len=0 ; 

 int buffer_length=0 ; 
 
 char *entity=NULL ;  
 
 int entity_len=0 ; 
 
 char seps[XCDE_MAX_SEPARATORS_BLOCK+1] ; 
 
 int num_seps=0 ; 

 unsigned 
   char physic_flag=0u ; 
 
 char separator ; 

 Hashptr tagposition=NULL ;

 // ..   
 // ..   end - CHECKS IF IS AN END ASSOCIATED WITH AN EMPTY
 // ..   TAG FLAG. IN THIS CASE THE FUNCTION ENDS 
 // ..

 if (empty_tag_flag) {

   empty_tag_flag=0 ; 

   return ; 
 }
 
 // ..
 // ..   
 // ..   end - ANALYZES THE TEXTBUFFER
 // ..
 // ..

 // checks if there's a token in the buffer 
 // and reads it 
 if (text_in_buffer(&textbuffer)) { 

   buffer_length=get_buffer_length(&textbuffer) ; 
   
   token = (char *) malloc((buffer_length+1)*sizeof(char)) ; 
   
   buffer_length=get_text_in_buffer(&textbuffer, 
				    token) ; 
   
   token[buffer_length]='\0' ; 
   
   undercase(token, 
	     buffer_length) ; 
   
   // checks if the proximity of the token in the buffer must be computed 
   if (proximity_flag) { // if enters the blocks the proximity must be computed 

     // inserts the token in the buffer in the word dictionary with its proximity
     // and increases the proximity counter 
     number_tokens+=hinsert((char *) token, 
			    buffer_length,
			    WORD,
			    (char *) NULL, 
			    ht, 
			    proximity_counter, 
			    0, 
			    ((0x00) | _INSERT_LOGICAL_OCCURRENCE)) ;  
   
     // increases the proximity counter 
     ++proximity_counter ; 
   }

   else
     
     // the proximity must not be computed. It inserts the token in the 
     // word dictionary 
     number_tokens+=hinsert((char *) token, 
			    buffer_length,
			    WORD,
			    (char *) NULL, 
			    ht, 
			    0, 
			    0, 
			    (0x00)) ;
   }

 // ..
 // ..   
 // ..   end - DECREASES THE NUMBER OF TAG OPENED 
 // ..   AND CHECKS IF THE TAG CLOSENING IS IN AN 
 // ..   ENTITY EXPANTION 
 // .. 

 // decreases the number of tag opened 
 --expat_number_tag_opened ; 
 
 // checks if the end tag it's in an internal entity expantion 
 physic_flag=phy_corr(&entity,
		      &entity_len,
		      1) ;

 // ..   
 // ..   end - CHECKS IF IT'S IN A </TAG> SITUATION OR 
 // ..   IN A <TAG1 /></TAG2> SITUATION 
 // .. 

 // checks if it's in the </CLOSE_TAG> case or
 // it's an empty tag 
 if ((xml_code[xml_position] == '<') && 
     (xml_code[xml_position+1] == '/'))  { // if enters the block the first two character are '<' and '/'. It may be the
                                           // tag closing, but also the closure of another tag that follows an empry tag. 
                                           // It reads the tag name to know in which situation is 

   // reads the closing tag name 
   token_len=get_next_token(xml_code+xml_position, 
			    " \t\n>",
			    &separator, 
			    xml_dimension-xml_position
			    ) ; 
   
   
   if (token_len > 0) {

     // frees the memory eventually allocated to contain the token in the
     // textbuffer
     if (token != NULL) 
       
       free(token) ; 
     
     // allocates the memory needed to contain the tag name 
     token = (char *) malloc((token_len+1)*sizeof(char)) ; 
     
     // copies the tag name to the memory allocated 
     for (k=0; k<token_len-2; ++k) 
       
       token[k] = xml_code[xml_position+k+2] ; 
     
     token[k] = '\0' ; 
   }
   
   // checks if tag name is egual to the token found. In this case it's in a 
   // </closing_tag> situation 
   if (strcmp(el, 
	      token) == 0) { 

     // there's correspondence between logical and physical views 
     if (physic_flag) { 

       if (verbosing_flag)
	 
	 fprintf(debugPhysicView, "</%s", el) ; 
       
       // inserts the character '<' in the word dictionary 
       number_tokens+=hinsert((char *) "<",
			      1, 
			      WORD,
			      (char *) NULL, 
			      ht, 
			      0, 
			      0, 
			      ((0x00) | _INCREASE_PHYSICAL_COUNT)) ; 
       
       // inserts the character '/' in the word dictionary 
       number_tokens+=hinsert((char *) "/",
			      1, 
			      WORD,
			      (char *) NULL, 
			      ht, 
			      0, 
			      0, 
			      ((0x00) | _INCREASE_PHYSICAL_COUNT)) ; 
       
       // inserts the tagname in the tag dictionary 
       number_tokens+=hinsert((char *) el, 
			       strlen(el),
			      TAG,
			      (char *) NULL, 
			      ht, 
			      0,
			      0, 
			      ((0x00) | _INCREASE_PHYSICAL_COUNT)) ; 
     }

     // increases the position 
     xml_position+=token_len ; 
   }

   // there's not correspondence between the name of the closing tag physical
   // and the logical name. It's in a <CLOSING_TAG1/></CLOSING_TAG2> situation,
   // and the logical name is TAG1. The function ends.
   else goto end_pos;
   
   // ..   
   // ..   end - ANALYZES SEPARATORS 
   // .. 

   do { num_seps=0 ; 
     
     do { 
       // copies a separator character in the separators buffer
       seps[num_seps]=separator; 
       
       // increases the number of separators
       ++num_seps ; 
       
       // increases position 
       xml_position+=1 ; 
       
     } while ((separator!='>') 
	      && 
	      (num_seps < XCDE_MAX_SEPARATORS_BLOCK) && 
	      ((token_len=get_next_token(xml_code+xml_position, 
					 " \t\n>",
					 &separator, 
					 xml_dimension-xml_position)==0))) ; 
     
     seps[num_seps]='\0' ; 
     
     // if there's a correspondence between physical and logical views
     // and there're separator in the buffer inserts its in the words dictionary 
     if ((physic_flag) && (num_seps > 0)) { 

       if (verbosing_flag)
	 
	 fprintf(debugPhysicView, "%s", seps) ;
       
       number_tokens+=hinsert((char *) seps, 
			      strlen(seps),
			      WORD,
			      (char *) NULL, 
			      ht, 
			      0,
			      0, 
			      ((0x00) | _INCREASE_PHYSICAL_COUNT)) ; 
     }
   } while (separator != '>') ; 
 }

 // it's in a <CLOSING_TAG /> situation. The function ends
 else goto end_pos ;

 // ..   
 // ..   end - CHECKS IF THE TAG IS RECURSIVE 
 // .. 
 
 // find the tagposition and sets the tag open flag to on
 if ((tagposition=hsearch((char *) el,
			   strlen(el), 
			   TAG, 
			   ht)) == NULL) { 

    fprintf(stderr, "\nFatal Error: at raw %d.Tag %s not found in the hash table\n\tError code 52\n", 
	    XML_GetCurrentLineNumber(parser), 
	    el) ;

    for(k=0 ; ((k<XCDE_EXPAT_PARSING_BUFFER_SIZE) && (k<100)) ; ++k)
     
     fprintf(stderr, "%c", expat_parsing_buffer[XML_GetCurrentByteIndex(parser)+k]) ; 
   
   fprintf(stderr, " ... \n") ; 
   
   fflush(stderr) ; 

   DELETE_FILES ;
   
   exit(-1) ;
 }

 // closes the tag 
 number_this_tag_opened=hclosetag(tagposition) ;
 
 // checks if the tag is recursive and that is not allowed
 if ((!recursivetag_flag) && (number_this_tag_opened > 0)) { // if enters the block the tag is recursive and that is not allowed 

   fprintf(stderr, "\nFatal Error : at raw %d.the tag %s has not been opened, and so can't be closed\n\tError code 53\n", 
	   XML_GetCurrentLineNumber(parser),
	   el) ; 
   
   for(k=0 ; ((k<XCDE_EXPAT_PARSING_BUFFER_SIZE) && (k<100)) ; ++k)
     
     fprintf(stderr, "%c", expat_parsing_buffer[XML_GetCurrentByteIndex(parser)+k]) ; 
   
   fprintf(stderr, " ... \n") ; 
   
   fflush(stderr) ;
   
   DELETE_FILES ;
   
   exit(-1) ; 
 }

 end_pos : 

  // frees the memory allocated 
 if (token != NULL)
   
   free(token) ; 
 
 if (entity != NULL) 
   
   free(entity) ; 
 
 return ; 
}

void endcod(void *data,
	    const char *el)
{ // variable used as counter
  register
    int k=0 ; 
  
  char *token=NULL ; 
  
  char *recursive_logic_tag=0 ; 

  int recursive_logic_tag_size=0 ; 

  int buffer_length=0 ; 
  
  char *entity=NULL ; 

  int entity_len=0 ; 

  int token_len=0 ; 
  
  char separator ;

  char seps[XCDE_MAX_SEPARATORS_BLOCK+1] ; 

  int num_seps=0 ;

  int number_this_tag_opened=0 ; 
  
  Hashptr tagposition=NULL ; 

  // ..   
  // ..   endcod - CHECKS IF IS AN END ASSOCIATED WITH AN EMPTY
  // ..   TAG FLAG. IN THIS CASE THE FUNCTION ENDS 
  // ..
  
  if (empty_tag_flag) {
    
    empty_tag_flag=0 ; 
    
    return ; 
  }

  // ..
  // ..   
  // ..   endcod - ANALYZES THE TEXTBUFFER
  // ..
  // ..

  // checks if there is a token in the buffer
  if (text_in_buffer(&textbuffer)) { 

    buffer_length=get_buffer_length(&textbuffer) ; 
    
    token=(char *) malloc((buffer_length+1)*sizeof(char)) ; 
    
    buffer_length=get_text_in_buffer(&textbuffer, 
				     token) ; 
    
    token[buffer_length]='\0' ; 
    
    undercase(token, 
	      buffer_length) ; 
    
    if (!physical_correspondence) { 

      hinsert((char *) token, 
	      strlen(token),
	      WORD,
	      (char *) NULL, 
	      ht, 
	      last_body_position_written,
	      elementRank, 
	      ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
      
      ++elementRank ; 
    }
    
    else
      
      hinsert((char *) token, 
	      strlen(token), 
	      WORD,
	      (char *) NULL, 
	      ht, 
	      last_body_position_written,
	      0, 
	      ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
  }

  // ..
  // ..   
  // ..   endcod - DECREASES THE NUMBER OF TAG OPENED 
  // ..   AND CHECKS IF THE TAG CLOSENING IS IN AN 
  // ..   ENTITY EXPANTION 
  // .. 

  // decreases the number of tags opened
  --expat_number_tag_opened ; 

  // if the token in the buffer wasn't the result of an entity expantion updates the
  // physical position 
  if (physical_correspondence)
    
    last_body_position_written=body_size_without_zlib ; 
  
  // memorizes the last physical correspondence 
  last_physical_correspondence=physical_correspondence ; 

  // checks if the end tag is in an internal entity expantion. 
  physical_correspondence=phy_corr(&entity,
				   &entity_len,
				   0) ; 
  
  // if the closing tag is in an internal entity expantion, and it's a new
  // entity expantion, initializes the element rank counter 
  if ((!physical_correspondence) && (changed_position))
    
    elementRank=1 ; 

  // ..   
  // ..   endcod - CHECKS IF IT'S IN A </TAG> SITUATION OR 
  // ..   IN A <TAG1 /></TAG2> SITUATION 
  // .. 
  
  // checks if it's int the </CLOSE_TAG> case
  if ((xml_code[xml_position] == '<') && (xml_code[xml_position+1] == '/')) { // if enters the block the first two character are '<' and '/'. It may be the
                                                                              // tag closing, but also the closure of another tag that follows an empry tag. 
                                                                              // It reads the tag name to know in which situation is 

    // reads the closing tag name 
    token_len=get_next_token(xml_code+xml_position, 
			     " \t\n>",
			     &separator, 
			     xml_dimension-xml_position
			     ) ; 
    
    if (token_len > 0) { 
      
      // frees the memory eventually allocated to contain the token in the
      // textbuffer
      if (token != NULL)
	
	free(token) ; 
      
      // allocates the memory needed to contain the closing tag name 
      token = (char *) malloc(token_len*sizeof(char)) ; 
      
      // copies the tag name to the memory allocated
      for (k=0; k<token_len-2; ++k) 
	
	token[k] = xml_code[xml_position+k+2] ; 
      
      token[k] = '\0' ;

      // checks if tag name is egual to the token found. In this case it's in a 
      // </closing_tag> situation  
      if (strcmp(el, 
		 token)== 0) { // if enters this block it's in a </closing_tag> situation  
	
	if (physical_correspondence) { // if enters in this block there's a 
	                               // correspondence between logical and physical views
	  
	  // writes the character '<' to the body file 
	  output_token("<", 
		       strlen("<"), 
		       WORD) ;
	  
	  // writes the closing tag character '/' to the body file 
	  output_token("/", 
		       strlen("/"), 
		       WORD) ;

	  // writes the tag name to the body file 
	  output_token((char *) el, 
		       strlen(el), 
		       TAG) ; 

	  // updates the body position 
	  last_body_position_written=body_size_without_zlib ; 
	}

	// increases the logical position of the body 
	xml_position+=token_len ; 
      }
	
      // there's not correspondence between the name of the closing tag physical
      // and the logical name. It's in a <CLOSING_TAG1/></CLOSING_TAG2> situation,
      // and the logical name is TAG1. The function ends.
      else goto end_pos; 
    }

    // it's the case <OPEN_CLOSING_TAG />. The function ends     
    else goto end_pos ; 

    // ..   
    // ..   endcod - CHECKS IF THE TAG IS RECURSIVE 
    // .. 

    // find the tagposition and sets the tag open flag to on
    if ((tagposition=hsearch((char *) el,
			     strlen(el), 
			     TAG, 
			     ht)) == NULL) { 

      fprintf(stderr, "\nFatal Error: at raw %d.Tag %s not found in the hash table\n\tError code 54\n", XML_GetCurrentLineNumber(parser), el) ;
      
      for(k=0 ; ((k<XCDE_EXPAT_PARSING_BUFFER_SIZE) && (k<100)) ; ++k)
	
	fprintf(stderr, "%c", expat_parsing_buffer[XML_GetCurrentByteIndex(parser)+k]) ; 
      
      fprintf(stderr, " ... \n") ; 
      
      fflush(stderr) ; 
      
      DELETE_FILES ;
      
      exit(-1) ;
    }
    
    // closes the tag 
    number_this_tag_opened=hclosetag(tagposition) ;
    
    // checks if the tag is recursive and that's allowed by the user 
    if ((!recursivetag_flag) && (number_this_tag_opened > 0)) { // if enters this block the tag is recursive and that is not allowed 

      fprintf(stderr, "\nFatal Error : at raw %d.the tag %s has not been opened, and so can't be closed\n\tError code 55\n", XML_GetCurrentLineNumber(parser),el) ; 
      
      for(k=0 ; ((k<XCDE_EXPAT_PARSING_BUFFER_SIZE) && (k<100)) ; ++k)
	
	fprintf(stderr, "%c", expat_parsing_buffer[XML_GetCurrentByteIndex(parser)+k]) ; 
      
      fprintf(stderr, " ... \n") ; 
      
      fflush(stderr) ;
      
      DELETE_FILES ;
      
      exit(-1) ; 
    }
    
    else
      
      if (number_this_tag_opened > 0) { // if enters this block the tag is recursive and 
	                                // this is allowed, so creates the virtual closing tag 

	// computes the number of prefixes 'xml_' in the virtual tag 
	recursive_logic_tag_size=((number_this_tag_opened)*strlen(XCDE_RECURSIVE_TAG_PREFIX)+strlen(el)) ; 
	
	// allocates the memory needed for the recursive logic tag 
	recursive_logic_tag=(char *) malloc((recursive_logic_tag_size+1)*sizeof(char)) ; 
	
	recursive_logic_tag[0]='\0' ; 
	
	// creates the virtual tag 
	for(k=0 ; k<(number_this_tag_opened) ; ++k)
	  
	  strcat(recursive_logic_tag, "xml_") ; 
	
	strcat(recursive_logic_tag, el) ; 
	
	token=recursive_logic_tag ; 
      }

      else // in this case tha tag isn't recursive
	
	token=(char *) el ; 
    
    // ..   
    // ..   endcod - ANALYZES SEPARATORS 
    // .. 
    
    do { num_seps=0 ; 
    
    do {
    
      // copies the separator character in the separators buffer
      seps[num_seps]=separator ; 
      
      // increases the number of separators in the buffer
      ++num_seps ; 
      
      // increases position 
      ++xml_position ; 
      
    } while ((separator != '>') 
	     && 
	     (num_seps < XCDE_MAX_SEPARATORS_BLOCK) && 
	     (token_len=get_next_token(xml_code+xml_position, 
				       " \t\n>",
				       &separator, 
				       xml_dimension-xml_position)==0)) ; 
    
    seps[num_seps]='\0' ; 
    
    // checks if there's correspondence between logical and physical views 
    if (physical_correspondence) { 
      
      if (separator == '>')
	
	// in this case there's correspondence between logical and physical views,
	// so it inserts the physical position of the closing tag 
	hinsert((char *) token,
		strlen(token),
		TAG,
		(char *) NULL, 
		ht, 
		last_body_position_written,
		0, 
		((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 	
      
      // writes separators in the body file 
      output_token(seps, 
		   strlen(seps), 
		   WORD) ;

      // updates the body physical position 
      last_body_position_written=body_size_without_zlib ; 
    }

    else 

      if (separator == '<') { // theresn't correspondence between logical and physical views. So inserts 
	                      // the escape position of the closing tag and increases the element rank 
	hinsert((char *) token,
		strlen(token),
		TAG,
		(char *) NULL, 
		ht, 
		last_body_position_written,
		elementRank,
		((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
	
	// increases the element rank 
	++elementRank ; 
      }
    } while ((token_len==0) && (separator != '>')) ; 
  }
  
  // the function has done all operations or it's in a <CLOSING_TAG /> situation. It ends. 
  end_pos : 
    
    if ((token != NULL) && (token != el))
      
      free(token) ; 
  
  if (entity != NULL) 
    
    free(entity) ; 
  
  return;
}

void endwrite(void *data,
	      const char *el)
{ // variable used as counter
  register
    int k=0 ; 
  
  char *token=NULL ; 

  char *recursive_logic_tag=0 ; 

  int recursive_logic_tag_size=0 ; 

  int buffer_length=0 ; 
  
  char *entity=NULL ; 

  int entity_len=0 ; 

  int token_len=0 ; 
  
  char separator ;

  char seps[XCDE_MAX_SEPARATORS_BLOCK+1] ; 

  int num_seps=0 ;

  int number_this_tag_opened=0 ; 
  
  Hashptr tagposition=NULL ; 

  // ..   
  // ..   endwrite - CHECKS IF IS AN END ASSOCIATED WITH AN EMPTY
  // ..   TAG FLAG. IN THIS CASE THE FUNCTION ENDS 
  // ..
  
  if (empty_tag_flag) {
    
    empty_tag_flag=0 ; 
    
    return ; 
  }
  
  // ..
  // ..   
  // ..   endwrite - ANALYZES THE TEXTBUFFER
  // ..
  // ..

  // checks if there is a token in the buffer
  if (text_in_buffer(&textbuffer)) { 

    buffer_length=get_buffer_length(&textbuffer) ; 
    
    token=(char *) malloc((buffer_length+1)*sizeof(char)) ; 
    
    buffer_length=get_text_in_buffer(&textbuffer, 
				     token) ; 
    
    token[buffer_length]='\0' ; 
    
    undercase(token, 
	      buffer_length) ; 
    
    // checks if the proximity of the token must be computed
    if (proximity_flag) { // if enters this block the proximity must be computed 

      // writes the proximity of the token in the IL files and increases the
      // proximity counter 
      hinsert((char *) token, 
	      buffer_length, 
	      WORD, 
	      (char *) NULL, 
	      ht, 
	      proximity_counter,
	      0,
	      ((0x00) | _WRITE_LOGICAL_OCCURRENCE)) ;  
      
      // increases the proximity counter 
      ++proximity_counter ;     
    }
      
    // checks if there's physical correspondence beetween logical and physical views
    if (!physical_correspondence) { 
     
      // theresn't physical correspondence between logical and physical views. So writes
      // the escape position in the IL file and increases the rank of the element 
      hinsert((char *) token, 
	      strlen(token),
	      WORD,
	      (char *) NULL, 
	      ht, 
	      last_body_position_written,
	      elementRank, 
	      ((0x00) | _WRITE_PHYSIC_ESCAPE)) ; 
      
      // increases the rank of the element 
      ++elementRank ; 
    }
    
    else
      
      // there's physical correspondence between the logical and physical views, so writes
      // the physical position in the IL file 
      hinsert((char *) token, 
	      strlen(token), 
	      WORD,
	      (char *) NULL, 
	      ht, 
	      last_body_position_written,
	      0, 
	      ((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ; 
  
  }

  // ..
  // ..   
  // ..   endwrite - DECREASES THE NUMBER OF TAG OPENED 
  // ..   AND CHECKS IF THE TAG CLOSENING IS IN AN 
  // ..   ENTITY EXPANTION 
  // .. 
  
  // decreases the number of tags opened
  --expat_number_tag_opened ; 

  // if the token in the buffer wasn't the result of an entity expantion updates the
  // physical position 
  if (physical_correspondence)
    
    last_body_position_written=body_size_without_zlib ; 
  
  // memorizes the last physical correspondence 
  last_physical_correspondence=physical_correspondence ; 
  
  // checks if the closing tag is in an internal entity expantion 
  physical_correspondence=phy_corr(&entity,
				   &entity_len,
				   2) ; 
  
  // if the closing tag is in an internal entity expantion, and it's a new
  // entity expantion, initializes the element rank counter 
  if ((!physical_correspondence) && (changed_position))
    
    elementRank=1 ; 

  // ..   
  // ..   endwrite - CHECKS IF IT'S IN A </TAG> SITUATION OR 
  // ..   IN A <TAG1 /></TAG2> SITUATION 
  // .. 
  
  // checks if it's int the </CLOSE_TAG> case
  if ((xml_code[xml_position] == '<') && (xml_code[xml_position+1] == '/')) { // if enters the block the first two character are '<' and '/'. It may be the
                                                                              // tag closing, but also the closure of another tag that follows an empry tag. 
                                                                              // It reads the tag name to know in which situation is 

    // reads the closing tag name 
    token_len=get_next_token(xml_code+xml_position, 
			     " \t\n>",
			     &separator, 
			     xml_dimension-xml_position
			     ) ; 
    
    if (token_len > 0) {

      // frees the memory eventually allocated to contain the token in the
      // textbuffer
      if (token != NULL)
	
	free(token) ; 
      
      // allocates the memory needed to contain the closing tag name 
      token = (char *) malloc(token_len*sizeof(char)) ; 
      
      // copies the tag name in the memory allocated 
      for (k=0; k<token_len-2; ++k) 
	
	token[k] = xml_code[xml_position+k+2] ; 
      
      token[k] = '\0' ;
      
      // checks if tag name is egual to the token found. In this case it's in a 
      // </closing_tag> situation  
      if (strcmp(el, 
		 token)== 0) { // if 

	if (physical_correspondence) { // if enters in this block there's a 
	                               // correspondence between logical and physical views,
	                               // so finds codewords lengths and updates the physical 
	                               // position to compute the closing tag position, that is
	                               // the position of the character '>' 
	  
	  // computes the codeword length of the character '<'
	  nooutput_token("<", 
			 strlen("<"), 
			 WORD) ;
	  
	  // computes the codeword length of the character '/'
	  nooutput_token("/", 
			 strlen("/"), 
			 WORD) ;
	  
	  // computes the codeword length of the tag name 
	  nooutput_token((char *) el, 
			 strlen(el), 
			 TAG) ; 
	  
	  // updates the physical position 
	  last_body_position_written=body_size_without_zlib ; 
	}
	
	// increases the position 
	xml_position+=token_len ; 
      }

      // there's not correspondence between the name of the closing tag physical
      // and the logical name. It's in a <CLOSING_TAG1/></CLOSING_TAG2> situation,
      // and the logical name is TAG1. The function ends.
      else goto end_pos; 
    }
    
    // it's the case <OPEN_CLOSING_TAG />. The function ends   
    else goto end_pos ; 
    
    // ..   
    // ..   endwrite - CHECKS IF THE TAG IS RECURSIVE 
    // .. 
    
    // find the tagposition and sets the tag open flag to on
    if ((tagposition=hsearch((char *) el,
			     strlen(el), 
			     TAG, 
			     ht)) == NULL) { 

      fprintf(stderr, "\nFatal Error: at raw %d.Tag %s not found in the hash table\n\tError code 56\n", 
	      XML_GetCurrentLineNumber(parser), 
	      el) ;
      
      for(k=0 ; ((k<XCDE_EXPAT_PARSING_BUFFER_SIZE) && (k<100)) ; ++k)
	
	fprintf(stderr, "%c", expat_parsing_buffer[XML_GetCurrentByteIndex(parser)+k]) ; 
      
      fprintf(stderr, " ... \n") ; 
      
      fflush(stderr) ; 
      
      DELETE_FILES ;
      
      exit(-1) ;
    }
    
    // closes the tag 
    number_this_tag_opened=hclosetag(tagposition) ;
    
    // checks if the tag is recursive and that's allowed by the user 
    if ((!recursivetag_flag) && (number_this_tag_opened > 0)) { // if enters this block the tag is recursive and that is allowed 

      fprintf(stderr, "\nFatal Error : at raw %d.the tag %s has not been opened, and so can't be closed\n\Error code 57\n", 
	      XML_GetCurrentLineNumber(parser),
	      el) ; 
      
      for(k=0 ; ((k<XCDE_EXPAT_PARSING_BUFFER_SIZE) && (k<100)) ; ++k)
	
	fprintf(stderr, "%c", expat_parsing_buffer[XML_GetCurrentByteIndex(parser)+k]) ; 
      
      fprintf(stderr, " ... \n") ; 
      
      fflush(stderr) ;
      
      DELETE_FILES ;
      
      exit(-1) ; 
    } 
    
    else
      
      if (number_this_tag_opened > 0) { // if enters this block the tag is recursive and 
	                                // that is allowed, so creates the virtual closing tag 
	
	// computes the number of prefixes 'xml_' in the virtual tag 
	recursive_logic_tag_size=((number_this_tag_opened)*strlen(XCDE_RECURSIVE_TAG_PREFIX)+strlen(el)) ; 
	
	// allocates the memory needed for the recursive logic tag 
	recursive_logic_tag=(char *) malloc((recursive_logic_tag_size+1)*sizeof(char)) ; 
	
	recursive_logic_tag[0]='\0' ; 
	
	// creates the virtual tag 
	for(k=0 ; k<(number_this_tag_opened) ; ++k)
	  
	  strcat(recursive_logic_tag, "xml_") ; 
	
	strcat(recursive_logic_tag, el) ; 
	
	token=recursive_logic_tag ; 
      }
    
      else  // in this case tha tag isn't recursive
	
	token=(char *) el ; 
    
    // ..   
    // ..   endwrite - ANALYZES SEPARATORS 
    // .. 
 
    do { num_seps=0 ; 
    
    do {

      // copies the separator character in the separators buffer 
      seps[num_seps]=separator ; 
      
      // increases the number of separators in the buffer
      ++num_seps ; 
      
      // increases position 
      ++xml_position ; 
      
    } while ((separator != '>') 
	     && 
	     (num_seps < XCDE_MAX_SEPARATORS_BLOCK) && 
	     (token_len=get_next_token(xml_code+xml_position, 
				       " \t\n>",
				       &separator, 
				       xml_dimension-xml_position)==0)) ; 
    
    
    
    seps[num_seps]='\0' ; 
    
    // checks if there's correspondence between logical and physical views 
    if (physical_correspondence) { // if enters this block there's correspondence
                                   // between logical and physical views. 

      // in this case it's at the end of the closing tag
      if (separator == '>')
	
	// writes the physical position of the closing tag in the IL file  
	hinsert((char *) token,
		strlen(token),
		TAG,
		(char *) NULL, 
		ht, 
		last_body_position_written,
		0, 
		((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ; 	
      
      // computes the separator codeword length 
      nooutput_token(seps, 
		     strlen(seps), 
		     WORD) ;
	
      // updates the body physical position 
      last_body_position_written=body_size_without_zlib ; 
    }

    else if (separator == '>') { // theresn't correspondence between logical and physical views. So inserts 
                                 // the escape position of the closing tag and increases the element rank 

      hinsert((char *) token,
	      strlen(token),
	      TAG,
	      (char *) NULL, 
	      ht, 
	      last_body_position_written,
	      elementRank,
	      ((0x00) | _WRITE_PHYSIC_ESCAPE)) ; 
      
      // increases the element rank 
      ++elementRank ; 
    }
    } while ((token_len==0) && (separator != '>')) ; 
  }

  end_pos : 
    
    if ((token != NULL) && (token != el))
      
      free(token) ; 
  
  if (entity != NULL) 
    
    free(entity) ; 
  
  return;
}

/******************************************************************** 
		             text handlers
*********************************************************************/

void 
text(void *data, 
     const char *t, 
     int len)
{ register 
    int k=0 ; 
 
 char *entity=NULL ; 

 int entity_len=0 ;  

 char *token=NULL ; 
 
 int token_len=0 ; 

 int textcount=0 ; 

 unsigned
   char separate_flag=0u ; 

 int num_seps=0 ; 

 char seps[XCDE_MAX_SEPARATORS_BLOCK+1] ; 
 
 char separator ; 
 
 int buffer_length=0 ; 
 
 unsigned char 
   physic_flag=0u ; 

 // .. 
 // .. text - CHECKS THE TEXT IS IN AN ENTITY EXPANTION 
 // ..        AND IT'S A SEPARATOR 
 // .. 

 // checks if the text is in an entity expantion
 physic_flag=phy_corr(&entity,
		      &entity_len,
		      1) ;
 
 // checks if the text is in an entity expantion, and if 
 // the entity is in the entity separators list 
 if ((!physic_flag) && 
     
     (hsearch(entity,
	      entity_len,
	      NOTHING, 
	      expat_separators_table)))
   
   separate_flag=1u ; // the flag is put to on if the text is in an entity expantion and 
                      // it is in the entity separators list 
 
 // .. 
 // .. text - ANALYZES THE TEXT AND THE TEXTBUFFER 
 // .. 

 do { 	
   
   do {
     
     num_seps=0 ;
     
     while((textcount < len) && 
	   (num_seps < XCDE_MAX_SEPARATORS_BLOCK) && 
	   ((token_len=get_next_token((char *) t+textcount, 
				      separators, 
				      &separator,
				      len-textcount))==0)) { // if enters in this loop the character of the text that has been read 
                                                             // is a separator

       

       // analyzes the textbuffer because the character is a separator and so the buffer
       // must be analyzed
       if (text_in_buffer(&textbuffer)) { // if enters this block there're some tokens in the buffer 
	 
	 buffer_length=get_buffer_length(&textbuffer) ; 

	 // frees the memory needed to contain the token 
	 if (token != NULL)
	   
	   free(token) ; 
	 
	 // allocates the memory needed to contain the token 
	 token = (char *) malloc((buffer_length+1)*sizeof(char)) ; 
	 
	 // reads the token 
	 buffer_length = get_text_in_buffer(&textbuffer, 
					    token) ; 
	 
	 token[buffer_length]='\0' ; 
	 
	 undercase(token, 
		   buffer_length) ; 
	 
	 // checks if the proximity must be computed
	 if (proximity_flag) { // if enters this block the proximity must be computed 

	   // inserts the token in the words dictionary with its proximity 
	   number_tokens+=hinsert((char *) token, 
				  buffer_length, 
				  WORD,
				  (char *) NULL, 
				  ht, 
				  proximity_counter, 
				  0, 
				  ((0x00) | _INSERT_LOGICAL_OCCURRENCE)) ; 
	   
	   // increases the proximity counter 
	   ++proximity_counter ;
	 }

	 else // in this case the proximity hasn't to be computed 

	   number_tokens+=hinsert((char *) token, 
				  buffer_length, 
				  WORD,
				  (char *) NULL, 
				  ht, 
				  0, 
				  0, 
				  (0x00)) ; 
       }

       // increases the text counter 
       ++textcount ; 
       
       // increases the position 
       ++xml_position ; 
       
       // copies the separator character in the separators buffer
       seps[num_seps]=separator ; 
       
       // increases the number of separators
       ++num_seps ; 
     }

     // checks if there's correspondence between physical and logical views and if there're some characters
     // in the separators buffer 
     if ((physic_flag) && (num_seps > 0)) { // if enters this block there's correspondence between physical and 
                                            // logical views and there're some characters in the separators buffer
       
       seps[num_seps]='\0' ; 
       
       // inserts the separators in the words dictionary 
       number_tokens+=hinsert((char *) seps, 
			      strlen(seps),
			      WORD,
			      (char *) NULL, 
			      ht, 
			      0,
			      0, 
			      ((0x00) | _INCREASE_PHYSICAL_COUNT)) ; 
       
       // writes information for debugging 
       if (verbosing_flag)
	 
	 fprintf(debugPhysicView, "%s", seps) ; 
       
       num_seps=0 ; 
     }
     
   } while ((token_len==0) && (textcount < len)) ; 
   
   // checks if all the characters in the text have been analyzed and 
   // in this case the loop ends 
   if (textcount >= len) break ; 

   // checks if the text has been derived from the expantion of an entity that 
   // is a separator 
   if ((text_in_buffer(&textbuffer)) && (separate_flag)) { // if enters in this block the text has been derived 
                                                           // from the expantio of an entity that is a separator.
                                                           // In this case the textbuffer must be analyzed 
     
     buffer_length=get_buffer_length(&textbuffer) ; 
     
     // frees the memory needed to contain the token 
     if (token != NULL)
       
       free(token) ; 
     
     // allocated the memory needed to contain the token 
     token = (char *) malloc((buffer_length+1)*sizeof(char)) ; 
     
     buffer_length=get_text_in_buffer(&textbuffer,
				      token) ; 
     
     token[buffer_length]='\0' ; 
     
     undercase(token, 
	       buffer_length) ; 
     
     // checks if the proximity must be computed
     if (proximity_flag) { // if enters in this block the proximity must be computed 

       // inserts the token in the words dictionary with its proximity
       number_tokens+=hinsert((char *) token, 
			      buffer_length, 
			      WORD,
			      (char *) NULL, 
			      ht, 
			      proximity_counter, 
			      0, 
			      ((0x00) | _INSERT_LOGICAL_OCCURRENCE)) ; 
       
       // increases the proximity counter
       ++proximity_counter ; 			
     } 

     else // in this case the proximity hasn't to be computed, but the token is 
          // inserted in the word dictionary 
       
       number_tokens+=hinsert((char *) token, 
			      buffer_length, 
			      WORD,
			      (char *) NULL, 
			      ht, 
			      0, 
			      0, 
			      (0x00)) ; 
   }

   // checks if there are no separators in the text analyzed and it wasn't derived
   // from the expantion of an entity that is a separator 
   if ((token_len == len-textcount) && (!separate_flag)) { // if enter this block there are no separators in the text
                                                           // analyzed and it wasn't derived from an entity expantion  
     
     // frees the memory needed to contain the text 
     if (token != NULL) 
       
       free(token) ; 
     
     // allocates the memory needed to contain the text 
     token = (char *) malloc((token_len+1)*sizeof(char)) ; 
     
     // copies the text in the memory allocated 
     for(k=0; k<token_len; ++k) 
       
       token[k]=t[textcount+k] ; 
     
     token[k]='\0' ; 
     
     // inserts the text analyzed in the buffer 
     insert_buffer(&textbuffer, 
		   token,
		   token_len) ; 
     
     // checks if there's correspondence between physical and logical views 
     if (physic_flag) { // if enters this block there's correspondence between logical and physical 
                        // views 

       // checks if the debugging information must be printed 
       if (verbosing_flag)
	 
	 fprintf(debugPhysicView, "%s", token) ; 
       
       // inserts the token in the words dictionary as a physical token 
       number_tokens+=hinsert((char *) token,
			      token_len,
			      WORD,
			      (char *) NULL, 
			      ht, 
			      0,
			      0, 
			      ((0x00) | _INCREASE_PHYSICAL_COUNT)) ; 
     }
     
     // increases the position 
     xml_position+=token_len ;
     
     if (token != NULL) 
       
       free(token) ; 
     
     if (entity != NULL)
       
       free(entity) ; 
     
     return ; 
   }
   
   else 
     
     // checks if the text analyzed was derived from an expansion of an entity that 
     // is a separator 
     if ((token_len == len-textcount) && (separate_flag)) { // if enters this block the text analyzed
                                                            // was derived from an entity that is a separator 
                                                            // and we have analyzed all the text. So the 
                                                            // last token in the text must not be inserted 
                                                            // in the textbuffer
       
       // frees the memory allocated 
       if (token != NULL)
	 
	 free(token) ; 
       
       // allocates the memory needed to contain the text 
       token = (char *) malloc((token_len+1)*sizeof(char)) ; 
       
       for(k=0; k<token_len; ++k) 
	 
	 token[k]=t[textcount+k] ; 
       
       token[k]='\0' ; 
       
       // checks if there's correspondence between logical and physical views
       if (physic_flag) { // if enters this block there's correspondence between logical 
	                  // and physical views  

	 // checks if debugging information must be printed  
	 if (verbosing_flag)
	   
	   fprintf(debugPhysicView, "%s", token) ; 
	 
	 // inserts the token in the word dictionary as a physical token 
	 number_tokens+=hinsert((char *) token,
				token_len,
				WORD,
				(char *) NULL, 
				ht, 
				0,
				0, 
				((0x00) | _INCREASE_PHYSICAL_COUNT)) ; 
       }             

       else
	 
	 // inserts the token in the word dictionary as a logical token 
	 number_tokens+=hinsert((char *) token,
				token_len,
				WORD,
				(char *) NULL, 
				ht, 
				0,
				0, 
				0x00) ; 
       
       // increases the position 
       xml_position+=token_len ; 

       // updates the physical correspondence flag 
       last_physical_correspondence=physical_correspondence ; 

       // frees the memory allocated
       if (token != NULL) 
	 
	 free(token) ;
       
       if (entity != NULL)
	 
	 free(entity) ; 
       
       return; 
     }
   
     else
       
       // a separator was found in the text analyzed, and we are not in the last token of the text. 
       // So it checks if there's some text in the textbuffer
       if (text_in_buffer(&textbuffer)) { // if enters this block there's some text in the buffer
	                                  // and a separator was found. In this case a
	                                  // new token must be created by concatening the text analyzed
	                                  // with the one in the textbuffer

	 buffer_length=get_buffer_length(&textbuffer) ; 
	 
	 // frees the memory needed to contain the token 
	 if (token != NULL)
	   
	   free(token) ;

	 // allocated the memory needed to contain the token 
	 token = (char *) malloc((buffer_length+token_len+1)*sizeof(char)) ; 
	 
	 buffer_length=get_text_in_buffer(&textbuffer, 
					  token) ; 
	 
	 undercase(token, 
		   buffer_length) ; 
	 
	 token[buffer_length]='\0' ; 
       }
   
       // in this case a separator was found in the text but there's not any text 
       // in the texbuffer 
       else { buffer_length = 0 ; 
	
       // frees the memory needed to contain the token
       if (token != NULL) 
	   
	 free(token) ; 
	 
       // allocates the memory needed to contain the token 
       token=(char *) malloc((token_len+1)*sizeof(char)) ;
       }

   // creates the token, eventually by concatening the text with the one contained 
   // in the textbuffer
   for(k=0; k<token_len; ++k) { 
     
     token[k+buffer_length]=t[textcount+k] ; 
     
     // checks if the debugging information must be printed 
     if ((physic_flag) && (verbosing_flag)) 
       
       fprintf(debugPhysicView, "%c", token[k+buffer_length]) ;
   }
   
   token[k+buffer_length] = '\0' ; 
   
   // checks if there's correspondence between logical and physical views
   if (physic_flag) 
     
     // there's correspondence between logical and physical views, so
     // inserts the token in the words dictionary as a physical token. The contain 
     // of the textbuffer was eventually alyet be inserted 
     number_tokens+=hinsert((char *) token+buffer_length,
			    token_len,
			    WORD,
			    (char *) NULL,
			    ht,
			    0,
			    0, 
			    ((0x00) | _INCREASE_PHYSICAL_COUNT)) ; 
   
   undercase(token, 
	     token_len+buffer_length) ; 
   
   // checks if the proximity must be computed
   if (proximity_flag) { // if enters this block the proximity must be computed
     
     // insertes the token created by concatening the textbuffer with
     // the text in the words dictionary as a logical token and with its proximity 
     number_tokens+=hinsert((char *) token,
			    token_len+buffer_length, 
			    WORD,
			    (char *) NULL,
			    ht,
			    proximity_counter,
			    0, 
			    ((0x00) | _INSERT_LOGICAL_OCCURRENCE)) ; 
   
     // increases the proximity counter
     ++proximity_counter ; 
   }
   
   else // in this case the proximity must not be computed
     

     // insertes the token created by concatening the text with the textbuffer in the
     // words dictionary as a logical token 
     number_tokens+=hinsert((char *) token,
			    token_len+buffer_length, 
			    WORD,
			    (char *) NULL,
			    ht,
			    0, 
			    0, 
			    (0x00)) ; 
   
   // increases the text counter 
   textcount+=token_len ; 
   
   // increases the logical position 
   xml_position+=token_len ; 
   
 } while (textcount < len) ; 
 
 // frees the memory allocated 
 if (token != NULL)
   
   free(token) ; 
 
 if (entity != NULL)
   
   free(entity) ; 
 
 return ;
}

void 
textcod(void *data, 
	const char *t, 
	int len)
{ register
    int k=0 ; 

 int last_position=0 ; 

 char *entity=NULL ; 
 
 int token_len=0 ; 
 
 int entity_len=0 ; 

 unsigned
   char separate_flag=0u ; 
 
 char seps[XCDE_MAX_SEPARATORS_BLOCK+1] ; 

 int num_seps=0 ; 

 int textcount=0 ; 
 
 char *token=NULL; 

 int buffer_length=0 ; 

 char separator ; 

 // .. 
 // .. textcod - CHECKS THE TEXT IS IN AN ENTITY EXPANTION 
 // ..           AND IT'S A SEPARATOR 
 // .. 

 // gets the last position in the body file used to determine 
 // the position of the text in the buffer
 last_position=body_size_without_zlib ; 
 
 // gets the last physical flag that the program uses to determine
 // the type of the last position of the text in the buffer
 last_physical_correspondence=physical_correspondence ; 
 
 // checks if there's correspondence between physical and logical
 // views of the file 
 physical_correspondence=phy_corr(&entity,
				  &entity_len,
				  0) ; 

 // checks if the text is the expansion of an entity 
 // which is a separator 
 if ((!physical_correspondence) &&
     (hsearch(entity,
	      strlen(entity),
	      NOTHING,
	      expat_separators_table)))
   
   separate_flag=1u ; // the flag is put to on if the text is in an entity expantion and 
                      // it is in the entity separators list 
 
 // .. 
 // .. textcod - ANALYZES THE TEXT AND THE TEXTBUFFER 
 // .. 

 do { // analizes the text 
   
   do { num_seps=0 ; 
	 
   while((textcount < len) && 
	 (num_seps < XCDE_MAX_SEPARATORS_BLOCK) &&
	 ((token_len=get_next_token((char *) t+textcount,
				    separators,
				    &separator,
				    len-textcount)) == 0)) { // if enters in this loop the character of the text that has been read 
                                                             // is a separator

     // checks if there is an element in the buffer 
     // and in this case the text is extracted 
     // and its physical position got
     if (text_in_buffer(&textbuffer)) { 

       buffer_length=get_buffer_length(&textbuffer) ; 
	 
       // frees the memory needed to contain the token 
       if (token != NULL)

	 free(token) ; 
       
       // allocates the memory needed to contain the token 
       token = (char *) malloc((buffer_length+1)*sizeof(char)) ; 
	 
       // reads the token 
       buffer_length=get_text_in_buffer(&textbuffer, 
					token) ; 
       
       token[buffer_length]='\0' ; 
       
       undercase(token, 
		 buffer_length) ; 
       
       // checks if there's correspondence between logical and physical views for the 
       // text in the buffer 
       if (!last_physical_correspondence) { // if enters this loop there isn't correspondence 
	                                    // between logical and physical views for the 
	                                    // text in the buffer
	 
	 // inserts the escape position of the token in the buffer
	 hinsert((char *) token, 
		 strlen(token),
		 WORD,
		 (char *) NULL, 
		 ht, 
		 last_body_position_written,
		 elementRank,
		 ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 

	 // increases the element rank 
	 ++elementRank ; 
       }
       
       else // in this case there's correspondence between logical and physical views 
	 
	 // inserts the physical position of the token in the buffer  
	 hinsert((char *) token, 
		 strlen(token), 
		 WORD,
		 (char *) NULL, 
		 ht, 
		 last_body_position_written,
		 0, 
		 ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
     }
       
     // if there's physical correspondence updates the physical position 
     if (physical_correspondence)
       
       last_body_position_written=last_position ; 
       
     // if there isn't physical correspondence and the entity 
     // is different from the previous, the element rank counter
     // is put to 1
     if ((!physical_correspondence) && (changed_position))
	 
       elementRank=1 ; 
       
     // copies the separator character in the buffer
     seps[num_seps]=separator ; 
       
     // increases the number of separator 
     ++num_seps ; 
       
     // increases the counter of the text 
     ++textcount ; 
       
     // increases the pointer to the text 
     ++xml_position ; 
     }
   
   // if there's physical correspondence and there are some separators in
   // text, writes the body file 
   if ((physical_correspondence) && (num_seps > 0)) { // if enters this block there's physical correspondence
                                                      // and there're some separators in the text 

     seps[num_seps]='\0' ; 

     // writes the separators codewords in the body file 
     output_token(seps, 
		  strlen(seps),
		  WORD) ; 
     
     // updates the physical position 
     last_body_position_written=body_size_without_zlib ; 
   }
   
   } while((token_len==0) && (textcount < len)) ;  
   
   // checks if all the text has been analyzed and in this case the loop ends 
   if (textcount >= len) break ; 
   
   // checks if the text has been derived from the expansion of an entity that 
   // is a separator   
   if ((text_in_buffer(&textbuffer)) && (separate_flag)) { // if enters in this block the text has been derived 
                                                           // from the expantio of an entity that is a separator.
                                                           // In this case the textbuffer must be analyzed 
     
     buffer_length=get_buffer_length(&textbuffer) ; 
     
     // frees the memory needed to contain the token 
     if (token != NULL)
       
       free(token) ; 
     
     // allocated the memory needed to contain the token 
     token=(char *) malloc((buffer_length+1)*sizeof(char)) ; 
     
     buffer_length=get_text_in_buffer(&textbuffer, 
				      token) ; 
     
     token[buffer_length]='\0' ; 
     
     undercase(token, 
	       buffer_length) ; 
     
     // checks if there's correspondence between physical and logical views for the 
     // text in the buffer
     if (!last_physical_correspondence) { // if enters in this block there's correspondence between physical
                                          // and logical views for the text in the buffer

       // inserts the escape position of the token 
       hinsert((char *) token, 
	       strlen(token),
	       WORD,
	       (char *) NULL, 
	       ht, 
	       last_body_position_written,
	       elementRank,
	       ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
       
       // increases the element rank 
       ++elementRank ; 
     }
	
     else // in this case there's physical correspondence between physical 
          // and logical views 
       
       // inserts the physical position of the token 
       hinsert((char *) token, 
	       strlen(token),
	       WORD,
	       (char *) NULL, 
	       ht, 
	       last_body_position_written,
	       0, 
	       ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
     
     // if there isn't correspondence between physical and logical 
     // views and the entity has changes, put to 1 the element rank
     // counter 
     if ((!physical_correspondence) && (changed_position))
       
       elementRank=1 ; 
   }
   
   // checks if there are no separators in the text analyzed and it wasn't derived
   // from the expansion of an entity that is a separator 
   if ((token_len == len-textcount) && (!separate_flag)) { 
     
     // frees the memory needed to contain the text 
     if (token != NULL)
       
       free(token) ; 
     
     // allocates the memory needed to contain the text 
     token = (char *) malloc((token_len+1)*sizeof(char)) ; 
     
     // copies the text in the memory allocated 
     for(k=0; k<token_len; ++k) 
       
       token[k]=t[textcount+k] ; 
     
     token[k]='\0' ; 
     
     // inserts the text analyzed in the buffer
     insert_buffer(&textbuffer, 
		   token,
		   token_len) ; 
     
     // checks if there's correspondence between physical and logical views 
     if (physical_correspondence) 
       
       // there's correspondence between physical and logical views. Writes the
       // codeword of the token in the body file 
       output_token(token, 
		    token_len,
		    WORD) ; 
     
     // increases the pointer to the text
     xml_position+=token_len ; 
     
     // updates the last physical correspondence flag 
     last_physical_correspondence=physical_correspondence ; 
     
     // frees the memory allocated 
     if (entity != NULL)
       
       free(entity) ; 
     
     if (token != NULL)
       
       free(token) ; 
     
     return; 
   }
   
   else 
     
     // checks if the text analyzed was derived from an expansion of an entity that 
     // is a separator 
     if ((token_len == len-textcount) && (separate_flag)) { // if enters this block the text analyzed
                                                            // was derived from an entity that is a separator 
                                                            // and we have analyzed all the text. So the 
                                                            // last token in the text must not be inserted 
                                                            // in the textbuffer 
       
       // frees the memory allocated 
       if (token != NULL)
	 
	 free(token) ; 
       
       // allocates the memory needed to contain the text
       token = (char *) malloc((token_len+1)*sizeof(char)) ; 
       
       // copies the text in the token 
       for(k=0; k<token_len; ++k) 
	 
	 token[k]=t[textcount+k] ; 
       
       token[k]='\0' ; 
       
       // checks if there's physical correspondence between logical and physical
       // views 
       if (physical_correspondence) { // if enters this block there's physical correspondence
	                              // and so writes the token codeword to the body file 
	                              // and inserts the physical position in the IL file 
	
	 // inserts the physical position of the token 
	 hinsert((char *) token, 
		 strlen(token),
		 WORD,
		 (char *) NULL, 
		 ht, 
		 last_body_position_written,
		 0, 
		 ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 	 
 
	 output_token(token, 
		      token_len,
		      WORD) ; 
	 
	 // updates the position in the body file 
	 last_body_position_written=body_size_without_zlib ;
       }
       
       else  { // if enters this block there isn't correspondence between logical and 
	       // physical views, so inserts the escape position in the IL file 
	 
	       // inserts the escape position of the token 
	       hinsert((char *) token, 
		       strlen(token),
		       WORD,
		       (char *) NULL, 
		       ht, 
		       last_body_position_written,
		       elementRank,
		       ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
	       
	       // increases the element rank 
	       ++elementRank ; 
       }
       
       // increases the pointer to the body file 
       xml_position+=token_len ; 
       
       // updates the physical correspondence flag 
       last_physical_correspondence=physical_correspondence ; 
       
       // frees the memory allocated
       if (entity != NULL)
	 
	 free(entity) ; 
       
       if (token != NULL)
	 
	 free(token) ; 
       
       return; 
     }
   
     else
       
       // a separator was found in the text analyzed, and we are not in the last token of the text. 
       // So it checks if there's some text in the textbuffer
       if (text_in_buffer(&textbuffer)) { // if enters this block there's some text in the buffer
	                                  // and a separator was found. In this case a
	                                  // new token must be created by concatening the text analyzed
	                                  // with the one in the textbuffer

	 buffer_length=get_buffer_length(&textbuffer) ; 
	 
	 // frees the memory allocated
	 if (token != NULL) 
	   
	   free(token) ; 
	 
	 // allocates the memory needed to contain the token 
	 token=(char *) malloc((buffer_length+token_len+1)*sizeof(char)) ; 

	 buffer_length=get_text_in_buffer(&textbuffer, 
					  token) ; 
	 
	 token[buffer_length]='\0' ; 
       }

       // in this case a separator was found in the text but there's not any text 
       // in the texbuffer 
       else { buffer_length=0 ; 
	 
       // frees the memory needed to contain the token 
       if (token != NULL) 
	 
	 free(token) ; 
       
       // allocates the memory needed to contain the token 
       token=(char *) malloc((token_len+1)*sizeof(char)) ;
       }
   
   // creates the token, eventually by concatening the text with the one contained
   // in the textbuffer 
   for(k=0; k<token_len; ++k)
     
     token[k+buffer_length]=t[textcount+k] ; 
   
   token[k+buffer_length]='\0' ; 
   
   // checks if there's correspondence between logical and physical views 
   if (physical_correspondence)
     
     // there's correspondence between logical and physical views, so writes the
     // codeword of the token in the body file 
     output_token(token+buffer_length,
		  token_len,
		  WORD) ; 
   
   undercase(token, 
	     token_len+buffer_length) ; 
 
   // checks if there's physical correspondence between logical and physical
   // views 
   if (physical_correspondence) 
     
     // there's correspondence between logical and physical views, so 
     // inserts the physical position of the token 
     hinsert((char *) token,
	     token_len+buffer_length,
	     WORD,
	     (char *) NULL,
	     ht,
	     last_body_position_written,
	     0, 
	     ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ;
   
   else { // if enters this block there isn't correspondence between physical and 
          // logical views, so inserts the escape position of the token and increases 
          // the element rank 
     
     hinsert((char *) token,
	     token_len+buffer_length,
	     WORD,
	     (char *) NULL,
	     ht,
	     last_body_position_written,
	     elementRank,
	     ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
    
     // increases the element rank 
     ++elementRank ; 
   }
 
   // increases the text counter
   textcount+=token_len ; 
 
   xml_position+=token_len ; 
 
   // if there's physical correspondence between physical and 
   // logical views updates the physical position 
   if (physical_correspondence)
     
     last_body_position_written=body_size_without_zlib ; 
   
 } while (textcount < len) ; 
 
 // updates the last physical correspondence flag 
 last_physical_correspondence=physical_correspondence ; 
 
 // frees the memory allocated
 if (entity != NULL)
   
   free(entity) ; 
 
 if (token != NULL)
   
   free(token) ; 
 
 return ; 
}

void 
textwrite(void *data, 
	  const char *t, 
	  int len)
{ register
    int k=0 ; 

 int last_position=0 ; 

 char *entity=NULL ; 
 
 int token_len=0 ; 
 
 int entity_len=0 ; 

 unsigned
   char separate_flag=0u ; 
 
 char seps[XCDE_MAX_SEPARATORS_BLOCK+1] ; 

 int num_seps=0 ; 

 int textcount=0 ; 
 
 char *token=NULL; 

 int buffer_length=0 ; 

 char separator ; 

 // .. 
 // .. textwrite - CHECKS THE TEXT IS IN AN ENTITY EXPANSION 
 // ..             AND IT'S A SEPARATOR 
 // .. 

 // gets the last position in the body file used to determine 
 // the position of the text in the buffer
 last_position=body_size_without_zlib ; 
 
 // gets the last physical flag that the program uses to determine
 // the type of the last position of the text in the buffer
 last_physical_correspondence=physical_correspondence ; 

 // checks if there's correspondence between physical and logical
 // views of the file 
 physical_correspondence=phy_corr(&entity,
				  &entity_len,
				  2) ; 

 // checks if the text is the expansion of an entity 
 // which is a separator 
 if ((!physical_correspondence) &&
     (hsearch(entity,
	      strlen(entity),
	      NOTHING,
	      expat_separators_table)))
   
   separate_flag=1u ; // the flag is put to on if the text is in an entity expantion and 
                      // it is in the entity separators list 
 
 // .. 
 // .. textwrite - ANALYZES THE TEXT AND THE TEXTBUFFER 
 // .. 

 do { // analizes the text 
   
   do { num_seps=0 ; 
	 
   while((textcount < len) && 
	 (num_seps < XCDE_MAX_SEPARATORS_BLOCK) &&
	 ((token_len=get_next_token((char *) t+textcount,
				    separators,
				    &separator,
				    len-textcount)) == 0)) { // if enters in this loop the character of the text that has been read 
                                                             // is a separator

     // checks if there is an element in the buffer 
     // and in this case the text is extracted 
     // and its physical position got
     if (text_in_buffer(&textbuffer)) { 
       
       buffer_length=get_buffer_length(&textbuffer) ; 
       
       // frees the memory needed to contain the token 
       if (token != NULL)

	 free(token) ; 

       // allocates the memory needed to contain the token 
       token = (char *) malloc((buffer_length+1)*sizeof(char)) ; 
       
       buffer_length=get_text_in_buffer(&textbuffer, 
					token) ; 
       
       token[buffer_length]='\0' ; 
       
       undercase(token, 
		 buffer_length) ; 

       // checks if the proximity must be computed
       if (proximity_flag) { // if enters this block the proximity must be computed

	 // writes the proximity of the token 
	 hinsert((char *) token, 
		 buffer_length, 
		 WORD, 
		 (char *) NULL, 
		 ht, 
		 proximity_counter,
		 0,
		 ((0x00) | _WRITE_LOGICAL_OCCURRENCE)) ;  
	 
	 // increases the proximity counter 
	 ++proximity_counter ;     
       }
       
       // checks if there's correspondence between logical and physical views for the 
       // text in the buffer 
       if (!last_physical_correspondence) { // if enters this loop there isn't correspondence 
	                                    // between logical and physical views for the 
	                                    // text in the buffer

	 // inserts the escape position of the token in the buffer	 	 
	 hinsert((char *) token, 
		 strlen(token),
		 WORD,
		 (char *) NULL, 
		 ht, 
		 last_body_position_written,
		 elementRank,
		 ((0x00) | _WRITE_PHYSIC_ESCAPE)) ; 
	 
	 // increases the element rank 
	 ++elementRank ; 
       }
       
       else // in this case there's correspondence between logical and physical views 

	 // inserts the physical position of the token in the buffer 
	 hinsert((char *) token, 
		 strlen(token), 
		 WORD,
		 (char *) NULL, 
		 ht, 
		 last_body_position_written,
		 0, 
		 ((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ; 
     }
     
     // if there's physical correspondence updates the physical position 
     if (physical_correspondence)
       
       last_body_position_written=last_position ; 

     // if there isn't physical correspondence and the entity 
     // is different from the previous, the element rank counter
     // is put to 1
     if ((!physical_correspondence) && (changed_position))
       
       elementRank=1 ; 
     
     // copies the separator character in the buffer
     seps[num_seps]=separator ; 

     // increases the number of separator 
     ++num_seps ; 

     // increases the counter of the text 
     ++textcount ; 
     
     // increases the pointer to the text 
     ++xml_position ; 
   }
   
   // checks if there's physical correspondence and there are some separators in 
   // text
   if ((physical_correspondence) && (num_seps > 0)) { // if enters this block there's physical correspondence
                                                      // and there're some separators in the text
 
     seps[num_seps]='\0' ; 

     // computes separators codeword length 
     nooutput_token(seps, 
		    strlen(seps),
		    WORD) ; 
     
     // updates the physical position in the body 
     last_body_position_written=body_size_without_zlib ; 
   }
   } while((token_len==0) && (textcount < len)) ;  
   
   // checks if all the text has been analyzed and in this case the loop ends 
   if (textcount >= len) break ; 
   
   // checks if the text has been derived from the expansion of an entity 
   // that is a separator 
   if ((text_in_buffer(&textbuffer)) && (separate_flag)) { // if enters in this block the text has been derived 
                                                           // from the expantio of an entity that is a separator.
                                                           // In this case the textbuffer must be analyzed  
     
     buffer_length=get_buffer_length(&textbuffer) ; 

     // frees the memory needed to contain the token 
     if (token != NULL)
       
       free(token) ; 
     
     // allocates the memory needed to contain the token 
     token = (char *) malloc((buffer_length+1)*sizeof(char)) ; 
     
     buffer_length=get_text_in_buffer(&textbuffer, 
				      token) ; 
     
     token[buffer_length]='\0' ; 
     
     undercase(token, 
	       buffer_length) ; 
     
     // checks if the proximity must be computed
     if (proximity_flag) { // if enters in this block the proximity must be computed

       // writes the proximity of the token in the word dictionary 
       hinsert((char *) token, 
	       strlen(token),
	       WORD, 
	       (char *) NULL, 
	       ht, 
	       proximity_counter,
	       0,
	       ((0x00) | _WRITE_LOGICAL_OCCURRENCE)) ;  
       
       // increases the proximity counter 
       ++proximity_counter ;          
     }
      
     // checks if there's correspondence between logical and physical views
     // for the token in the buffer
     if (!last_physical_correspondence) { // if enters in this block there's correspondence between physical
                                          // and logical views for the text in the buffer
       
       // inserts the escape position of the token 
       hinsert((char *) token, 
	       strlen(token),
	       WORD,
	       (char *) NULL, 
	       ht, 
	       last_body_position_written,
	       elementRank,
	       ((0x00) | _WRITE_PHYSIC_ESCAPE)) ; 

       // increases the element rank 
       ++elementRank ; 
     }
     
     else // in this case there's physical correspondence between physical 
          // and logical views 
       
       // inserts the physical position of the token 
       hinsert((char *) token, 
	       strlen(token),
	       WORD,
	       (char *) NULL, 
	       ht, 
	       last_body_position_written,
	       0, 
	       ((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ; 
     
     // if there isn't correspondence between physical and logical 
     // views and the entity has changes, put to 1 the element rank
     // counter 
     if ((!physical_correspondence) && (changed_position))
       
       elementRank=1 ; 
   }

   // checks if there are no separators in the text analyzed and it wasn't derived
   // from the expansion of an entity that is a separator 
   if ((token_len == len-textcount) && (!separate_flag)) { 
     
     // frees the memory needed to contain the text
     if (token != NULL)
       
       free(token) ; 
     
     // allocates the memory needed to contain the tex t
     token = (char *) malloc((token_len+1)*sizeof(char)) ; 
     
     // copies the text in the memory allocated 
     for(k=0; k<token_len; ++k) 
       
       token[k]=t[textcount+k] ; 
     
     token[k]='\0' ; 
     
     // inserts the text analyzed in the buffer
     insert_buffer(&textbuffer, 
		   token,
		   token_len) ; 
     
     // checks if there's physical correspondence between logical and
     // physical views
     if (physical_correspondence)
       
       // computes the codeword length of the token 
       nooutput_token(token, 
		      token_len,
		      WORD) ; 
     
     // increases the pointer to the text
     xml_position+=token_len ; 
     
     // update the last physical correspondence flag
     last_physical_correspondence=physical_correspondence ; 
     
     // frees the memory allocated 
     if (entity != NULL)
       
       free(entity) ; 
     
     if (token != NULL)
       
       free(token) ; 
     
     return; 
   }
   
   else 
     
     // checks if the text analyzed was derived from an expansion of an entity that 
     // is a separator 
     if ((token_len == len-textcount) && (separate_flag)) { // if enters this block the text analyzed
                                                            // was derived from an entity that is a separator 
                                                            // and we have analyzed all the text. So the 
                                                            // last token in the text must not be inserted 
                                                            // in the textbuffer 
       
       // frees the memory allocated
       if (token != NULL)
	 
	 free(token) ; 
       
       // allocates the memory needed to contain the text
       token = (char *) malloc((token_len+1)*sizeof(char)) ; 
       
       // copies the text in the token 
       for(k=0; k<token_len; ++k) 
	 
	 token[k]=t[textcount+k] ; 
       
       token[k]='\0' ; 
       
       // checks if there's physical correspondence between logical and physical
       // views 
       if (physical_correspondence) { // if enters this block there's physical correspondence
	                              // and so writes the token codeword to the body file 
	                              // and writes the physical position in the IL file 
	
	 // writes the physical position of the token in the IL file  
	 hinsert((char *) token, 
		 strlen(token),
		 WORD,
		 (char *) NULL, 
		 ht, 
		 last_body_position_written,
		 0, 
		 ((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ; 	 
 
	 // computes the token codeword length 
	 nooutput_token(token, 
			token_len,
			WORD) ; 
	 
	
	 // updates the physical position in the body 
	 last_body_position_written=body_size_without_zlib ;
       }

       else  { // if enters this block there isn't correspondence between logical and 
	       // physical views, so writes the escape position in the IL file 
	 
	 // inserts the escape position of the token 
	 hinsert((char *) token, 
		 strlen(token),
		 WORD,
		 (char *) NULL, 
		 ht, 
		 last_body_position_written,
		 elementRank,
		 ((0x00) | _WRITE_PHYSIC_ESCAPE)) ; 
	 
	 // increases the element rank 
	 ++elementRank ; 
       }
       
       // increases the pointer to the body file
       xml_position+=token_len ; 
       
       // updates the physical correspondence flag 
       last_physical_correspondence=physical_correspondence ; 
       
       // frees the memory allocated 
       if (entity != NULL)
	 
	 free(entity) ; 
       
       if (token != NULL)
	 
	 free(token) ; 
       
       return; 
     }
   
     else
       
       // a separator was found in the text analyzed, and we are not in the last token of the text. 
       // So it checks if there's some text in the textbuffer    
       if (text_in_buffer(&textbuffer)) { // if enters this block there's some text in the buffer
	                                  // and a separator was found. In this case the
	                                  // token is created by concatening the text analyzed
	                                  // with the one in the textbuffer
	 
	 buffer_length=get_buffer_length(&textbuffer) ; 

	 // frees the memory needed to contain the token 
	 if (token != NULL) 
	   
	   free(token) ; 
	 
	 // allocates the memory needed to contain the token 
	 token=(char *) malloc((buffer_length+token_len+1)*sizeof(char)) ; 
	 
	 buffer_length=get_text_in_buffer(&textbuffer, 
					  token) ; 
	 
	 token[buffer_length]='\0' ; 
       }
   
       // in this case a separator was found in the text but there's not any text 
       // in the texbuffer 
       else { 
	 
	 buffer_length=0 ; 
	 
	 // frees the memory needed to contain the token 
	 if (token != NULL) 
	   
	   free(token) ; 
	 
	 // allocates the memory needed to contain the token 
	 token=(char *) malloc((token_len+1)*sizeof(char)) ;
       }
   
   // creates the token, eventually by concatening the text with the one contained
   // in the textbuffer 
   for(k=0; k<token_len; ++k)
     
     token[k+buffer_length]=t[textcount+k] ; 

   token[k+buffer_length]='\0' ; 

   // checks if there's correspondence between logical and physical view 
   if (physical_correspondence)
     
     // there's correspondence between logical and physical views,
     // so compute the codeword lenght of the token 
     nooutput_token(token+buffer_length,
		    token_len,
		    WORD) ; 
   
   undercase(token, 
	     token_len+buffer_length) ; 

   // checks if the proximity must be computed 
   if (proximity_flag) { // if enters this block the proximity must be computed 
     
     // writes the proximity associated with the token 
     hinsert((char *) token, 
	     token_len+buffer_length, 
	     WORD, 
	     (char *) NULL, 
	     ht, 
	     proximity_counter,
	     0,
	     ((0x00) | _WRITE_LOGICAL_OCCURRENCE)) ;  
   
     // increases the proximity counter 
     ++proximity_counter ;             
   }
   
   // checks if there's correspondence between physical and logical
   // views 
   if (physical_correspondence) 
     
     // there's correspondence between physical and logical views. Writes
     // the physical position of the token in the IL file 
     hinsert((char *) token,
	     token_len+buffer_length,
	     WORD,
	     (char *) NULL,
	     ht,
	     last_body_position_written,
	     0, 
	     ((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ;
   
   else { // if enters this block there isn't correspondence between physical 
          // and logical views
     
     // inserts the escape position of the token in the IL file 
     hinsert((char *) token,
	     token_len+buffer_length,
	     WORD,
	     (char *) NULL,
	     ht,
	     last_body_position_written,
	     elementRank,
	     ((0x00) | _WRITE_PHYSIC_ESCAPE)) ; 
     
     // increases the rank of the element 
     ++elementRank ; 
   }
   
   // increases the text counter 
   textcount+=token_len ; 
   
   // increases the pointer 
   xml_position+=token_len ; 
   
   // if there's correspondence between physical and logical views
   // updates the position in the body file 
   if (physical_correspondence)
     
     last_body_position_written=body_size_without_zlib ; 
   
 } while (textcount < len) ; 
 
 // updates the last physical correspondence flag 
 last_physical_correspondence=physical_correspondence ; 

 // frees the memory allocated 
 if (entity != NULL)
   
   free(entity) ; 
 
 if (token != NULL)
   
   free(token) ; 
 
 return ; 
}

 /*******************************************************************
		  CDATA section start handlers
 *******************************************************************/

void 
cdstart(void *data) 
{ const 
    char open_CDATA_section[] = "<![CDATA["; 
 
 char *token=NULL ;  
 
 char *entity=NULL ; 
 
 int entity_len=0 ; 
 
 int buffer_length=0 ; 
 
 unsigned 
   char physic_flag=0u ; 
 
 char separator ; 

  // ..
  // ..   
  // ..   cdstart - ANALYZES THE TEXTBUFFER
  // ..
  // ..

 // checks if there's a token in the textbuffer 
 if (text_in_buffer(&textbuffer)) { 

   buffer_length=get_buffer_length(&textbuffer) ; 
   
   // allocates the memory needed to contain the token 
   token = (char *) malloc((buffer_length+1)*sizeof(char)) ; 
   
   buffer_length=get_text_in_buffer(&textbuffer,
				    token) ; 
   
   token[buffer_length]= '\0' ; 
   
   undercase(token, 
	     buffer_length) ; 
   
   // checks if the proximity must be computed
   if (proximity_flag) { // if enters in this block the proximity must be computed

     // inserts the token in the words dictionary with its proximity 
     number_tokens+=hinsert((char *) token, 
			    buffer_length, 
			    WORD,
			    (char *) NULL, 
			    ht, 
			    proximity_counter, 
			    0, 
			    ((0x00) | _INSERT_LOGICAL_OCCURRENCE)) ;  
     
     // increases the proximity counter 
     ++proximity_counter ; 
   }

   else // in this case the proximity must not be computed 
      
     // inserts the token in the words dictionary 
     number_tokens+=hinsert((char *) token, 
			    buffer_length, 
			    WORD,
			    (char *) NULL, 
			    ht, 
			    0, 
			    0, 
			    (0x00)) ; 
 }

 // ..
 // ..   
 // ..   cdstart - CHECKS IF THERE IS CORRESPONDENCE
 // ..   BETWEEN LOGICAL AND PHYSICAL VIEWS 
 // ..

 // checks if there's correspondence between logical and 
 // physical views
 physic_flag=phy_corr(&entity,
		      &entity_len,
		      1) ;
 
 if (physic_flag) { // if enters this block there is correspondence between logical and 
                    // physical views. Inserts the open_CDATA_section string 
                    // ('<![CDATA[') in the tags dictionary as a physical token 

   number_tokens+=hinsert((char *) open_CDATA_section,
			  strlen(open_CDATA_section), 
			  TAG,
			  (char *) NULL, 
			  ht, 
			  0, 
			  0, 
			  ((0x00) | _INCREASE_PHYSICAL_COUNT)) ; 
 }
 
 else { // in this case there isn't correspondence between physical and logical views, so 
        // inserts the open_CDATA_section string ('<![CDATA[') in the tags dictionary as a logical
        // string
   
   number_tokens+=hinsert((char *) open_CDATA_section,
			  strlen(open_CDATA_section), 
			  TAG,
			  (char *) NULL,
			  ht,
			  -1977,
			  -1977, 
			  (0x00)) ; 
   
   // set to 1 the flag that says if the CDATA is in an expansion of an internal
   // entity 
   expat_CDATA_expansion_flag=1u ; 
 }

 // increases the pointer to the text
 xml_position+=strlen(open_CDATA_section) ; 
 
 // checks if the debugging information must be printed
 if ((physic_flag) && (verbosing_flag)) 
   
   fprintf(debugPhysicView, "%s", open_CDATA_section) ; 

 // set to 1 the flag that says if it's in a CDATA section 
 expat_CDATA_section_flag=1u ; 
 
 // frees the memory allocated 
 if (entity != NULL)
   
   free(entity) ; 
 
 if (token != NULL)
   
   free(token) ; 
 
 return ;
}

void 
cdstartcod(void *data) 
{ const 
    char open_CDATA_section[] = "<![CDATA["; 
 
 char *token=NULL ; 

 char *entity=NULL ; 

 int entity_len=0 ; 

 int buffer_length=0 ; 

 char separator ; 

 // ..
 // ..   
 // ..   cdstartcod - ANALYZES THE TEXTBUFFER
 // ..
 // ..

 // checks if there is a token in the buffer 
 if (text_in_buffer(&textbuffer)) { 

   buffer_length=get_buffer_length(&textbuffer) ; 

   // allocates the memory needed to contain the token 
   token= (char *) malloc((buffer_length+1)*sizeof(char)) ; 
   
   buffer_length=get_text_in_buffer(&textbuffer, 
				    token) ; 
   
   token[buffer_length]='\0' ; 
   
   undercase(token, 
	     buffer_length) ; 

   // checks if there's correspondence between logical 
   // and physical views
   if (physical_correspondence) 
     
     // inserts the physical position of the token 
     // in the words dictionary 
     hinsert((char *) token, 
	     strlen(token), 
	     WORD,
	     (char *) NULL, 
	     ht, 
	     last_body_position_written,
	     0,
	     ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
   
   else
     
     { // inserts the escape position of the token in the words dictionary
       // and increases the element rank 
       hinsert((char *) token, 
	       strlen(token),
	       WORD,
	       (char *) NULL, 
	       ht, 
	       last_body_position_written,
	       elementRank,
	       ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
     
       // increases the element rank 
       ++elementRank ; 
     }
 }

 // ..
 // ..   
 // ..   cdstartcod - CHECKS IF THERE IS CORRESPONDENCE
 // ..   BETWEEN LOGICAL AND PHYSICAL VIEWS 
 // ..

 if (physical_correspondence)
   
   // if there's correspondence between logical and 
   // physical views for the text in the buffer 
   // updates the physical position 
   last_body_position_written=body_size_without_zlib ; 
 
 // updates the last physical correspondence flag 
 last_physical_correspondence=physical_correspondence ; 
 
 // checks if there's correspondence between logical and
 // physical views 
 physical_correspondence=phy_corr(&entity,
				  &entity_len,
				  0) ; 
 
 // if there isn't physical correspondence and the physical 
 // position changed set to 1 the element rank counter
 if ((!physical_correspondence) && (changed_position)) 
   
   elementRank=1 ; 
 
 // checks if there's correspondence between logical and 
 // physical views 
 if (physical_correspondence) 
   
   // there's correspondence. Inserts the open_CDATA_section string
   // ('<![CDATA[') physical position in the tags dictionary 
   hinsert((char *) open_CDATA_section, 
	   strlen(open_CDATA_section),
	   TAG,
	   (char *) NULL, 
	   ht, 
	   last_body_position_written, 
	   0,
	   ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
 
 else
   
   { // there isn't correspondence. Inserts the open_CDATA_section string
     // ('<![CDATA[') escape position in the tags dictionary 
     hinsert((char *) open_CDATA_section,
	     strlen(open_CDATA_section),
	     TAG,
	     (char *) NULL, 
	     ht, 
	     last_body_position_written,
	     elementRank,
	     ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
   
     // increases the element rank 
     ++elementRank ; 
   }
 
 if (physical_correspondence) { // if enters this block there's correspondence between logical
                                // and physical views 

   // writes the open_CDATA_section string codeword in the body file 
   output_token((char *) open_CDATA_section,
		strlen(open_CDATA_section),
		TAG) ; 
   
   // updates the position 
   last_body_position_written=body_size_without_zlib ; 
 }
 
 else

   // set to 1 the flag that says if the CDATA is in an expansion of an internal
   // entity 
   expat_CDATA_expansion_flag=1u ; 
 
 // set to 1 the flag that says if it's in a CDATA section 
 expat_CDATA_section_flag=1u ; 
 
 // increases the position 
 xml_position+=strlen(open_CDATA_section) ; 
 
 // frees the memory allocated 
 if (token != NULL)
   
   free(token) ; 
 
 if (entity != NULL)
   
   free(entity) ; 
 
 return ;
}

void 
cdstartwrite(void *data) 
{ const 
    char open_CDATA_section[] = "<![CDATA["; 
 
 char *token=NULL ; 
 
 char *entity=NULL ; 

 int entity_len=0 ; 

 int buffer_length=0 ; 

 char separator ; 

 // ..
 // ..   
 // ..   cdstartwrite - ANALYZES THE TEXTBUFFER
 // ..
 // ..
 
 // checks if there is a token in the buffer 
 if (text_in_buffer(&textbuffer)) { 

   buffer_length=get_buffer_length(&textbuffer) ; 
   
   // allocates the memory needed to contain the token 
   token= (char *) malloc((buffer_length+1)*sizeof(char)) ; 
   
   buffer_length=get_text_in_buffer(&textbuffer, 
				    token) ; 
   
   token[buffer_length]='\0' ; 
   
   undercase(token, 
	     buffer_length) ; 
   
   // checks if the proximity must be computed
   if (proximity_flag) { // if enters this block the proximity must be computed

     // writes the proximity associated with the token in the IL file 
     hinsert((char *) token, 
	     strlen(token), 
	     WORD, 
	     (char *) NULL, 
	     ht, 
	     proximity_counter,
	     0,
	     ((0x00) | _WRITE_LOGICAL_OCCURRENCE)) ;  
     
     // increases the proximity counter 
     ++proximity_counter ;    
   }
   
   // checks if there's correspondence between logical and 
   // physical views 
   if (physical_correspondence) 
     
     // there's correspondence between logical and physical
     // views, so writes the physical position associated
     // with the token to the IL file 
     hinsert((char *) token, 
	     strlen(token), 
	     WORD,
	     (char *) NULL, 
	     ht, 
	     last_body_position_written,
	     0,
	     ((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ; 
   
   else
     
     { // if enters this block there isn't correspondence between logical
       // and physical position, 

       // writes the escape position associated with the token in the IL file 
       hinsert((char *) token, 
	       strlen(token),
	       WORD,
	       (char *) NULL, 
	       ht, 
	       last_body_position_written,
	       elementRank,
	       ((0x00) | _WRITE_PHYSIC_ESCAPE)) ; 
     
       // increases the element rank 
       ++elementRank ; 
     }
 }
 
 // if there's physical correspondence updates the physical position 
 if (physical_correspondence)
   
   last_body_position_written=body_size_without_zlib ; 
 
 // updates the last physical correspondence flag 
 last_physical_correspondence=physical_correspondence ; 
 
 // checks if there is correspondence between logical
 // and physical views 
 physical_correspondence=phy_corr(&entity,
				  &entity_len,
				  2) ; 
 
 // checks if there isn'tlcorrespondence between logical and physical
 // views and if the entity expanded is new. In this case set to 1 the 
 // element rank counter
 if ((!physical_correspondence) && (changed_position)) 
   
   elementRank=1 ; 
 
 if (physical_correspondence) 
 
   // there's correspondence between logical and physical views,
   // so writes the physical position associated to the open_CDATA_section
   // string in the IL file 
   hinsert((char *) open_CDATA_section, 
	   strlen(open_CDATA_section),
	   TAG,
	   (char *) NULL, 
	   ht, 
	   last_body_position_written, 
	   0,
	   ((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ; 
 
 else
   
   { // if enters this block there isn't correspondence
     // between logical and physical views

     // writes the escape position associated to the open_CDATA_section
     // string in the IL file 
     hinsert((char *) open_CDATA_section,
	     strlen(open_CDATA_section),
	     TAG,
	     (char *) NULL, 
	     ht, 
	     last_body_position_written,
	     elementRank,
	     ((0x00) | _WRITE_PHYSIC_ESCAPE)) ; 
   
     // increases the element rank 
     ++elementRank ; 
   }
 
 if (physical_correspondence) { 

   // if enters this block there is correspondence
     // between logical and physical views

     // computes the codeword length of the open_CDATA_section
     // string 
     nooutput_token((char *) open_CDATA_section,
		    strlen(open_CDATA_section),
		    TAG) ; 
   
     // updates the position 
     last_body_position_written=body_size_without_zlib ; 
   }
 
 else
   
   // set to 1 the flag that says if the CDATA is in an expansion of an internal
   // entity 
   expat_CDATA_expansion_flag=1u ; 

 // set to 1 the flag that says if it's in a CDATA section 
 expat_CDATA_section_flag=1u ; 
 
 // increases the position 
 xml_position+=strlen(open_CDATA_section) ; 
 
 // frees the memory allocated
 if (token != NULL)
   
   free(token) ; 
 
 if (entity != NULL)
   
   free(entity) ; 
 
 return ;
}

/*******************************************************************
                       CDATA section end handler
*******************************************************************/

void 
cdend(void *data) 
{ const 
    char close_CDATA_section[]= "]]>" ; 
 
 char *token=NULL ;
 
 int token_len=0 ;

 unsigned 
   char physic_flag=0u ; 
 
 char *entity=NULL ; 
 
 int entity_len=0 ; 

 int buffer_length=0 ; 

 // ..
 // ..   
 // ..   cdend - ANALYZES THE TEXTBUFFER
 // ..
 // ..

 // checks if there is a token in the buffer
 if (text_in_buffer(&textbuffer)) { 

   buffer_length=get_buffer_length(&textbuffer) ; 
   
   // allocates the memory needed to contain the token in the buffer
   token=(char *) malloc((buffer_length+1)*sizeof(char)) ; 
   
   buffer_length=get_text_in_buffer(&textbuffer,
				    token) ; 
   
   token[buffer_length]='\0' ; 
   
   undercase(token, 
	     buffer_length) ; 
   
   // checks if the proximity must be computed 
   if (proximity_flag) { // if enters this block the proximity must be computed

     // inserts the token in the textbuffer with its proximity 
     // in the words dictionary 
     number_tokens+=hinsert((char *) token, 
			    buffer_length, 
			    WORD,
			    (char *) NULL, 
			    ht, 
			    proximity_counter, 
			    0, 
			    ((0x00) | _INSERT_LOGICAL_OCCURRENCE)) ; 
     
     // increases the proximity
     ++proximity_counter ; 
   }
   
   else

     // in this case the proximity must not be computed, inserts
     // the token in the dictionary as a logical token 
     number_tokens+=hinsert((char *) token, 
			    buffer_length, 
			    WORD,
			    (char *) NULL, 
			    ht, 
			    0, 
			    0, 
			    (0x00)) ; 
 }

 // ..
 // ..   
 // ..   cdend - CHECKS IF THERE'S CORRESPONDENCE
 // ..   BETWEEN LOGICAL AND PHYSICA VIEWS
 // ..

 // checks is there's correspondence between
 // logical and physical views
 physic_flag=phy_corr(&entity,
		      &entity_len,
		      1) ;
 
 if (physic_flag) { // if enters this block there's correspondence
                    // between logical and physical views

   // checks if the debugging information must be printed 
   if (verbosing_flag)
     
     fprintf(debugPhysicView, "%s", close_CDATA_section) ; 
   
   // inserts the close_CDATA_section string (']]>')
   number_tokens+=hinsert((char *) close_CDATA_section, 
			  strlen(close_CDATA_section),
			  WORD, 
			  (char *) NULL, 
			  ht, 
			  0,
			  0, 
			  ((0x00) | _INCREASE_PHYSICAL_COUNT)) ;
 }
 
 // set to 0 the CDATA section flag
 expat_CDATA_section_flag=0u ; 
 
 // checks if the CDATA section is in an expansion of an internal entity 
 if ((!physic_flag) && (expat_CDATA_expansion_flag)) 
 
   // if the CDATA section is in an expansion of an internal entity 
   // put to 0 the flag 
   expat_CDATA_expansion_flag=0u ; 
 
 // increases the physical position 
 xml_position+=strlen(close_CDATA_section) ; 
 
 // frees the memory allocated 
 if (entity != NULL)
   
   free(entity) ; 
 
 if (token != NULL)
   
   free(token) ; 
 
 return ; 
}

void 
cdendcod(void *data) 
{ const 
    char open_CDATA_section[] = "<![CDATA["; 
 
 const 
   char close_CDATA_section[]= "]]>" ;  
 
 char *token=NULL ; 
 
 int buffer_length=0 ; 

 char *entity=NULL ;
 
 int entity_len=0 ; 

 // ..
 // ..   
 // ..   cdendcod - ANALYZES THE TEXTBUFFER
 // ..
 // ..
 
 // checks if there's a token in the buffer
 if (text_in_buffer(&textbuffer)) { 

   buffer_length=get_buffer_length(&textbuffer) ;
   
   // allocates the memory needed to contain the token in the 
   // buffer 
   token = (char *) malloc((buffer_length+1)*sizeof(char)) ; 
   
   buffer_length=get_text_in_buffer(&textbuffer, 
				    token) ; 
   
   token[buffer_length]='\0' ; 
   
   undercase(token, 
	     buffer_length) ; 
   
   // checks if there's a correspondence between logical and physical
   // views 
   if (physical_correspondence)
     
     // there's a correspondence between logical and physical
     // views, so inserts the physical position associated to 
     // the token in the words dictionary 
     hinsert((char *) token, 
	     strlen(token),
	     WORD,
	     (char *) NULL, 
	     ht, 
	     last_body_position_written,
	     0,
	     ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
   
   else
     
     { // if enters this block there isn't a correspondence between
       // logical and physical views 

       // inserts the escape position associated to the token 
       // in the words dictionary 
       hinsert((char *) token, 
	       strlen(token),
	       WORD,
	       (char *) NULL, 
	       ht, 
	       last_body_position_written,
	       elementRank,
	       ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
     
       // increases the rank of the element 
       ++elementRank ; 
     }
 }

 // ..
 // ..   
 // ..   cdendcod - CHECKS IF THERE'S CORREPONDENCE
 // ..   BETWEEN LOGICAL AND PHYSICAL VIEWS 
 // ..

 if (physical_correspondence) 
   
   // if there's a correspondence between logical 
   // and physical views for the text in the buffer
   // updates the position 
   last_body_position_written=body_size_without_zlib ; 
 
 // updates the last physical correspondence
 last_physical_correspondence=physical_correspondence ; 
 
 // checks if there's a correspondence between logical
 // and physical views
 physical_correspondence=phy_corr(&entity,
				  &entity_len,
				  0) ; 
 
 if (physical_correspondence) { // if enters this block there's correspondence
                                // between logical and physical views 

   // inserts the physical position associated with the open CDATA section string ('<![CDATA[') in the
   // tags dictionary 
   hinsert((char *) open_CDATA_section,
	   strlen(open_CDATA_section), 
	   TAG,
	   (char *) NULL, 
	   ht, 
	   last_body_position_written,
	   0,
	   ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
   
   // writes the CDATA_section_string 
   output_token((char *) close_CDATA_section,
		strlen(close_CDATA_section),
		WORD) ; 
   
   // updates the physical position 
   last_body_position_written=body_size_without_zlib ; 
 }
 
 else { // if enters this block means that there isn't 
        // correspondence between logical and physical views

   // inserts the escape position associated with the open_CDATA_section string
   // in the tags dictionary 
   hinsert((char *) open_CDATA_section,
	   strlen(open_CDATA_section),
	   TAG, 
	   (char *) NULL, 
	   ht, 
	   last_body_position_written,
	   elementRank,
	   ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
   
   // increases the element rank counter 
   ++elementRank ; 
 }
 
 // set to 0 the flag that says if it's in a CDATA section 
 expat_CDATA_section_flag=0u ; 
 
 // increases the pointer to the text 
 xml_position+=strlen(close_CDATA_section) ; 
 
 if ((!physical_correspondence) && (expat_CDATA_expansion_flag))
     
   expat_CDATA_expansion_flag=0u ; 
 
 if (token != NULL)
   
   free(token) ; 
 
 if (entity != NULL)
   
   free(entity) ; 
 
 return ; 
}

void 
cdendwrite(void *data) 
{ const 
    char open_CDATA_section[] = "<![CDATA["; 
 
 const 
   char close_CDATA_section[]= "]]>" ;  
 
 char *token=NULL ; 
 
 int buffer_length=0 ; 

 char *entity=NULL ;
 
 int entity_len=0 ; 

 // ..
 // ..   
 // ..   cdendwrite - ANALYZES THE TEXTBUFFER
 // ..
 // ..

 // checks if there's a token in the buffer
 if (text_in_buffer(&textbuffer)) { 

   buffer_length=get_buffer_length(&textbuffer) ;
   
   // allocates the memory needed to contain the token in the
   // buffer
   token = (char *) malloc((buffer_length+1)*sizeof(char)) ; 
   
   buffer_length=get_text_in_buffer(&textbuffer, 
				    token) ; 
   
   token[buffer_length]='\0' ; 
   
   undercase(token, 
	     buffer_length) ; 

   // checks if the proximity must be computed 
   if (proximity_flag) { // if enters this block the proximity must be computed

     // writes the proximity associated with the token in the textbuffer 
     // in the IL file 
     number_tokens+=hinsert((char *) token, 
			    buffer_length, 
			    WORD,
			    (char *) NULL, 
			    ht, 
			    proximity_counter, 
			    0, 
			    ((0x00) | _INSERT_LOGICAL_OCCURRENCE)) ; 
     
     // increases the proximity counter
     ++proximity_counter ; 
   }

   // checks if the proximity must be computed
   if (physical_correspondence) { // if enters in this block the proximity must be computed
     
     // writes the proximity associated to the token in the textbuffer
     // in the IL file 
     hinsert((char *) token, 
	     strlen(token),
	     WORD,
	     (char *) NULL, 
	     ht, 
	     last_body_position_written,
	     0,
	     ((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ; }
   
   else
     
     { // if enters in this block there isn't physical correspondence between 
       // logical and physical views

       // writes the escape position of the token in the textbuffer
       // in the IL file 
       hinsert((char *) token, 
	       strlen(token),
	       WORD,
	       (char *) NULL, 
	       ht, 
	       last_body_position_written,
	       elementRank,
	       ((0x00) | _WRITE_PHYSIC_ESCAPE)) ; 
     
       // increases the element rank 
       ++elementRank ; 
     }
 }
 
 // ..
 // ..   
 // ..   cdendwrite - CHECKS IF THERE'S CORREPONDENCE
 // ..   BETWEEN LOGICAL AND PHYSICAL VIEWS 
 // ..
 
 if (physical_correspondence) 
   
   // if there's a correspondence between logical 
   // and physical views for the text in the buffer
   // updates the position 
   last_body_position_written=body_size_without_zlib ; 
 
 // updates the last physical correspondence
 last_physical_correspondence=physical_correspondence ; 
 
 // checks if there's a correspondence between logical
 // and physical views
 physical_correspondence=phy_corr(&entity,
				  &entity_len,
				  2) ; 
 
 if (physical_correspondence) { // if enters this block there's correspondence
   // between logical and physical views 
   
   // writes the physical position associated with the open_CDATA_section string
   // in the IL file 
   hinsert((char *) open_CDATA_section,
	   strlen(open_CDATA_section), 
	   TAG,
	   (char *) NULL, 
	   ht, 
	   last_body_position_written,
	   0,
	   ((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ; 
   
   // computes the codeword length of the close_CDATA_section
   // string 
   nooutput_token((char *) close_CDATA_section,
		  strlen(close_CDATA_section),
		  WORD) ; 
   
   // updates the last body position written 
   last_body_position_written=body_size_without_zlib ; 
 }
 
 else { //  if enters this block means that there isn't 
   // correspondence between logical and physical views
   
   // writes the escape position of the open_CDATA_section string
   // in the IL file 
   hinsert((char *) open_CDATA_section,
	   strlen(open_CDATA_section),
	   TAG, 
	   (char *) NULL, 
	   ht, 
	   last_body_position_written,
	   elementRank,
	   ((0x00) | _WRITE_PHYSIC_ESCAPE)) ; 
   
   // increases the element rank 
   ++elementRank ; 
 }
 
 // set to 0 the flag that indicates if it's in a CDATA section 
 expat_CDATA_section_flag=0u ; 
 
 // increases the pointer to the text 
 xml_position+=strlen(close_CDATA_section) ; 
 
 if ((!physical_correspondence) && (expat_CDATA_expansion_flag))
   
   expat_CDATA_expansion_flag=0u ; 
 
 // frees the memory allocated
 if (token != NULL)
   
   free(token) ; 
 
   if (entity != NULL)
     
     free(entity) ; 
   
   return ; 
}

/*******************************************************************
                          comment handler
*******************************************************************/
void comment(void *userData,
	     const char *data)

{ register
    int k=0 ; 

 const 
   char open_COMMENT[] = "<!--"; 
 
 const 
   char close_COMMENT[]="-->" ; 
 
 char *token=NULL ;  
 
 char *entity=NULL ; 
 
 int entity_len=0 ; 
 
 int buffer_length=0 ; 
 
 unsigned 
   char physic_flag=0u ; 
 
 int token_len=0 ; 
 
 int textcount=0 ; 
 
 int num_seps=0 ; 
 
 char seps[XCDE_MAX_SEPARATORS_BLOCK+1] ; 
 
 char separator ; 

 // ..
 // ..   
 // ..   comment - ANALYZES THE TEXTBUFFER
 // ..
 
 // checks if there's a token in the text 
 if (text_in_buffer(&textbuffer)) { 
   
   buffer_length=get_buffer_length(&textbuffer) ; 
   
   // allocates the memory needed to contain the token 
   token = (char *) malloc((buffer_length+1)*sizeof(char)) ; 
   
   buffer_length=get_text_in_buffer(&textbuffer,
				    token) ; 
   
   token[buffer_length]= '\0' ; 
    
   undercase(token, 
	      buffer_length) ; 
   
   // checks if the proximity must be computed
   if (proximity_flag) { // if enters this block the proximity must be computed

     // inserts the token extracted from textbuffer in the words dictionary
     // as a physical token 
     number_tokens+=hinsert((char *) token, 
			    buffer_length, 
			    WORD,
			    (char *) NULL, 
			    ht, 
			    proximity_counter, 
			    0, 
			    ((0x00) | _INSERT_LOGICAL_OCCURRENCE)) ;  

     // increases the proximity counter
     ++proximity_counter ; 
   }
   
   else

     // there isn't correspondence between logical and 
     // physical views, so inserts the token extracted from 
     // the textbuffer in the words dictionary as a logical
     // token 
     number_tokens+=hinsert((char *) token, 
			    buffer_length, 
			    WORD,
			    (char *) NULL, 
			    ht, 
			    0, 
			    0, 
			    (0x00)) ; 
 }

 // ..
 // ..   
 // ..   comment - CHECKS IF THERE IS CORRESPONDENCE
 // ..   BETWEEN LOGICAL AND PHYSICAL VIEWS 
 // ..
 
 // checks if there's correspondence
 // between logical and physical views
 physic_flag=phy_corr(&entity,
		      &entity_len,
		      1) ;
 
 if (physic_flag) { // if enters this block there's correspondence
                    // between logical and physical views
   
   // inserts the open_COMMENT string in the tags dictionary 
   // as a physical token 
   number_tokens+=hinsert((char *) open_COMMENT,
			  strlen(open_COMMENT),
			  TAG,
			  (char *) NULL, 
			  ht, 
			  0, 
			  0, 
			  ((0x00) | _INCREASE_PHYSICAL_COUNT)) ; 

   // checks if debugging information must be printed 
   if (verbosing_flag) 
     
     fprintf(debugPhysicView, "%s", open_COMMENT) ; 
 }
 
 else
  
   // there isn't correspondence between logical and physical
   // views, so inserts open_COMMENT string in the tags dictionary
   // as a logical token 
   number_tokens+=hinsert((char *) open_COMMENT,
			  strlen(open_COMMENT), 
			  TAG,
			  (char *) NULL,
			   ht,
			  0,
			  0, 
			  (0x00)) ; 
 
 // increases the position in the text
 xml_position+=strlen(open_COMMENT) ; 
 
 // ..
 // ..   
 // ..   comment - LOOPS OVER THE TEXT OF THE COMMENT
 // .. 

 while(textcount < strlen(data)) { 
   
   do { num_seps=0 ; 
     
   while((textcount < strlen(data)) && 
	 (num_seps < XCDE_MAX_SEPARATORS_BLOCK) &&
	 ((token_len = get_next_token((char *) data+textcount, 
				      " \t\n", 
				      &separator, 
				      strlen(data)-textcount)) == 0)) { 
     
     // increases the text counter
     textcount+=1 ; 
       
     // increases the text position 
     xml_position+=1 ; 
     
     // copies the separator character in the characters buffer
     seps[num_seps]=separator ;

     // increases the number of character in the buffer
     ++num_seps ; 
   }		    
     
   // checks if there're some characters in the buffer and there's
   // physical correspondence between logical and physical views 
   if ((physic_flag) && (num_seps > 0)) { // if enters this block there're some characters in the
                                          // buffer and there's physical correspondence, so 
                                          // the separators must be insertes as a physical token 

     seps[num_seps]='\0' ; 
       
     // checks if the debugging information must be printed
     if (verbosing_flag) 
       
       fprintf(debugPhysicView, "%s", seps) ; 
     
     // inserts separators in the words dictionary as a 
     // physical token 
     number_tokens+=hinsert((char *) seps,
			    strlen(seps),
			    WORD,
			    (char *) NULL, 
			    ht, 
			    0,
			    0, 
			    ((0x00) | _INCREASE_PHYSICAL_COUNT)) ;
       }
   
   } while((token_len==0) && (textcount < strlen(data))) ; 
   
   // frees the memory needed to contain the token 
   if (token != NULL)
     
     free(token) ; 
   
   // allocates the memory needed to contain the token 
   token = (char *) malloc((token_len+1)*sizeof(char)) ; 
   
   // copies the token in the memory allocated
   for(k=0;k<token_len;++k) { 
     
     // checks if the debugging information must be printed
     if ((physic_flag) && (verbosing_flag))
       
       fprintf(debugPhysicView, "%c", data[textcount+k]) ;
     
     token[k]=data[textcount+k] ; 
   }
   
   token[k]='\0' ;
   
   if (physic_flag)
     
     // there's correspondence between logical and physical views, so the token
     // individuated in the comment text must be inserted as a physical token
     number_tokens+=hinsert((char *) token,
			    token_len,
			    WORD,
			    (char *) NULL,
			    ht,
			    0, 
			    0, 
			    ((0x00) | _INCREASE_PHYSICAL_COUNT)) ; 
   
   // increases the text counter
   textcount+=token_len ; 
   
   // increases the position in the text 
   xml_position+=token_len ; 
 }

 // ..
 // ..   comment - INSERTS THE CLOSE_COMMENT STRING AND FREES THE MEMORY 
 // ..   ALLOCATED
 // ..   

 if (physic_flag) {  // if enters this block there's correspondence
                     // between logical and physical views, so the
                     // close_COMMENT string must be inserted as a
                     // physical token 
   
   // inserts the close_COMMENT string as a physical token in the
   // words dictionary 
   number_tokens+=hinsert((char *) close_COMMENT,
			  strlen(close_COMMENT),
			  WORD,
			  (char *) NULL, 
			  ht, 
			  0, 
			  0, 
			  ((0x00) | _INCREASE_PHYSICAL_COUNT)) ; 
   
   // checks if the debugging information must be printed
   if (verbosing_flag) 
     
     fprintf(debugPhysicView, "%s", close_COMMENT) ;     
 }
 
 // increases the position of the pointer 
 xml_position+=strlen(close_COMMENT) ; 
  
 // frees the memory allocated
 if (token != NULL)
   
   free(token) ; 
 
 if (entity != NULL)
   
   free(entity) ; 
 
 return ; 
}

void commentcod(void *userData,
		const char *data)
     
{ register
    int k=0 ; 
 
 const 
   char open_COMMENT[] = "<!--"; 
 
 const 
   char close_COMMENT[]="-->" ; 
 
 char *token=NULL ;  
 
 char *entity=NULL ; 
 
 int entity_len=0 ; 
 
 int buffer_length=0 ; 
 
 int token_len=0 ; 
 
 int textcount=0 ; 
 
 int num_seps=0 ; 
 
 char seps[XCDE_MAX_SEPARATORS_BLOCK+1] ; 
 
 char separator ; 

 // ..
 // ..   
 // ..   commentcod - ANALYZES THE TEXTBUFFER
 // ..

 // checks if there's a token in the text 
 if (text_in_buffer(&textbuffer)) { 

    buffer_length=get_buffer_length(&textbuffer) ; 

    // allocates the memory needed to contain the token 
    token = (char *) malloc((buffer_length+1)*sizeof(char)) ; 
    
    buffer_length=get_text_in_buffer(&textbuffer,
				     token) ; 
    
    token[buffer_length]= '\0' ; 
   
    undercase(token, 
	      buffer_length) ; 
    
    // checks if there's a correspondence between logical
    // and physical views 
    if (physical_correspondence) 
      
      // there's correspondence between logical and physical views so inserts the physical 
      // position of token extracted from the textbuffer in the words dictionary 
      hinsert((char *) token, 
	      strlen(token), 
	      WORD,
	      (char *) NULL, 
	      ht, 
	      last_body_position_written,
	      0,
	      ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
    
    else { // if enters in this block there isn't correspondence between logical and
           // physical views 

      // inserts the escape position of the token extracted from the textbuffer
      // in the words dictionary 
      hinsert((char *) token, 
	      strlen(token),
	      WORD,
	      (char *) NULL, 
	      ht, 
	      last_body_position_written,
	      elementRank,
	      ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
      
      // increases the element rank 
      ++elementRank ; 
    }
 }

 // ..
 // ..   
 // ..   commentcod - CHECKS IF THERE IS CORRESPONDENCE
 // ..   BETWEEN LOGICAL AND PHYSICAL VIEWS 
 // .. 

 // checks if there's correspondence between logical and 
 // physical views
 if (physical_correspondence)
    
   // updates the physical position 
   last_body_position_written=body_size_without_zlib ; 
  
  // updates the last physical correspondence flag 
  last_physical_correspondence=physical_correspondence ; 
  
  // checks if there's correspondence between logical and
  // physical views 
  physical_correspondence=phy_corr(&entity,
				   &entity_len,
				   0) ; 
  
  if (physical_correspondence) { // if enters this block there's correspondence
                                 // between logical and physical views

    // inserts the physical position associated with the open_COMMENT string 
    // in the tags dictionary 
    hinsert((char *) open_COMMENT,
	    strlen(open_COMMENT), 
	    TAG,
	    (char *) NULL, 
	    ht, 
	    last_body_position_written, 
	    0,
	    ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
    
    // writes the codeword of the open_COMMENT string in
    // the body file 
    output_token((char *) open_COMMENT,
		 strlen(open_COMMENT),
		 TAG) ; 
    
    // updates the physical position 
    last_body_position_written=body_size_without_zlib ;
  }
  
  else { // if enters this block there isn't correspondence between 
         // logical and physical views
    
    // inserts the escape position associated with the open_COMMENT
    // string in the tags dictionary 
    hinsert((char *) open_COMMENT,
	    strlen(open_COMMENT), 
	    TAG,
	    (char *) NULL, 
	    ht, 
	    last_body_position_written,
	    elementRank,
	    ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
    
    // increases the element rank 
    ++elementRank ; 
  }

  // ..
  // ..   
  // ..   commentcod - LOOPS OVER THE TEXT OF THE COMMENT
  // .. 

  while(textcount < strlen(data)) {
    
    do { num_seps=0 ; 
      
    while((textcount < strlen(data)) && 
	  (num_seps < XCDE_MAX_SEPARATORS_BLOCK) &&
	  ((token_len = get_next_token((char *) data+textcount, 
				       " \t\n", 
				       &separator, 
				       strlen(data)-textcount)) == 0)) { 
      
      // increases the text counter
      textcount+=1 ; 
      
      // increases the text position 
      xml_position+=1 ; 
	
      // copies the separator character in the characters buffer
      seps[num_seps]=separator ;
	
      // increases the number of character in the buffer
      ++num_seps ; 
    }		    

    // checks if there're some characters in the buffer and there's
    // physical correspondence between logical and physical views 
    if ((physical_correspondence) && (num_seps > 0)) { // if enters this block there're some characters in the
                                                       // buffer and there's physical correspondence

      seps[num_seps]='\0' ; 
      
      // writes separators codeword in the body file 
      output_token(seps,
		   strlen(seps),
		   WORD) ; 
	
      // updates the physical position 
      last_body_position_written=body_size_without_zlib ; 
      }
      
    } while((token_len==0) && (textcount < strlen(data))) ; 
    


    // frees the memory needed to contain the token 
    if (token != NULL)
      
      free(token) ; 
    
    // allocates the memory needed to contain the token
    token = (char *) malloc((token_len+1)*sizeof(char)) ; 
    
    // copies the token in the memory allocated
    for(k=0;k<token_len;++k) 
      
      token[k]=data[textcount+k] ; 

    token[k]='\0' ;
    
    // checks if there's correspondence between logical and
    // physical views
    if (physical_correspondence) { // if enters this block there's physical
                                   // correspondence

      // writes the token codeword in the body file 
      output_token(token,
		   strlen(token),
		   WORD) ; 
      
      // updates the physical position 
      last_body_position_written=body_size_without_zlib ; 
    }
    
    // increases the textcounter
    textcount+=token_len ; 
    
    // increases the text pointer 
    xml_position+=token_len ; 
  }

  // ..
  // ..   commentcod - INSERTS THE CLOSE_COMMENT STRING POSITION AND FREES THE MEMORY 
  // ..   ALLOCATED
  // ..   
  
  if (physical_correspondence) { // if there's correspondence between physical and 
                                 // logical views enters in this block  

    // inserts the physical position associated with the open_COMMENT string
    // in the tags dictionary 
    hinsert((char *) open_COMMENT,
	    strlen(open_COMMENT), 
	    TAG,
	    (char *) NULL, 
	    ht, 
	    last_body_position_written,
	    0,
	    ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
    
    // writes the codeword in the body file 
    output_token((char *) close_COMMENT, 
		 strlen(close_COMMENT), 
		 WORD) ; 
    
    // updates the physical position 
    last_body_position_written=body_size_without_zlib ; 
  }
  
  else { // if enters this block there isn't correspondence between logical
         // and physical views

    // inserts the escape position associated with the open_COMMEN string in the
    // tags dictionary 
    hinsert((char *) open_COMMENT, 
	    strlen(open_COMMENT),
	    TAG, 
	    (char *) NULL, 
	    ht, 
	    last_body_position_written,
	    elementRank,
	    ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
    
    // increases the rank of the element 
    ++elementRank ; 
  }
  
  // increases the text pointer 
  xml_position+=strlen(close_COMMENT) ; 
  
  // frees the memory allocated
  if (token != NULL)
    
    free(token) ; 
  
  if (entity != NULL)
    
    free(entity) ; 
  
  return ; 
}

void commentwrite(void *userData,
		  const char *data)
     
{ register
    int k=0 ; 
 
 const 
   char open_COMMENT[] = "<!--"; 
 
 const 
   char close_COMMENT[]="-->" ; 
 
 char *token=NULL ;  
 
 char *entity=NULL ; 
 
 int entity_len=0 ; 
 
 int buffer_length=0 ; 
 
 int token_len=0 ; 
 
 int textcount=0 ; 
 
 int num_seps=0 ; 
 
 char seps[XCDE_MAX_SEPARATORS_BLOCK+1] ; 
 
 char separator ; 
 
 // ..
 // ..   
 // ..   commentwrite - ANALYZES THE TEXTBUFFER
 // ..

 // checks if there's a token in the text 
 if (text_in_buffer(&textbuffer)) { 
   
   buffer_length=get_buffer_length(&textbuffer) ; 
   
   // allocates the memory needed to contain the token
   token = (char *) malloc((buffer_length+1)*sizeof(char)) ; 
   
   buffer_length=get_text_in_buffer(&textbuffer,
				    token) ; 
   
   token[buffer_length]= '\0' ; 
   
   undercase(token, 
	     buffer_length) ; 
   
   // checks if the proximity must be computed
   if (proximity_flag) { // if enters in this block the proximity must be
                         // computed
     
     // writes the proximity associated with the token exctracted from
     // the textbuffer in the IL file 
     hinsert((char *) token, 
	     buffer_length, 
	     WORD, 
	     (char *) NULL, 
	     ht, 
	     proximity_counter,
	     0,
	     ((0x00) | _WRITE_LOGICAL_OCCURRENCE)) ;  
     
     // increases the proximity counter 
     ++proximity_counter ;     
   }
   
   if (physical_correspondence) 

     // there's correspondence between physical and logical views, so writes
     // the physical position associated with the token extracted from the
     // textbuffer in the IL file 
     hinsert((char *) token, 
	     strlen(token), 
	     WORD,
	     (char *) NULL, 
	     ht, 
	     last_body_position_written,
	     0,
	     ((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ; 
   
   else { // if enters this block there isn't correspondence between logical 
          // and physical views 
     
     // writes the escape position associated with the token extracted from the 
     // textbuffer in the IL file 
     hinsert((char *) token, 
	     strlen(token),
	     WORD,
	     (char *) NULL, 
	     ht, 
	     last_body_position_written,
	     elementRank,
	     ((0x00) | _WRITE_PHYSIC_ESCAPE)) ; 
     
     // increases the rank of the element 
     ++elementRank ; 
   }
 }

 // ..
 // ..   
 // ..   commentwrite - CHECKS IF THERE IS CORRESPONDENCE
 // ..   BETWEEN LOGICAL AND PHYSICAL VIEWS 
 // .. 

 // checks if there's correspondence between logical and 
 // physical views
 if (physical_correspondence)
   
   // update the physical position 
   last_body_position_written=body_size_without_zlib ; 
 
 // updates the last physical correspondence flag
 last_physical_correspondence=physical_correspondence ; 
 
 // checks if there's correspondence between logical 
 // and physical views
 physical_correspondence=phy_corr(&entity,
				  &entity_len,
				  2) ; 
  
 if (physical_correspondence) { // if enters this block there's correspondence
                                // between logical and physical views
    
   // writes the physical position associated with the open_COMMEN string
   // in the IL file 
   hinsert((char *) open_COMMENT,
	   strlen(open_COMMENT), 
	   TAG,
	   (char *) NULL, 
	   ht, 
	   last_body_position_written, 
	   0,
	   ((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ; 
    
   // computes the length of the open_COMMENT string codeword
   nooutput_token((char *) open_COMMENT,
		  strlen(open_COMMENT),
		  TAG) ; 
    
   // updates the last body position written 
   last_body_position_written=body_size_without_zlib ;
 }
  
 else { // if enters this block there isn't correspondence
        // between logical and physical views
   
   // writes the escape position associated with the
   // open_COMMENT string in the IL file 
   hinsert((char *) open_COMMENT,
	   strlen(open_COMMENT), 
	   TAG,
	   (char *) NULL, 
	   ht, 
	   last_body_position_written,
	   elementRank,
	   ((0x00) | _WRITE_PHYSIC_ESCAPE)) ; 
   
   // increases the rank of the element 
   ++elementRank ; 
 }

 // ..
 // ..   
 // ..   commentwrite - LOOPS OVER THE TEXT OF THE COMMENT
 // .. 

 while(textcount < strlen(data)) {
   
   do { num_seps=0 ; 
      
      while((textcount < strlen(data)) && 
	    (num_seps < XCDE_MAX_SEPARATORS_BLOCK) &&
	    ((token_len = get_next_token((char *) data+textcount, 
					 " \t\n", 
					 &separator, 
					 strlen(data)-textcount)) == 0)) { 
	
	// increases the text counter
	textcount+=1 ; 
	
	// increases the text position 
	xml_position+=1 ; 
	
	// copies the separator character in the characters buffer
	seps[num_seps]=separator ;
	
	// increases the number of separators
	++num_seps ; 
      }		    

      // checks if there're some characters in the buffer and there's
      // physical correspondence between logical and physical views 
      if ((physical_correspondence) && (num_seps > 0)) {  // if enters this block there're some characters in the
	                                                  // buffer and there's physical correspondence 

	seps[num_seps]='\0' ; 
	
	// computes the codeword lenght of separators string  
	nooutput_token(seps,
		       strlen(seps),
		       WORD) ; 
	
	// updates the last body position written 
	last_body_position_written=body_size_without_zlib ; 
      }
      
    } while((token_len==0) && (textcount < strlen(data))) ; 
    
   // frees the memory allocated
   if (token != NULL)
     
     free(token) ; 
   
   // allocates the memory needed to contain the token 
   token = (char *) malloc((token_len+1)*sizeof(char)) ; 
   
   // copies the token in the memory allocated
   for(k=0;k<token_len;++k) 
     
     token[k]=data[textcount+k] ; 
   
   token[k]='\0' ;
   
   // checks if there's correspondence between logical and
   // physical views
   if (physical_correspondence) { // if enters this block there's physical
                                  // correspondence

     // computes the token length 
     nooutput_token(token,
		    strlen(token),
		    WORD) ; 
     
     // updates the physical position 
     last_body_position_written=body_size_without_zlib ; 
   }
   
   // increases the text counter
   textcount+=token_len ; 
   
   // increases the text position 
   xml_position+=token_len ; 
 }

 // ..
 // ..   commentwrite - INSERTS THE CLOSE_COMMENT STRING POSITION AND FREES THE MEMORY 
 // ..   ALLOCATED
 // ..   
 
 
 if (physical_correspondence) { // if there's correspondence between physical and 
                                // logical views enters in this block  

   // writes the open_COMMENT string physical position in the 
   // tags dictionary 
   hinsert((char *) open_COMMENT,
	   strlen(open_COMMENT), 
	   TAG,
	   (char *) NULL, 
	   ht, 
	   last_body_position_written,
	   0,
	   ((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ; 
   
   // computes the close_COMMENT strint codeword length 
   nooutput_token((char *) close_COMMENT, 
		  strlen(close_COMMENT), 
		  WORD) ; 
   
   // updates the physical position 
   last_body_position_written=body_size_without_zlib ; 
 }
 
 else { // if enters this block there isn't correspondence between logical
        // and physical views
   
   // writes the escape position associated with the open_COMMENT string
   // to the IL file 
   hinsert((char *) open_COMMENT, 
	   strlen(open_COMMENT),
	   TAG, 
	   (char *) NULL, 
	   ht, 
	   last_body_position_written,
	   elementRank,
	   ((0x00) | _WRITE_PHYSIC_ESCAPE)) ; 
   
   // increases the element rank 
   ++elementRank ; 
 }
 
 // increases the pointer to the text
 xml_position+=strlen(close_COMMENT) ; 
 
 // frees the memory allocated 
 if (token != NULL)
   
   free(token) ; 
 
 if (entity != NULL)
   
   free(entity) ; 
 
 return ; 
}

/*******************************************************************
			default handler
*******************************************************************/

void defa(void *data,
	  const XML_Char *s,
	  int len) 
{ // variable used as counter 
  register 
    int k=0 ;  
 
  unsigned 
    char physic_flag=0u ; 

  char *entity=NULL ; 
  
  int entity_len=0 ; 

  int buffer_length=0 ; 
  
  char *token=NULL ; 

  int token_len=0 ; 

  int textcount=0 ; 

  int num_seps=0 ; 

  char seps[XCDE_MAX_SEPARATORS_BLOCK+1] ; 
 
  char separator ; 

  // ..
  // ..   defa - CHECKS IF THERE'S CORRESPONDENCE BETWEEN LOGICAL 
  // ..   AND PHYSICAL VIEWS
  // ..   
    
  physic_flag=phy_corr(&entity,
		       &entity_len,
		       1) ;

  // ..
  // ..  defa - ANALYZES THE TEXT
  // ..   

  // checks if the entity is an external general entity 
  // which isn't a separator, and that it's in the text
  if ((!physic_flag) &&
      (expat_number_tag_opened > 0) &&
      (len == entity_len) && 
      (strncmp(s,
	       entity,
	       len) ==0) &&
      (!hsearch(entity,
		entity_len,
		NOTHING,
		expat_separators_table))) { // if enters in this block the entity is an external general entity which isn't a separator
                                            // and is in the text, so it must be inserted in the textbuffer

    // inserts the element into the buffer 
    insert_buffer(&textbuffer,
		  entity,
		  entity_len) ; 
    
    // increases the pointer to the text
    xml_position+=entity_len ; 
   
    // frees the memory allocated
    if (entity != NULL)
      
	free(entity) ; 
    
    return ; 
  }
  
  else 
    
    // checks if it's an external general entity which is a separator
    // and there's a token in the textbuffer
    if ((!physic_flag) &&
	(expat_number_tag_opened > 0) && 
	(entity_len == len) &&
	(strncmp(s,
		 entity,
		 len) ==0) &&
	text_in_buffer(&textbuffer)) { // if enters this block it's an external general entity which is 
                                       // a separator and it's a token in the textbuffer, so it must be
                                       // extracted

      buffer_length = get_buffer_length(&textbuffer) ; 

      // allocates the memory needed to contain the token 
      token = (char *) malloc((buffer_length+1)*sizeof(char)) ; 
      
      buffer_length=get_text_in_buffer(&textbuffer,
				       token) ; 
      
      token[buffer_length]='\0' ; 
      
      undercase(token,
		buffer_length) ; 
      
      // checks if the proximity must be computed
      if (proximity_flag) { // if enters this block the proximity must be computed 

	// inserts the token extracted from the textbuffer in the words dictionary as a 
	// logical token with the proximity associated with it
	number_tokens+=hinsert((char *) token,
			       strlen(token),
			       WORD,
			       (char *) NULL,
			       ht, 
			       proximity_counter, 
			       0, 
			       ((0x00) | _INSERT_LOGICAL_OCCURRENCE)) ; 
	
	// increases the proximity counter
	++proximity_counter ; 
      }

      else 
	
	// inserts the token extracted from the textbuffer in the words dictionary
	// as a logical token 
	number_tokens+=hinsert((char *) token,
			       strlen(token), 
			       WORD,
			       (char *) NULL,
			       ht, 
			       0, 
			       0, 
			       (0x00)) ; 
			      
      // increases the position 
      xml_position+=entity_len ; 
      
      // frees the memory allocated 
      if (token != NULL)
	
	free(token) ; 
      
      if (entity != NULL)
	
	free(entity) ; 
      
      return ; 
    }
  
    else
      
      // checks it's an external entity which isn't a separator and which is contained
      // in an internal entity expansion 
      if ((!physic_flag) && 
	  (expat_number_tag_opened > 0) &&
	  ((strncmp(s,
		    entity,
		    len) != 0) || (entity_len != len)) &&
	  (!hsearch((char *) s,
		    len,
		    NOTHING,
		    expat_separators_table))) { // if enters this block it's an external entity which isn't a separator
	                                        // and is contained in an internal entity expansion 

	// the entity is put into the buffer
	insert_buffer(&textbuffer,
		      (char *) s,
		      len) ; 
	
	// increases the pointer to the text 
	xml_position+=len ; 
	
	// frees the memory allocated 
	if (entity != NULL)
	  
	  free(entity) ; 
	
	return ; 
      }
  
      else
	
	// checks if it's an external entity which is a separator and is contained 
	// in an internal entity expansion 
	if ((!physic_flag) && 
	    (expat_number_tag_opened > 0) &&
	    ((strncmp(s,
		      entity,
		      len) != 0) || (entity_len != len)) &&
	    (!hsearch((char *) s,
		      len,
		      NOTHING,
		      expat_separators_table))) { // if enters this block it's an external entity which is a 
	                                          // separator and is contained in an internal entity expansion

	  buffer_length=get_buffer_length(&textbuffer) ; 
	  
	  // allocates the memory to contain the token 
	  token = (char *) malloc((buffer_length+1)*sizeof(char)) ; 
	  
	  buffer_length=get_text_in_buffer(&textbuffer,
					   token) ; 
	  
	  token[buffer_length]='\0' ; 
	  
	  undercase(token,
		    buffer_length) ; 
	  
	  // checks if the proximity must be computed
	  if (proximity_flag) { // if enters this block the proximity must be computed 

	    // inserts the token in the words dictionary as a logical token 
	    // with the proximity associated with it
	    number_tokens+=hinsert((char *) token,
				   strlen(token), 
				   WORD,
				   (char *) NULL,
				   ht, 
				   proximity_counter, 
				   0, 
				   ((0x00) | _INSERT_LOGICAL_OCCURRENCE)) ; 
	    
	    // increases the proximity counter 
	    ++proximity_counter ; 
	  }
	  
	  else
	    
	    // inserts the token in the words dictionary as a logical token with the 
	    // proximity associated with it
	    number_tokens+=hinsert((char *) token,
				   strlen(token), 
				   WORD,
				   (char *) NULL,
				   ht, 
				   0, 
				   0, 
				   (0x00)) ; 
	    
	  // increases the text pointer
	  xml_position+=len ; 
	  
	  // frees the memory associated
	  if (entity != NULL)
	    
	    free(entity) ; 
	  
	  if (token != NULL)
	    
	    free(token) ; 
	  
	  return ; 
	}
  
	else

	  // it's not an entity, so analyzes the text 
	  while(textcount < len) { // loops over the text
	    
	  do { num_seps=0 ; 
	  
	    while((textcount < len) && 
		  (num_seps < XCDE_MAX_SEPARATORS_BLOCK) &&
		  ((token_len = get_next_token((char *) s+textcount, 
					       " \t\n", 
					       &separator, 
					       len-textcount)) == 0)) { // if enters this block the character is a separator
	      
	      // checks if there's a text in the buffer
	      if (text_in_buffer(&textbuffer)) { // if enters this block there's a text in the buffer

		buffer_length=get_buffer_length(&textbuffer) ; 
		
		// allocated the memory needed to contain the token extracted from the textbuffer
		token=(char *) malloc((buffer_length+1)*sizeof(char)) ; 
		
		buffer_length=get_text_in_buffer(&textbuffer,
						 token) ; 
		
		token[buffer_length]='\0' ; 
		
		undercase(token, 
			  buffer_length) ; 

		// checks if the proximity must be computed
		if (proximity_flag) { // if enters this block the proximity must be computed
		  
		  // inserts the token extracted from the textbuffer in the words dictionary 
		  // as a logical token with its proximity 
		  number_tokens+=hinsert((char *) token,
					 buffer_length, 
					 WORD,
					 (char *) NULL,
					 ht, 
					 proximity_counter, 
					 0, 
					 ((0x00) | _INSERT_LOGICAL_OCCURRENCE)) ; 
		  
		  // increases the proximity counter
		  ++proximity_counter ;
		}

		else
		  
		  // inserts the token extracted from the textbuffer in the words dictionary 
		  // as a logical token 
		  number_tokens+=hinsert((char *) token,
					 buffer_length, 
					 WORD,
					 (char *) NULL,
					 ht, 
					 0,
					 0, 
					 (0x00)) ; 
	      }
	      
	      // increases the textcounter
	      textcount+=1 ; 

	      // increases the pointer
	      xml_position+=1 ; 
	      
	      // copies the separator character in the separators buffer
	      seps[num_seps]=separator ;
	      
	      // increases the number of separators 
	      ++num_seps ; 
	    }		    
	    
	    // checks if there's correspondence between logical and physical views and
	    // there're some separators in the separators buffer
	    if ((physic_flag) && (num_seps > 0)) { // if enters this block  there's correspondence between logical and physical views and
	                                           // there're some separators in the separators buffer

	      seps[num_seps]='\0' ; 
	      
	      // checks if the debugging informations must be printed
	      if (verbosing_flag) 
		
		fprintf(debugPhysicView, "%s", seps) ; 
	      
	      // inserts the separators in the words dictionary as a physical token 
	      number_tokens+=hinsert((char *) seps,
				     strlen(seps),
				     WORD,
				     (char *) NULL, 
				     ht, 
				     0,
				     0, 
				     ((0x00) | _INCREASE_PHYSICAL_COUNT)) ;
	    }
	  
	  } while((token_len==0) && (textcount < len)) ; 
	  
	  // checks if all the text has been analyzed
	  if (textcount >= len) break ; 
	  
	  if (text_in_buffer(&textbuffer)) { // if enters this block the character is not a separator
	                                     // and there's a token in the textbuffer, so it must be 
	                                     // extracted
	    
	    buffer_length=get_buffer_length(&textbuffer) ; 
	    
	    // allocates the memory needed to contain the token extracted
	    // from the textbuffer
	    token = (char *) malloc((buffer_length+1)*sizeof(char)) ; 
	    
	    buffer_length = get_text_in_buffer(&textbuffer,
					       token) ; 
	    
	    token[buffer_length]='\0' ; 
	    
	    undercase(token, 
		      buffer_length) ; 
	    
	    // checks if the proximity must be computed
	    if (proximity_flag) { // if enters this block the proximity must be computed

	      // inserts the token extracted from the textbuffer in the words dictionary as a
	      // logical token with the proximity associated with it
	      number_tokens+=hinsert((char *) token,
				     buffer_length,
				     WORD,
				     (char *) NULL,
				     ht, 
				     proximity_counter, 
				     0, 
				     ((0x00) | _INSERT_LOGICAL_OCCURRENCE)) ; 
	      
	      // increases the proximity counter 
	      ++proximity_counter ;
	    }

	    else

	      // inserts the token extracted from the textbuffer in the words dictionary as a
	      // logical token 
	      number_tokens+=hinsert((char *) token,
				     buffer_length,
				     WORD,
				     (char *) NULL,
				     ht, 
				     0, 
				     0, 
				     (0x00)) ; 
	  }

	  // frees the memory allocated
	  if (token != NULL)
	    
	    free(token) ; 
	  
	  // allocates the memory needed to contain the token 
	  token = (char *) malloc((token_len+1)*sizeof(char)) ; 
	  
	  for(k=0;k<token_len;++k) { 

	    // checks if the debugging information must be printed
	    if ((physic_flag) && (verbosing_flag))
	      
	      fprintf(debugPhysicView, "%c", s[textcount+k]) ;

	    // copies the token in the memory allocated
	    token[k]=s[textcount+k] ; 
	  }
	  
	  token[k]='\0' ;
	  
	  if (physic_flag)
	    
	    // it there's correspondence between logical and physical views
	    // inserts the token in the words dictionary as a physical token 
	    number_tokens+=hinsert((char *) token,
				   token_len,
				   WORD,
				   (char *) NULL,
				   ht,
				   0, 
				   0, 
				   ((0x00) | _INCREASE_PHYSICAL_COUNT)) ; 
	  
	  // increases the text counter
	  textcount+=token_len ; 
	  
	  // increases the text pointer 
	  xml_position+=token_len ; 
	  }
  
  // ..
  // ..   defa - FREES THE MEMORY ALLOCATED 
  // ..   

  if (token != NULL)
    
    free(token) ; 
  
  if (entity != NULL)
    
    free(entity) ; 
  
  return ; 
}

void defacod(void *data,
	     const XML_Char *s,
	     int len) 
{ register
    int k=0 ; 
 
 char *entity=NULL ; 
 
 char *token=NULL ;  
 
 int entity_len=0 ; 
 
 int token_len=0 ; 
 
 char separator ; 
 
 int num_seps=0 ; 

 char seps[XCDE_MAX_SEPARATORS_BLOCK]="\0" ; 
 
 int last_position=0 ; 
 
 int buffer_length=0 ; 
 
 int textcount=0 ; 
 
 // ..
 // ..   defa - CHECKS IF THERE'S CORRESPONDENCE BETWEEN LOGICAL 
 // ..   AND PHYSICAL VIEWS
 // ..   
 
 // memorizes the last position in the body file 
 last_position=body_size_without_zlib ; 
 
 // memorizes the last physical correspondence flag
 last_physical_correspondence=physical_correspondence ; 
 
 // checks if there's correspondence between logical and
 // physical views 
 physical_correspondence=phy_corr(&entity,
				  &entity_len,
				  0) ; 
 
 // checks if it's an external general entity 
 // which isn't a separator, and that it'is in an XML text 
 if ((!physical_correspondence) && 
     (expat_number_tag_opened > 0) && 
     (entity_len == len) && 
     (strncmp(s, 
	      entity,
	      len) == 0) && 
     (!hsearch(entity,
	       entity_len,
	       NOTHING, 
	       expat_separators_table))) { // if enters this block it's an external general entity
                                           // which isn't a separator and it's in an XML text 
   
   // there's physical correspondence, because the entity is an external entity that 
   // isn't a separator
   last_physical_correspondence=1u ; 
   
   physical_correspondence=1u ; 
   
   // inserts the external entity in the textbuffer
   insert_buffer(&textbuffer,
		 entity,
		 entity_len) ; 
   
   // increases the text pointer
   xml_position+=len ; 
   
   // frees the memory allocated 
   if (entity != NULL)
     
     free(entity) ; 
   
   return ; 
 }
  
 else
   
   // checks if it's an external general entity which is a separator
   // and there's a token in the textbuffer
   if ((!physical_correspondence) &&
       (expat_number_tag_opened > 0) &&
       (entity_len == len) && 
       (strncmp(s,
		entity,
		entity_len)== 0) && 
       text_in_buffer(&textbuffer)) { // if enters this block it's an external general entity which is a separator
                                      // and there's a token in the textbuffer

     buffer_length=get_buffer_length(&textbuffer) ; 
     
     // allocates the memory needed to contain the token extracted from
     // the textbuffer
     token=(char *) malloc((buffer_length+1)*sizeof(char)) ; 
     
     buffer_length=get_text_in_buffer(&textbuffer,
				      token) ; 
     
     token[buffer_length]='\0' ; 
     
     undercase(token, 
	       buffer_length) ; 

     // checks if the token in the textbuffer has derived from an internal entity expantion 
     if (last_physical_correspondence) 
       
       // the token hasn't derived from an internal entity expansion, so inserts
       // its physical position in the words dictionary 
       hinsert((char *) token,
	       strlen(token),
	       WORD,
	       (char *) NULL,
	       ht, 
	       last_body_position_written,
	       0,
	       ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
     
     else { // if enters this block the token has been derived from an internal
            // entity expansion, so inserts its escape position in the words
            // dictionary 

       hinsert((char *) token,
	       strlen(token), 
	       WORD,
	       (char *) NULL,
	       ht, 
	       last_body_position_written,
	       elementRank, 
	       ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
       
       // increases the element rank 
       ++elementRank ; 
     }
     
     // checks if the entity is new 
     if ((!physical_correspondence) && (changed_position))
       
       // if the entity is new set the rank of the element to 1
       elementRank=1 ; 
     
     // memorizes the physical position 
     last_body_position_written=last_position ; 
     
     // increases the position 
     xml_position+=len ; 
     
     // frees the memory allocated 
     if (token != NULL)
       
       free(token) ;
     
     if (entity != NULL)

       free(entity) ;
     
     return ;
   }
 
   else 
     
     // checks if it's an external entity which isn't a separator and 
     // which is contained in the expansion of an internal entity
     if ((!physical_correspondence) &&
	 (expat_number_tag_opened > 0) &&
	 ((strncmp(s, 
		   entity,
		   len) != 0) || (entity_len != len)) && 
	 (!hsearch((char *) s,
		   len, 
		   NOTHING, 
		   expat_separators_table))) { // if enters this block  it's an external entity which isn't a separator and 
                                               // which is contained in the expansion of an internal entity 
       
       // memorizes the last physical correspondence 
       last_physical_correspondence=physical_correspondence ; 
       
       // put the external entity in the textbuffer
       insert_buffer(&textbuffer,
		     (char *) s,
		     len) ; 
       
       // increases the pointer to the text
       xml_position+=len ; 
       
       // frees the memory allocated
       if (entity != NULL)
	 
	 free(entity) ; 
       
       return ; 
     }
 
     else
       
       // it's an external entity which is a separator and is contained 
       // in the expansion of an internal entity 
       if ((!physical_correspondence) &&
	   (expat_number_tag_opened > 0) &&
	   ((strncmp(s, 
		     entity,
		     len) != 0) || (entity_len != len)) && 
	   (hsearch((char *) s,
		    len, 
		    NOTHING, 
		    expat_separators_table))) { // if enters this block it's an external entity 
	                                        // which is a separator and is contained in the expansion of an
	                                        // internal entity 

	 buffer_length=get_buffer_length(&textbuffer) ; 
	 
	 // allocates the memory needed to contain the token extracted from 
	 // the textbuffer
	 token = (char *) malloc((buffer_length+1)*sizeof(char)) ; 
	 
	 buffer_length=get_text_in_buffer(&textbuffer,
					  token) ; 
	 
	 token[buffer_length]='\0' ;
	 
	 undercase(token,
		   buffer_length) ; 
	 
	 // checks if the token in the textbuffer was derived from an internal 
	 // entity expansion 
	 if (last_physical_correspondence)
	   
	   // the token wasn't derived from an internal entity expansion, so 
	   // inserts its physical position in the words dictionary 
	   hinsert((char *) token,
		   strlen(token), 
		   WORD,
		   (char *) NULL,
		   ht, 
		   last_body_position_written,
		   0,
		   ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
	 
	 else { // if enters this block the token was derived from an internal
	        // entity expansion 
	   
	   // inserts the escape position of the token in the words dictionary 
	   hinsert((char *) token,
		   strlen(token),
		   WORD,
		   (char *) NULL,
		   ht, 
		   last_body_position_written,
		   elementRank, 
		   ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
	   
	   // increases the element rank 
	   ++elementRank ; 
	 }
	 
	
	 // if the entity has changed set to 1 the element rank counter 
	 if ((!physical_correspondence) && (changed_position))
	   
	   elementRank=1u ; 

	 // increases the pointer to the text
	 xml_position+=len ; 
       }
 
       else

	 // it's not an entity, so analyzes the text 
	 { while(textcount < len) {
	   
	   do { num_seps=0 ;
	     
	     while((textcount < len) &&
		   (num_seps < XCDE_MAX_SEPARATORS_BLOCK) && 
		   ((token_len = get_next_token((char *) s+textcount,
						" \t\n", 
						&separator, 
						len-textcount)) == 0)) { // if enters this block the character is a separator
	      
	       // checks if there's a token in the textbuffer
	       if (text_in_buffer(&textbuffer)) { // it enters this block there's a token in the textbuffer

		 buffer_length=get_buffer_length(&textbuffer) ; 
		 
		 // allocates the memory needed to contain the token extracted from
		 // the textbuffer
		 token= (char *) malloc((buffer_length+1)*sizeof(char)) ; 
		 
		 buffer_length=get_text_in_buffer(&textbuffer, 
						  token) ; 
		 
		 token[buffer_length]='\0' ; 
		 
		 undercase(token, 
			   buffer_length) ;
		 
		 // checks if there's correspondence between logical and physical
		 // views
		 if (last_physical_correspondence)
		   
		   // there's correspondence betwen logical and physical views,
		   // so inserts the physical position associated with the token
		   // extracted from the textbuffer in the words dictionary 
		   hinsert((char *) token,
			   buffer_length,
			   WORD,
			   (char *) NULL,
			   ht, 
			   last_body_position_written, 
			   0,
			   ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
		
		 else { // if enters this block there isn't correspondence 
		        // between logical and physical views
		      
		        // inserts the escape position associated with the token
		        // extracted from the textbuffer in the words dictionary 
		        hinsert((char *) token,
			 	buffer_length, 
				WORD,
				(char *) NULL,
				ht,
				last_body_position_written, 
				elementRank,
				((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
		 
			// increases the element rank 
			++elementRank ; 
		 }
		 
		 // checks if the token is new 
		 if ((!physical_correspondence) && (changed_position)) 
		   
		   // if the token is new set to 1 the element rank counter
		   elementRank=1 ; 
		 
		 // memorizes the last body positon written 
		 last_body_position_written=last_position ; 
	       }
		
	       // increases the text counter
	       ++textcount ; 
	       
	       // increases the text pointer
	       ++xml_position ; 
	       
	       // put the separator character in the separators buffer
	       seps[num_seps]=separator ; 
	       
	       // increases the number of separators 
	       ++num_seps ; 
	     }
	     
	     // checks if there's correspondence between logical and 
	     // physical flag and if there're some separators in the 
	     // separators buffer 
	     if ((physical_correspondence) && (num_seps > 0)) { 

	       seps[num_seps]='\0' ; 
	       
	       // writes the separators token codeword in the body file 
	       output_token(seps, 
			    strlen(seps), 
			    WORD) ; 

	       // updates the last body position written 
	       last_body_position_written=body_size_without_zlib ; 
	     }
	     
	   } while ((token_len==0) && (textcount < len)) ; 
	   
	   // it all the text has been analyzes so the loop ends 
	   if (textcount >= len) break ; 
	   
	   // checks if there's a token in the textbuffer
	   if (text_in_buffer(&textbuffer)) { // if enters this block there's a token
	                                      // in the textbuffer

	     buffer_length=get_text_in_buffer(&textbuffer,
					      token) ; 
	     
	     // frees the memory allocated 
	     if (token != NULL)

	       free(token) ;
	       
	     // allocates the memory needed to contain the token extracted from
	     // the textbuffer
	     token = (char *) malloc((buffer_length+1)*sizeof(char)) ; 
	     
	     buffer_length=get_text_in_buffer(&textbuffer,
					      token) ; 
	     
	     token[buffer_length]='\0' ; 
	     
	     undercase(token, 
		       buffer_length) ; 
	     
	     // checks if the token extracted from the textbuffer has been derived
	     // from an internal entity expansion
	     if (last_physical_correspondence)
	       
	       // the token hasn't been derived from an internal entity expansion,
	       // so inserts the physical position associated with the token in
	       // the words dictionary 
	       hinsert((char *) token,
		       buffer_length,
		       WORD,
		       (char *) NULL,
		       ht, 
		       last_body_position_written, 
		       0,
		       ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
	     
	     else 
	       
	       { // if enters this block the token has been derived from 
		 // an internal entity expansion 
	       
	       // inserts the escape position associated with the token in the
	       // words dictionary 
	       hinsert((char *) token,
			 buffer_length,
			 WORD,
			 (char *) NULL,
			 ht,
			 last_body_position_written,
			 elementRank,
			 ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
		 
		 // increases the rank of the element 
		 ++elementRank ; 
	       }
		
	     // if there isn't correspondence between logical and 
	     // physical views and the entity is new put to 1 the 
	     // element rank counter 
	     if ((!physical_correspondence) && (changed_position)) 
	       
	       elementRank=1 ; 
	     
	     // updates the last body position written 
	     last_body_position_written=last_position ; 
	   }
	   
	   // frees the memory allocated 
	   if (token != NULL)
	     
	     free(token) ; 
	   
	   // allocates the memory needed to contain the token 
	   token = (char *) malloc((token_len+1)*sizeof(char)) ; 
	   
	   // copies the token to the memory allocated 
	   for(k=0;k<token_len;++k) 
	     
	     token[k]=s[textcount+k] ; 
	   
	   token[k]='\0' ;
	   
	   if (physical_correspondence) { // it enters this block there's correspondence between 
	                                  // logical and physical views 
	                                  
	     // writes the token codeword to the body file 
	     output_token(token, 
			  token_len, 
			  WORD) ; 
	     
	     // memorizes the last body position written 
	     last_body_position_written=body_size_without_zlib ; 
	   }
	   
	   // increases the text counter
	   textcount += token_len ; 
	   
	   // increases the text pointer 
	   xml_position += token_len ; 
	 }
	 }
 
 // ..
 // ..   defacod - FREES THE MEMORY ALLOCATED 
 // ..   

 if (token != NULL)

   free(token) ; 
 
 if (entity != NULL) 
   
   free(entity) ; 
 
 return ; 
}

void defawrite(void *data,
	       const XML_Char *s,
	       int len) 
{ register
    int k=0 ; 
 
 char *entity=NULL ; 
 
 char *token=NULL ;  
 
 int entity_len=0 ; 
 
 int token_len=0 ; 
 
 char separator ; 
 
 int num_seps=0 ; 

 char seps[XCDE_MAX_SEPARATORS_BLOCK]="\0" ; 
 
 int last_position=0 ; 
 
 int buffer_length=0 ; 
 
 int textcount=0 ; 
 
 // ..
 // ..   defawrite - CHECKS IF THERE'S CORRESPONDENCE BETWEEN LOGICAL 
 // ..   AND PHYSICAL VIEWS
 // ..   

 // memorizes the last position in the body file 
 last_position=body_size_without_zlib ; 
 
 // memorizes the last physical correspondence flag
 last_physical_correspondence=physical_correspondence ; 
 
 // checks if there's correspondence between logical and
 // physical views 
 physical_correspondence=phy_corr(&entity,
				  &entity_len,
				  2) ; 
 
 // checks if it's an external general entity 
 // which isn't a separator, and that whe are in a
 // XML text 
 if ((!physical_correspondence) && 
     (expat_number_tag_opened > 0) && 
     (entity_len == len) && 
     (strncmp(s, 
	      entity,
	      len) == 0) && 
     (!hsearch(entity,
	       entity_len,
	       NOTHING, 
	       expat_separators_table))) { // if enters this block it's an external general entity
                                           // which isn't a separator and it's in an XML text 
   
   // there's physical correspondence, because the entity is an external entity that 
   // isn't a separator
   last_physical_correspondence=1u ; 
   
   physical_correspondence=1u ; 
   
   // inserts the external entity in the textbuffer
   insert_buffer(&textbuffer,
		 entity,
		 entity_len) ; 
   
   // increases the text pointer 
   xml_position+=len ; 
   
   // frees the memory allocated 
   if (entity != NULL)
     
     free(entity) ; 
   
   return ; 
 }
 
 else

   // checks if it's an external general entity which is a separator
   // and there's a token in the textbuffer
   if ((!physical_correspondence) &&
       (expat_number_tag_opened > 0) &&
       (entity_len == len) && 
       (strncmp(s,
		entity,
		entity_len)== 0) && 
       text_in_buffer(&textbuffer)) {  // if enters this block it's an external general entity which is a separator
                                       // and there's a token in the textbuffer

     buffer_length=get_buffer_length(&textbuffer) ; 
     
     // allocates the memory needed to contain the token extracted from
     // the textbuffer
     token=(char *) malloc((buffer_length+1)*sizeof(char)) ; 
     
     buffer_length=get_text_in_buffer(&textbuffer,
				      token) ; 
     
     token[buffer_length]='\0' ; 
     
     undercase(token, 
	       buffer_length) ; 
     
     // checks if the proximity must be computed 
     if (proximity_flag) { // if enters this block the proximity must be computed
       
       // writes the proximity associated to the token extracted from the
       // textbuffer in the IL file 
       hinsert((char *) token,
	       buffer_length,
	       WORD,
	       (char *) NULL,
	       ht, 
	       proximity_counter, 
	       0, 
	       ((0x00) | _WRITE_LOGICAL_OCCURRENCE)) ; 
       
       // increases the proximity counter 
       ++proximity_counter ;      
     }
     
     // checks if there's a correspondence between logical and physical views
     if (last_physical_correspondence) 
       
       // in this case there's a correspondence between logical and physica views
       // so writes the physical position associated with the token extracted from
       // the textbuffer in the IL file 
       hinsert((char *) token,
	       strlen(token),
	       WORD,
	       (char *) NULL,
	       ht, 
	       last_body_position_written,
	       0,
	       ((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ; 
     
     else { // if enters this block there isn't a physical correspondence between
            // logical and physical views
            
       // writes the escape position associated with the token extracted from the
       // textbuffer in the words dictionary 
       hinsert((char *) token,
	       strlen(token), 
	       WORD,
	       (char *) NULL,
	       ht, 
	       last_body_position_written,
	       elementRank, 
	       ((0x00) | _WRITE_PHYSIC_ESCAPE)) ; 
       
       // increases the rank of the element 
       ++elementRank ; 
     }
     
     // checks if the entity is new 
     if ((!physical_correspondence) && (changed_position))
       
       // if the entity is new set the rank of the element to 1
       elementRank=1 ; 
     
     // memorizes the physical position 
     last_body_position_written=last_position ; 

     // increases the text pointer 
     xml_position+=len ; 
     
     // frees the memory allocated 
     if (token != NULL)
       
       free(token) ;
     
     if (entity != NULL)

       free(entity) ;
     
     return ;
   }
 
   else 

     // checks if it's an external entity which isn't a separator and 
     // which is contained in the expansion of an internal entity
     if ((!physical_correspondence) &&
	 (expat_number_tag_opened > 0) &&
	 ((strncmp(s, 
		   entity,
		   len) != 0) || (entity_len != len)) && 
	 (!hsearch((char *) s,
		   len, 
		   NOTHING, 
		   expat_separators_table))) { // if enters this block  it's an external entity which isn't a separator and 
                                               // which is contained in the expansion of an internal entity 
       
       
       // memorizes the last physical correspondence 
       last_physical_correspondence=physical_correspondence ; 
       
       // the entity is put into the buffer
       insert_buffer(&textbuffer,
		     (char *) s,
		     len) ; 
       
       // increases the pointer to the text
       xml_position+=len ; 
       
       // frees the memory allocated
       if (entity != NULL)
	 
	 free(entity) ; 
       
       return ; 
     }
 
     else

       // it's an external entity which is a separator and is contained 
       // in the expansion of an internal entity 
       if ((!physical_correspondence) &&
	   (expat_number_tag_opened > 0) &&
	   ((strncmp(s, 
		     entity,
		     len) != 0) || (entity_len != len)) && 
	   (hsearch((char *) s,
		    len, 
		    NOTHING, 
		    expat_separators_table))) { // if enters this block it's an external entity 
	                                        // which is a separator and is contained in the expansion of an
	                                        // internal entity 

	 buffer_length=get_buffer_length(&textbuffer) ; 
	 
	 // allocates the memory needed to contain the token extracted from 
	 // the textbuffer
	 token  = (char *) malloc((buffer_length+1)*sizeof(char)) ; 
	 
	 buffer_length=get_text_in_buffer(&textbuffer,
					  token) ; 
	 
	 token[buffer_length]='\0' ;
	 
	 undercase(token,
		   buffer_length) ; 
	 
	 // checks if the proximity must be computed
	 if (proximity_flag) { // if enters this block the proximity must be computed
	   
	   // write the proximity associated with the token extracted from the 
	   // textbuffer in the IL file 
	   hinsert((char *) token,
		   buffer_length,
		   WORD,
		   (char *) NULL,
		   ht, 
		   proximity_counter, 
		   0, 
		   ((0x00) | _WRITE_LOGICAL_OCCURRENCE)) ; 
	   
	   // increases the proximity counter
	   ++proximity_counter ;      
	 }
	 
	 // checks if there's a correspondence between logical and physical
	 // views
	 if (last_physical_correspondence)
	   
	   // there's correspondence between logical and physical views, 
	   // so writes the physical position associated with the token
	   // extracted from the textbuffer in the IL file 
	   hinsert((char *) token,
		   strlen(token), 
		   WORD,
		   (char *) NULL,
		   ht, 
		   last_body_position_written,
		   0,
		   ((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ; 
	 
	 else { // if enters this block there isn't correspondence between 
	        // logical and physical views 
	   
	   // writes the escape position associated with the token extracted
	   // from the textbuffer in the IL file 
	   hinsert((char *) token,
		   strlen(token),
		   WORD,
		   (char *) NULL,
		   ht, 
		   last_body_position_written,
		   elementRank, 
		   ((0x00) | _WRITE_PHYSIC_ESCAPE)) ; 
	   
	   // increases the element rank 
	   ++elementRank ; 
	 }

	 // if the entity has changed set to 1 the element rank counter 
	 if ((!physical_correspondence) && (changed_position))
	   
	   elementRank=1u ; 
	 
	 // increases the pointer to the text 
	 xml_position+=len ; 
       }
 
       else
	 
	 // it's not an entity, so analyzes the text 
	 { while(textcount < len) {
	   
	   do { num_seps=0 ;
	     
	   while((textcount < len) &&
		 (num_seps < XCDE_MAX_SEPARATORS_BLOCK) && 
		 ((token_len = get_next_token((char *) s+textcount,
					      " \t\n", 
					      &separator, 
					      len-textcount)) == 0)) { 
	     
	     // checks if there's a token in the textbuffer
	     if (text_in_buffer(&textbuffer)) { // if enters this block there's a token in the textbuffer
	       
	       buffer_length=get_buffer_length(&textbuffer) ; 
		
	       // allocates the memory needed to contain the token extracted from the buffer
	       token = (char *) malloc((buffer_length+1)*sizeof(char)) ; 
	       
	       buffer_length=get_text_in_buffer(&textbuffer, 
						  token) ; 
		 
	       token[buffer_length]='\0' ; 
	       
	       undercase(token, 
			 buffer_length) ;
	       
	       // checks if the proximity must be computed 
	       if (proximity_flag) { // if enters this block the proximity must be
		                     // computed 
		 
		 // writes the proximity associated with the token extracted from 
		 // the textbuffer in the IL file 
		 hinsert((char *) token,
			 buffer_length,
			 WORD,
			 (char *) NULL,
			 ht, 
			 proximity_counter, 
			 0, 
			 ((0x00) | _WRITE_LOGICAL_OCCURRENCE)) ; 
		 
		 // increases the proximity counter
		 ++proximity_counter ;      		
	       }
	     
	       // checks if there's correspondence between logical and physical
	       // views
	       if (last_physical_correspondence)

		 // there's correspondence betwen logical and physical views,
		 // so inserts the physical position associated with the token
		 // extracted from the textbuffer in the words dictionary 
		 hinsert((char *) token,
			 buffer_length,
			 WORD,
			 (char *) NULL,
			 ht, 
			 last_body_position_written, 
			 0,
			 ((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ; 
	       
	       else { // if enters this block there isn't correspondence 
		      // between logical and physical views

		 // writes the escape position associated with the token
		 // extracted from the textbuffer in the IL file 
		 hinsert((char *) token,
			 buffer_length, 
			 WORD,
			 (char *) NULL,
			 ht,
			 last_body_position_written, 
			 elementRank,
			 ((0x00) | _WRITE_PHYSIC_ESCAPE)) ; 
		 
		 // increases the rank of the element 
		 ++elementRank ; 
	       }
	       
	       // checks if the token is new 
	       if ((!physical_correspondence) && (changed_position)) 

		 // if the token is new set to 1 the element rank counter
		 elementRank=1 ; 
	       
	       // memorizes the last body positon written 
	       last_body_position_written=last_position ; 
	     }
		
	     // increases the text counter
	     ++textcount ;
	       
	     // increases the text pointer 
	     ++xml_position ; 
	     
	     // copies the character to the separator buffer
	     seps[num_seps]=separator ; 
	       
	     // increases the number of separator characters in the 
	     // buffer
	     ++num_seps ; 
	     }
	     
	   // checks if there's correspondence between logical and 
	   // physical flag and if there're some separators in the 
	   // separators buffer 
	   if ((physical_correspondence) && (num_seps > 0)) { 
	     
	     seps[num_seps]='\0' ; 
	     
	     // computes the separators token codeword length 
	     nooutput_token(seps, 
			    strlen(seps), 
			    WORD) ; 
	     
	     // updates the last body position written 
	     last_body_position_written=body_size_without_zlib ; 
	   }
	     
	   } while ((token_len==0) && (textcount < len)) ; 
	   
	   // it all the text has been analyzes so the loop ends 
	   if (textcount >= len) break ; 
	     
	   // checks if there's a token in the textbuffer
	   if (text_in_buffer(&textbuffer)) { // if enters this block there's a token
	                                      // in the textbuffer

	     buffer_length=get_text_in_buffer(&textbuffer,
					      token) ; 
	     
	     // free the memory allocated 
	     if (token != NULL) 
	     
	       free(token) ; 
	     
	     // allocates the memory needed to contain the token extracted from 
	     // the textbuffer
	     token = (char *) malloc((buffer_length+1)*sizeof(char)) ; 
	       
	     buffer_length=get_text_in_buffer(&textbuffer,
					      token) ; 
	     
	     token[buffer_length]='\0' ; 
	     
	     undercase(token, 
		       buffer_length) ; 
	     
	     // checks if the proximity must be computed 
	     if (proximity_flag) { // if enters this block the proximity must be
	                           // computed 
	       
	       // writes the proximity associated with the token extracted
	       // from the textbuffer in the IL file 
	       hinsert((char *) token,
		       buffer_length,
		       WORD,
		       (char *) NULL,
		       ht, 
		       proximity_counter, 
		       0, 
		       ((0x00) | _WRITE_LOGICAL_OCCURRENCE)) ; 
	       
	       // increases the proximity counter
	       ++proximity_counter ; 
	     } 

	     // checks if the token extracted from the textbuffer has been derived
	     // from an internal entity expansion
	     if (last_physical_correspondence)
	       
	       // the token hasn't been derived from an internal entity expansion,
	       // so writes the physical position associated with the token in
	       // the IL file 
	       hinsert((char *) token,
		       buffer_length,
		       WORD,
		       (char *) NULL,
		       ht, 
		       last_body_position_written, 
		       0,
		       ((0x00) | _WRITE_PHYSICAL_OCCURRENCE)) ; 
	     
	     else 
	       
	       { // if enters this block the token has been derived from 
		 // an internal entity expansion 

		 // writes the escape position associated with the token in the
		 // IL file 
		 hinsert((char *) token,
			 buffer_length,
			 WORD,
			 (char *) NULL,
			 ht,
			 last_body_position_written,
			 elementRank,
			 ((0x00) | _WRITE_PHYSIC_ESCAPE)) ; 
	       
		 // increases the element rank 
		 ++elementRank ; 
	       }
		
	     // if there isn't correspondence between logical and 
	     // physical views and the entity is new put to 1 the 
	     // element rank counter 
	     if ((!physical_correspondence) && (changed_position)) 
	       
	       elementRank=1 ; 
	     
	     // updates the last body position written 
	     last_body_position_written=last_position ; 
	   }
	   
	   // frees the memory allocated 
	   if (token != NULL)
	     
	     free(token) ; 
	   
	   // allocates the memory needed to contain the token 
	   token = (char *) malloc((token_len+1)*sizeof(char)) ; 
	   
	   // copies the token in the memory allocated 
	   for(k=0;k<token_len;++k) 
	     
	     token[k]=s[textcount+k] ; 
	   
	   token[k]='\0' ;
	   
	   if (physical_correspondence) { // it enters this block there's correspondence between 
	                                  // logical and physical views 

	     // computes the token codeword length 
	     nooutput_token(token, 
			    token_len, 
			    WORD) ; 
	     
	     // memorizes the last body position written 
	     last_body_position_written=body_size_without_zlib ; 
	   }
	   
	   // increases the text counter
	   textcount += token_len ; 
	   
	   // increases the text pointer 
	   xml_position += token_len ; 
	 }
	 }

 // ..
 // ..   defawrite - FREES THE MEMORY ALLOCATED 
 // ..   

 if (token != NULL)

   free(token) ; 

 if (entity != NULL) 

   free(entity) ; 

 return ; 
}

/*******************************************************************
              handler for expanding entity references
 *******************************************************************/

void InternalEntity(void *userData,
		    const XML_Char *entityName,
		    const XML_Char *replacementText,
		    int replacementTextLength)
{ // variables used as counters 
  register 
    int k=0 ; 

  register
    int j=0 ; 

  char *token=NULL ; 

  int token_len=0 ; 

  char *repl=NULL ; 

  int repl_length=0 ; 

  char separator ; 

  char *tag=NULL ; 

  Hashptr search ;

  int len=0 ; 

  int state=0 ; 

  // state in which the parser is 
  /*     0     xml text                                             */
  /*     1     tag opening                                          */
  /*     3     section CDATA                                        */
  /*     4     definition of an attribute with "                    */
  /*     5     definition of an attribute with '                    */

  // allocates the memory space needed by the reference expansions 
  repl = malloc(replacementTextLength*sizeof(char)) ; 

  repl_length=replacementTextLength ; 
  
  // looks at the text for replacing 
  for(j=0; j<replacementTextLength; j++) 

    // it's in a state in which the entity can be expanded
    if ((replacementText[j]=='&') && (state==0)) { 

      // reads the token name
      token_len = get_next_token( (char *) replacementText+j,
				  ";",
				  &separator,
				  replacementTextLength-j) ;
      
      // increases the token length 
      ++token_len ; 

      // allocates the memory needed to contain the expnasion of the entity 
      token = (char *) malloc((token_len+1)*sizeof(char)) ; 
      
      // copies the expansion of the entity in the text
      for(k=0; k<token_len;++k)
	
	token[k]=replacementText[j+k] ;
      
      token[k]='\0' ; 
      
      // reads the value of the entity 
      if ((search=hsearch((char *) token, 
			  strlen(token), 
			  NOTHING, 
			  expat_general_declared_entity)) != NULL) { 

	j+=(token_len-1) ;
	
	// reallocates the memory to contain the expansion 
	repl=realloc(repl,
		     sizeof(char)*(repl_length+strlen(search->ass_el))) ; 
	
	// copies the expansion of the entity in the memory 
	for(k=0; k<strlen(search->ass_el); ++k)
	  
	  repl[len+k]=search->ass_el[k] ; 
	
	// increases the length of the entity 
	len+=strlen(search->ass_el) ;
	
	repl[len+k]='\0' ;
	
	repl_length+=len; 
      }
      
      else { // copies the replacement text and increases the length 

	repl[len]=replacementText[j] ;
	
	++len ; 
      }
    }
  
    else 
      
      { // if's into state 0 and a section CDATA has been opened 
	if ((replacementText[j] == '<') && (state == 0) &&
	    (strncmp((const char *) replacementText+j, 
		     "<![CDATA[", 
		     strlen("<!CDATA[")) == 0))
	  
	  state=3 ;
	
        else
	  
	  // it's into state 0 and a tag has been opened 
	  if((replacementText[j] == '<') && (state== 0) &&
	     (j<replacementTextLength-1))
	    
	    state=1 ; 
	
	  else
	    
	    // it's into a TAG (state=1) and a tag closing has been found
	    if ((replacementText[j] == '>') && (state==1))
	      
	      // closing state 
	      state=0 ; 
	
	    else
	      
	      // it's into a CDATA section and it has been closed 
	      if ((replacementText[j] == ']') && (state==3) 
		  && strncmp(replacementText+j, "]]>", 3))
		
		state=0 ;
	
	      else
		
		// it's into a tag and an attribute definition has been found
		if ((replacementText[j] == '"') && (state == 1))
		  
		  state=4 ;
	
		else
		  
		  // it's into an attribute definition and it's closed
		  if ((replacementText[j] == '"') && (state==4))
		    
		    state=1 ; 
	
		  else
		    
		    // it's into a tag and an attribute definition has been found
		    if ((replacementText[j] == '\'') && (state==1))
		      
		      // state of definition of an attribute 
		      state=5 ;
	
		    else
		      
		      // it's into the definition of an attribute and 
		      // it is closed 
		      if((replacementText[j] == '\'') && (state==5))
			
			// state of attribute closing 
			state=1 ; 
	
	// copies the text into the buffer
	repl[len]=replacementText[j] ;
	
	++len ; 
      }
  
  repl[len+1] = '\0' ; 
  
  // allocates the memory needed to contain the total entity expansion 
  tag = (char *) malloc((strlen(entityName)+3)*sizeof(char)) ; 
  
  // creates the string that contains the total entity expansion 
  sprintf(tag, 
	  "%c%s%c",
	  _SepTagAttr, 
	  entityName, 
	  _PuntoEVirgola) ;
  
  // inserts the entity name associated with its expansion in the
  // hash table that contains all entities
  hinsert((char *) tag, 
	  strlen(tag), 
	  NOTHING,
	  (char *) repl, 
	  expat_general_declared_entity,
	  0,
	  0,
	  ((0x00) | _INSERT_ASSOCIATED_ELEMENT)) ; 
  
  // frees the memory allocated
  if (tag != NULL)
    
    free(tag) ; 
  
  if (repl != NULL)
    
    free(repl) ; 
  
  return ;
}


